; Super Fighter Team

;====================<DEFAULT VALUES>====================

[Remap]
x = x
y = y
z = z
a = a
b = b
c = c
s = s

;====================<DEFAULT VALUES>====================

[Defaults]
command.time = 15
command.buffer.time = 1

;-| Single Button |---------------------------------------------------------

[Command]
name = "a"
command = a
time = 1

[Command]
name = "b"
command = b
time = 1

;-| Hold Button |--------------------------------------------------------------

[Command]
name = "hold_a"
command = /a
time = 1

[Command]
name = "hold_b"
command = /b
time = 1

;-| Hold Dir |--------------------------------------------------------------

[Command]
name = "holdfwd"
command = /$F
time = 1

[Command]
name = "holddown"
command = /$D
time = 1

[Command]
name = "holdback"
command = /$B
time = 1

[Command]
name = "holdup"
command = /$U
time = 1

;-| Single Dir |------------------------------------------------------------

[Command]
name = "fwd"
command = $F
time = 1

[Command]
name = "down"
command = $D
time = 1

[Command]
name = "back"
command = $B
time = 1

[Command]
name = "up"
command = $U
time = 1

;-| Super Motions |--------------------------------------------------------

[Command]
name = "632632P"
command = ~F, DF, D, F, DF, D, a
time = 32

[Command]
name = "632632P"
command = ~F, DF, D, F, DF, D, ~a
time = 32

;-| Special Motions |------------------------------------------------------

[command]
name = "623P"
command = ~F, D, DF, a
time = 16

[command]
name = "623P"
command = ~F, D, DF, ~a
time = 16

[Command]
name = "236P"
command = ~D, DF, F, a
time = 16

[Command]
name = "236P"
command = ~D, DF, F, ~a
time = 16

[command]
name = "421P"
command = ~B, D, DB, a
time = 16

[command]
name = "421P"
command = ~B, D, DB, ~a
time = 16

;-| Other |-----------------------------------------------

[Command]
name = "recovery"
command = a+b
time = 1

[Command]
name = "start"
command = s
time = 1

;=========================================================================
[Statedef -1]
;=========================================================================

[state -1, Status: Change to Dizzy State]
type = changestate
trigger1 = stateno != 5035
trigger1 = fvar(3) >= 40.0 || var(10)
trigger1 = !hitshakeover || gethitvar(hitshaketime)
value = 5035
ignorehitpause = 1

[state -1, Status: Change to Dizzy State]
type = changestate
trigger1 = fvar(3) >= 64.0 || var(10)
trigger1 = ctrl || movetype != H
trigger1 = statetype != A && stateno != 5120
trigger1 = fvar(3) := 0 || var(10) := 0 || 1
value = 5300
ignorehitpause = 1

;=========================================================================
; SUPER MOVES
;=========================================================================

[state -1, Dragon Revenge]
type = changestate
value = 3000
triggerall = !ailevel
triggerall = power >= 124
triggerall = command = "632632P"
triggerall = statetype != A
trigger1 = ctrl || stateno = 40 || stateno = 52 && time > 3

;=========================================================================
; SPECIALS
;=========================================================================

[state -1, Flying Dragon Punch]
type = changestate
value = 1000
triggerall = !ailevel
triggerall = command = "623P"
triggerall = statetype != A
trigger1 = ctrl || stateno = 40 || stateno = 52 && time > 3

[state -1, Aura Punch]
type = changestate
value = 1200
triggerall = !ailevel
triggerall = command = "236P"
triggerall = statetype != A
triggerall = !var(14)
trigger1 = ctrl || stateno = 40 || stateno = 52 && time > 3

[state -1, Twister Punch]
type = changestate
value = 1100
triggerall = !ailevel
triggerall = command = "421P"
triggerall = statetype != A
trigger1 = ctrl || stateno = 40 || stateno = 52 && time > 3

;=========================================================================
; SYSTEM
;=========================================================================

[state -1, Grab]
type = changestate
value = 800
trigger1 = !ailevel
trigger1 = command = "a" && (command = "holdfwd" || command = "holdback")
trigger1 = p2statetype != L && p2statetype != A && p2stateno != 5120 && p2stateno != 5201
trigger1 = statetype != A && p2movetype != A && (p2movetype != H || p2stateno = 5300)
trigger1 = p2bodydist x = [-8, 16]
trigger1 = ctrl

;=========================================================================
; NORMALS
;=========================================================================

[state -1, Standing Punch]
type = changestate
value = 200
triggerall = !ailevel
triggerall = command = "a" && command != "holddown"
triggerall = statetype != A
trigger1 = ctrl

[state -1, Standing Kick]
type = changestate
value = 230
triggerall = !ailevel
triggerall = command = "b" && command != "holddown"
triggerall = statetype != A
trigger1 = ctrl

[state -1, Crouching Punch]
type = changestate
value = 400
triggerall = !ailevel
triggerall = command = "a" && command = "holddown"
triggerall = statetype != A
trigger1 = ctrl

[state -1, Crouchng Kick]
type = changestate
value = 430
triggerall = !ailevel
triggerall = command = "b" && command = "holddown"
triggerall = statetype != A
trigger1 = ctrl

[state -1, Aerial Punch]
type = changestate
value = 600 + 5 *(vel x != 0)
triggerall = !ailevel
triggerall = command = "a"
triggerall = statetype = A
trigger1 = ctrl

[state -1, Aerial Kick]
type = changestate
value = 630 + 5 *(vel x != 0)
triggerall = !ailevel
triggerall = command = "b"
triggerall = statetype = A
trigger1 = ctrl

;===========================================================================
; ARTIFICIAL INTELLIGENCE (ORDERED BY ARBITRARY PREFERENCE)
;===========================================================================

[state -1, AI Jump]
type = changestate
value = 40
triggerall = ailevel && numenemy && roundstate = 2
triggerall = statetype != A && stateno != 40
triggerall = ctrl
; condition
trigger1 = inguarddist && enemynear,hitdefattr = SC,AT
trigger1 = random < 128 * (ailevel ** 2.0 / 64.0) ; probability
trigger1 = var(17) := 1 ; action
; condition
trigger2 = enemy,var(14) = 1 || enemy,var(14) = 2 || enemy,var(14) = 4
trigger2 = enemy,fvar(6) = [64, 128]
trigger2 = random < 128 * (ailevel ** 2.0 / 64.0) ; probability
trigger2 = var(17) := 2 ; action
; condition
trigger3 = backedgedist > frontedgedist && enemy,stateno = 5120 && enemy,anim >= -8
trigger3 = random < 128 * (ailevel ** 2.0 / 64.0) ; probability
trigger3 = var(17) := 3 ; action

[state -1, AI Guard]
type = changestate
value = 120
triggerall = ailevel && numenemy && roundstate = 2 
triggerall = ctrl && inguarddist && stateno != [120, 155]
triggerall = enemynear,hitdefattr != SCA,AT && enemynear,time < 72
; condition
trigger1 = enemy,var(13) && (enemy,pos x - pos x) * facing = [0, enemy,var(13) + 24]
trigger1 = random < cond(statetype = A, 0, cond(statetype != A && p2statetype = A, 496, 896)) * (ailevel ** 2 / 64.0) ; probability
; condition
trigger2 = enemy,var(14) && enemy,fvar(6) = [0, 80]
trigger2 = random < cond(statetype = A, 0, 896) * (ailevel ** 2 / 64.0) ; probability

[state -1, AI Grab]
type = changestate
value = 800
triggerall = ailevel && numenemy && roundstate = 2
triggerall = p2statetype != L && p2statetype != A && p2stateno != 5120 && p2stateno != 5201
triggerall = statetype != A && p2movetype != A  && (p2movetype != H || p2stateno = 5300)
triggerall = (p2bodydist x = [-8, 16]) && (p2dist y = [-72, 8])
; condition
trigger1 = ctrl
trigger1 = random < 128 * (ailevel ** 2.0 / 64.0) ; probability

[state -1, AI Dragon Revenge]
type = changestate
value = 3000
triggerall = ailevel && numenemy && roundstate = 2 && !var(4)
triggerall = p2statetype != L && p2stateno != 5120 && p2stateno != 5201
triggerall = statetype != A
triggerall = power >= 124
; condition
trigger1 = ctrl || stateno = 52 && time > 3
trigger1 = (p2bodydist x = [-8, 64]) && (p2dist y = [-96, 8])
trigger1 = random < (48 + 496 * enemy,movetype = I && enemy,animtime < -8 && enemy,stateno = [1000, 3999]) * (ailevel ** 2.0 / 64.0) ; probability
; condition
trigger2 = ctrl || stateno = 52 && time > 3
trigger2 = (p2bodydist x = [-8, 64]) && (p2dist y = [-96, 8])
trigger2 = p2stateno = 5300 && p2life > 20
trigger2 = random < 544 * (ailevel ** 2.0 / 64.0) ; probability
; condition
trigger3 = ctrl || stateno = 52 && time > 3
trigger3 = (p2bodydist x = [-8, 64]) && (p2dist y = [-96, 8])
trigger3 = p2movetype = A
trigger3 = random < 96 * (ailevel ** 2.0 / 64.0) ; probability

[state -1, AI Twister Punch]
type = changestate
value = 1100
triggerall = ailevel && numenemy && roundstate = 2 && !var(4)
triggerall = p2statetype != L && p2stateno != 5120 && p2stateno != 5201
triggerall = statetype != A
triggerall = cond(enemy,name = "Onimaru", enemy,statetype != C, 1)
; condition
trigger1 = ctrl || stateno = 52 && time > 3
trigger1 = (p2bodydist x = [-8, 104]) && (p2dist y = [-72, 8])
trigger1 = random < 32 * (ailevel ** 2.0 / 64.0) ; probability
; condition
trigger2 = ctrl || stateno = 52 && time > 3
trigger2 = (p2bodydist x = [-8, 104]) && (p2dist y = [-72, 8])
trigger2 = enemy,var(14) && enemy,fvar(6) = [88, 96]
trigger2 = random < 900 * (ailevel ** 2.0 / 64.0) ; probability

[state -1, AI Aura Punch]
type = changestate
value = 1200
triggerall = ailevel && numenemy && roundstate = 2 && !var(4)
triggerall = p2statetype != L && p2stateno != 5201 || p2stateno = 5120 && p2bodydist x > 200
triggerall = statetype != A
triggerall = enemy,name != "Onimaru"
triggerall = cond(enemy,name = "Phoenix", enemy,statetype != C, 1)
triggerall = !var(14) && enemy,var(14) != 8
; condition
trigger1 = ctrl || stateno = 52 && time > 3
trigger1 = p2bodydist x > 48 && (p2dist y = [-96, 8])
trigger1 = random < 48 * (ailevel ** 2.0 / 64.0) ; probability
; condition
trigger2 = ctrl || stateno = 52 && time > 3
trigger2 = p2bodydist x > 96 && (p2dist y = [-96, 8])
trigger2 = enemy,var(14) = 2 && enemy,fvar(6) > 160
trigger2 = random < 48 * (ailevel ** 2.0 / 64.0) ; probability

[state -1, AI Standing Punch]
type = changestate
value = 200
triggerall = ailevel && numenemy && roundstate = 2 && !var(4)
triggerall = p2statetype != L && p2stateno != 5120 && p2stateno != 5201
triggerall = statetype != A
triggerall = cond(enemy,name = "Onimaru", enemy,statetype != C, 1)
; condition
trigger1 = ctrl
trigger1 = (p2bodydist x = [-8, 32]) && (p2dist y = [-72, 8])
trigger1 = random < 48 * (ailevel ** 2.0 / 64.0) ; probability

[state -1, AI Standing Kick]
type = changestate
value = 230
triggerall = ailevel && numenemy && roundstate = 2 && !var(4)
triggerall = p2statetype != L && p2stateno != 5120 && p2stateno != 5201
triggerall = statetype != A
triggerall = cond(enemy,name = "Onimaru", enemy,statetype != C, 1)
; condition
trigger1 = ctrl
trigger1 = (p2bodydist x = [-8, 16 + 28 * (enemy,vel x > 1 && enemy,statetype = A)]) && (p2dist y = [-112, 8])
trigger1 = random < 48 * (ailevel ** 2.0 / 64.0) ; probability

[state -1, AI Crouching Punch]
type = changestate
value = 400
triggerall = ailevel && numenemy && roundstate = 2 && !var(4)
triggerall = p2statetype != L && p2stateno != 5120 && p2stateno != 5201
triggerall = statetype != A
; condition
trigger1 = ctrl
trigger1 = (p2bodydist x = [-8, 40]) && (p2dist y = [-56, 8])
trigger1 = random < 48 * (ailevel ** 2.0 / 64.0) ; probability

[state -1, AI Crouching Kick]
type = changestate
value = 430
triggerall = ailevel && numenemy && roundstate = 2 && !var(4)
triggerall = p2statetype != L && p2statetype != A && p2stateno != 5120 && p2stateno != 5201
triggerall = statetype != A
; condition
trigger1 = ctrl
trigger1 = (p2bodydist x = [-8, 46]) && (p2dist y = [-56, 8])
trigger1 = random < 48 * (ailevel ** 2.0 / 64.0) ; probability

[state -1, AI Flying Dragon Punch]
type = changestate
value = 1000
triggerall = ailevel && numenemy && roundstate = 2 && !var(4)
triggerall = p2statetype != L && p2stateno != 5120 && p2stateno != 5201
triggerall = statetype != A
; condition
trigger1 = ctrl || stateno = 52 && time > 3
trigger1 = (p2bodydist x = [-8, 64]) && (p2dist y = [-160, 8])
trigger1 = random < 32 * (ailevel ** 2.0 / 64.0) ; probability
; condition
trigger2 = ctrl || stateno = 52 && time > 3
trigger2 = (p2bodydist x = [-8, 88]) && (p2dist y = [-160, 8])
trigger2 = enemy,var(12) = 8 && !enemy,var(14) && enemy,vel x > 1
trigger2 = random < 72 * (ailevel ** 2.0 / 64.0) ; probability

[state -1, AI Aerial Punch - Motionless]
type = changestate
value = 600
triggerall = ailevel && numenemy && roundstate = 2
triggerall = p2statetype != L && p2stateno != 5120 && p2stateno != 5201
triggerall = statetype = A && !vel x
; condition
trigger1 = ctrl
trigger1 = (p2bodydist x = [-8, 32]) && (p2dist y = [-88, 40 + 32 * (vel y > 2.0)])
trigger1 = random < 72 * (ailevel ** 2.0 / 64.0) ; probability

[state -1, AI Aerial Punch - Motional]
type = changestate
value = 605
triggerall = ailevel && numenemy && roundstate = 2
triggerall = p2statetype != L && p2stateno != 5120 && p2stateno != 5201
triggerall = statetype = A && vel x
; condition
trigger1 = ctrl
trigger1 = (p2bodydist x = [-8, 32 + 8 * vel x * (vel x > 0)]) && (p2dist y = [-88, 40 + 32 * vel y * (vel y > 0)])
trigger1 = random < 72 * (ailevel ** 2.0 / 64.0) ; probability
; condition
trigger2 = ctrl && ailevel >= 6
trigger2 = vel y > 0 && p2bodydist x > 0 && p2dist y > -72 && abs(p2dist y) = [p2dist x, p2dist x + 72]
trigger2 = p2statetype != A
trigger2 = random < 200 * (ailevel ** 2.0 / 64.0) ; probability

[state -1, AI Aerial Kick - Motionless]
type = changestate
value = 630
triggerall = ailevel && numenemy && roundstate = 2
triggerall = p2statetype != L && p2stateno != 5120 && p2stateno != 5201
triggerall = statetype = A && !vel x
; condition
trigger1 = ctrl
trigger1 = (p2bodydist x = [-8, 36]) && (p2dist y = [-88, 32 + 32 * (vel y > 2.0)])
trigger1 = random < 72 * (ailevel ** 2.0 / 64.0) ; probability

[state -1, AI Aerial Kick - Motional]
type = changestate
value = 635
triggerall = ailevel && numenemy && roundstate = 2
triggerall = p2statetype != L && p2stateno != 5120 && p2stateno != 5201
triggerall = statetype = A && vel x
; condition
trigger1 = ctrl
trigger1 = (p2bodydist x = [-8, 36 + 8 * vel x * (vel x > 0)]) && (p2dist y = [-88, 32 + 32 * vel y * (vel y > 0)])
trigger1 = random < 72 * (ailevel ** 2.0 / 64.0) ; probability
; condition
trigger2 = ctrl && ailevel >= 6
trigger2 = vel y > 0 && p2bodydist x > 0 && p2dist y > -72 && abs(p2dist y) = [p2dist x, p2dist x + 72]
trigger2 = p2statetype != A
trigger2 = random < 200 * (ailevel ** 2.0 / 64.0) ; probability