; Super Fighter Team

;=========================================================================
; Whirlpool Kick
;=========================================================================
[Statedef 3000]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 1

[state 3000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3000, Change Animation]
type = changeanim
trigger1 = !time
value = 3000

[state 3000, Animation Loop]
type = changeanim
trigger1 = time - 67 < 96
trigger1 = !animelemtime(11)
value = anim
elem = 7

[state 3000, Add Power]
type = poweradd
trigger1 = !time
value = -power

[state 3000, Super Config]
type = helper
trigger1 = !animelemtime(1)
name = "Super Config"
id = 6120
stateno = 6120
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 65536
pausemovetime = 65536

[state 3000, Super Pause]
type = superpause
trigger1 = !animelemtime(1)
time = 48
movetime = 48
unhittable = 1
anim = -1
sound = -1
p2defmul = 1
poweradd = 0
darken = 0

[state 3000, Invulnerability]
type = nothitby
trigger1 = animelemtime(1) <= 48
value = SCA
time = 4

[state 3000, Set State Type]
type = statetypeset
trigger1 = animelemtime(2) >= 0
statetype = A
persistent = 0

[state 3000, Solidity]
type = playerpush
trigger1 = animelemtime(2) >= 0
value = 0
ignorehitpause = 1

[state 3000, Voice]
type = playsnd
trigger1 = !animelemtime(1)
; trigger2 = !animelemtime(4) || !animelemtime(8)
value = f0, 0
volumescale = 100
channel = 0

[state 3000, Sound]
type = playsnd
trigger1 = !animelemtime(4) || !animelemtime(8)
value = f100, 0
volumescale = 100
channel = 1

[state 3000, Increment Position]
type = posadd
trigger1 = !animelemtime(2) || !animelemtime(3)
y = -10.0 ; -16.0

[state 3000, Increment Velocity]
type = veladd
trigger1 = animelemtime(11) > 0
y = const(movement.yaccel)

[state 3000, Wind]
type = helper
trigger1 = !numhelper(3010)
trigger1 = animelemtime(3) >= 0 && animelemtime(11) < 0
name = "Wind"
ID = 3010
stateno = 3010
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
size.ground.front = 8
size.ground.back = 8
size.height = 128

[state 3000, Attack Distance]
type = attackdist
trigger1 = !time
value = floor(const(size.attack.dist) * 0.5)

[state 3000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 6 || var(13) := 56

[state 3000, Cornerpush]
type = varset
trigger1 = 1
fvar(2) = 0

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(4) || !animelemtime(8)
trigger1 = time - 67 < 80
ID = 3
attr = A, HA
damage = 4, 1
fall.envshake.phase = 0 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 6, 6
guard.pausetime = 6, 6
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -56
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = cond((p2dist x = [-48, 48]), 6.8359375, 8.7890625), cond(enemy,pos y < -48, 0.0, -5.0)
guard.velocity = cond((p2dist x = [-48, 48]), 13.671875, 17.578125)
air.velocity = cond((p2dist x = [-48, 48]), 6.8359375, 8.7890625), cond(enemy,pos y < -48, 0.0, -2.5)
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 1
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(6) || !animelemtime(10)
trigger1 = time - 67 < 80
ID = 3
attr = A, HA
damage = 4, 1
fall.envshake.phase = 0 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 6, 6
guard.pausetime = 6, 6
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -56
animtype = hard
ground.type = high
air.animtype = back
air.type = low
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = cond((p2dist x = [-48, 48]), -6.8359375, -8.7890625), cond(enemy,pos y < -48, 0.0, -5.0)
guard.velocity = cond((p2dist x = [-48, 48]), -13.671875, -17.578125)
air.velocity = cond((p2dist x = [-48, 48]), -6.8359375, -8.7890625), cond(enemy,pos y < -48, 0.0, -2.5)
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 1
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(8)
trigger1 = time - 67 >= 80
ID = 3
attr = A, HA
damage = 4, 1
fall.envshake.phase = 7 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 6, 6
guard.pausetime = 6, 6
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -56
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -6.8359375, -8.59375
guard.velocity = -7.8125
air.velocity = -6.8359375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 1
air.fall = 1
fall.recover = 0
fall.animtype = hard
p2facing = 1

[state 3000, Idle]
type = statetypeset
trigger1 = animelemtime(11) >= 0
movetype = I
persistent = 0

[state 3000, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 3005
ctrl = 0

;=========================================================================
; Land
;=========================================================================
[Statedef 3005]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 3005, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3005, Change Animation]
type = changeanim
trigger1 = !time
value = 3005

[state 3005, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Wind
;=========================================================================
[Statedef 3010]
type = S
movetype = A
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 4

[state 3010, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3010, Change Animation]
type = changeanim
trigger1 = !time
value = 3010

[state 3010, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 3010, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = -1

[state 3010, Turn]
type = turn
trigger1 = rootdist x < 8

[state 3010, Solidity]
type = playerpush
trigger1 = p2bodydist x = [ -8, 8]
value = cond(p2movetype = H && p2stateno != 5300 || p2statetype = L, 0, 1)

[state 3010, Increment Position]
type = posadd
trigger1 = p2bodydist x != [-8, 8]
x = p2dist x - 32

[state 3010, Set Velocity]
type = velset
trigger1 = 1
x = (256.0 - 128.0 * (p2stateno = [120, 155])) / (rootdist x * 0.5 + 1.0)

[state 3010, Destroy Helper]
type = destroyself
trigger1 = root,stateno != 3000 || root,anim != 3000
trigger2 = root,animelemtime(11) >= 0 || root,movetype != A

;=========================================================================
; Thunder Roar
;=========================================================================
[Statedef 3100]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 1

[state 3100, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3100, Change Animation]
type = changeanim
trigger1 = !time
value = 3100

[state 3100, Add Power]
type = poweradd
trigger1 = !time
value = -power

[state 3100, Super Config]
type = helper
trigger1 = !animelemtime(1)
name = "Super Config"
id = 6120
stateno = 6120
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 65536
pausemovetime = 65536

[state 3100, Super Pause]
type = superpause
trigger1 = !animelemtime(1)
time = 48
movetime = 48
unhittable = 1
anim = -1
sound = -1
p2defmul = 1
poweradd = 0
darken = 0

[state 3100, Invulnerability]
type = nothitby
trigger1 = animelemtime(1) <= 48
value = SCA
time = 4

[state 3100, Voice]
type = null ; playsnd
trigger1 = !animelemtime(1)
value = f0, 0
volumescale = 100
channel = 0

[state 3100, Voice]
type = playsnd
trigger1 = !animelemtime(2)
value = f0, 1
volumescale = 100
channel = 0

[state 3100, Sound]
type = playsnd
trigger1 = !animelemtime(2)
value = f100, 0
volumescale = 100
channel = 1

[state 3100, Thunder]
type = helper
trigger1 = !animelemtime(2)
name = "Thunder"
ID = 4
stateno = 3105
postype = p1
pos = -22, -82
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 3100, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 0 || var(13) := 80

[state 3100, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 3000, Idle]
type = statetypeset
trigger1 = animelemtime(3) >= 17
movetype = I
persistent = 0

[state 3000, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Proj Start
;=========================================================================
[Statedef 3105]
type = S
movetype = A
physics = N
ctrl = 0
velset = vel x, vel y
sprpriority = 4

[state 3105, Juggling and Dampener]
type = null
trigger1 = var(3) := root,var(3) || var(4) := root,var(4) || fvar(1) := root,fvar(1)

[state 3105, Change Animation]
type = changeanim
trigger1 = !time && !prevstateno
value = 3105

[state 3105, Root Bind]
type = bindtoroot
trigger1 = animelemtime(2) < 0
trigger1 = root,stateno = 3100 && root,movetype != H && !root,gethitvar(isbound)
pos = -22, -82

[state 3105, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 3105, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NP,SP,HP
time = -1

[state 3105, Hit Override]
type = hitoverride
trigger1 = 1
attr = SCA,NP,SP,HP
stateno = 3107
slot = 0
time = -1
forceair = 0

[state 3105, Increment Position]
type = posadd
trigger1 = !animelemtime(2) && !prevstateno
x = 80.0
y = 23.0
persistent = 0

[state 3105, Set Velocity]
type = velset
trigger1 = !time
x = 3.515625
y = 0.0

[state 3105, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 3105, Miss]
type = hitdef
trigger1 = 1
attr = S, HP
hitflag = 

[state 3105, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !var(3) && 
trigger1 = cond(numtarget, target,gethitvar(hitcount) % 2 = 0, 1)
ID = 3
attr = S, HP 
damage = 8, 1
fall.envshake.phase = 3 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 0, 10
guard.pausetime = 0, 10
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = -1 ; 195 + 5 * teamside
guard.sparkno = -1 ; 195 + 5 * teamside
sparkxy = 0, 0
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -vel x * 3.0
guard.velocity = -vel x * 3.0
air.velocity = -vel x * 1.5, -4.8828125
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = back
forcestand = 1
p2facing = p2statetype != A

[state 3105, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !var(3) && 
trigger1 = cond(numtarget, target,gethitvar(hitcount) % 2 = 1, 0)
ID = 3
attr = S, HP 
damage = 8, 1
fall.envshake.phase = 3 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 0, 10
guard.pausetime = 0, 10
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = -1 ; 195 + 5 * teamside
guard.sparkno = -1 ; 195 + 5 * teamside
sparkxy = 0, 0
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -vel x * 3.0
guard.velocity = -vel x * 3.0
air.velocity = -vel x * 1.5, -4.8828125
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = back
forcestand = 1
p2facing = p2statetype != A

[state 3105, End State]
type = changestate
trigger1 = movecontact || movereversed
value = stateno + 1
ignorehitpause = 1

[state 3105, Destroy Helper]
type = destroyself
trigger1 = frontedgedist <= -96
trigger2 = animelemtime(2) < 0
trigger2 = root,stateno != 3100 || root,movetype = H || root,gethitvar(isbound)

;=========================================================================
; Proj Contact
;=========================================================================
[Statedef 3106]
type = S
movetype = A
physics = N
ctrl = 0
movehitpersist = 1

[state 3106, Hit Counter]
type = varadd
trigger1 = !time
var(0) = 1

[state 3106, Juggle]
type = parentvaradd
trigger1 = movehit = 1 && numtarget
var(3) = 1

[state 3106, Dampener]
type = parentvaradd
trigger1 = movehit = 1 && numtarget
var(5) = 1

[state 3106, Pause Frame]
type = changeanim
trigger1 = 1
value = anim
elem = 2 + var(0) % 2

[state 3106, Hit Sound]
type = playsnd
trigger1 = movecontact = 1 && numtarget
value = f200, cond(movehit, var(1), var(2))
channel = 2

[state 3106, Hit Spark]
type = explod
trigger1 = movecontact = 1 && numtarget
ID = 195 + 5 * teamside
anim = f195 + 5 * teamside
postype = p1
pos = enemy,const(size.ground.front), 0
bindtime = 1
removetime = -2
removeongethit = 0
ownpal = 1
scale = 1.0, 1.0
sprpriority = 5

[state 3106, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 3106, Priority]
type = sprpriority
trigger1 = 1
value = 4

[state 3106, Freeze Position]
type = posfreeze
trigger1 = time < 3
value = 1

[state 3106, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NP,SP,HP
time = -1

[state 3106, Hit Override]
type = hitoverride
trigger1 = 1
attr = SCA,NP,SP,HP
stateno = 3107
slot = 0
time = -1
forceair = 0

[state 3106, Invulnerability]
type = nothitby
trigger1 = var(0) >= 5
value = SCA
time = -1

[state 3106, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 3106, Miss]
type = hitdef
trigger1 = 1
attr = S, HP
hitflag = 

[state 3106, End State]
type = changestate
trigger1 = time > 10
value = 3105 + 3 * (var(0) >= 5)

;=========================================================================
; Proj Canceled
;=========================================================================
[Statedef 3107]
type = S
movetype = A
physics = N
ctrl = 0
movehitpersist = 1

[state 3107, Hit Counter]
type = varadd
trigger1 = !time
var(0) = 1

[state 3107, Pause Frame]
type = changeanim
trigger1 = 1
value = anim
elem = 2 + var(0) % 2

[state 3107, Hit Sound]
type = playsnd
trigger1 = !time
value = f200, 120
channel = 2

[state 3107, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 3107, Priority]
type = sprpriority
trigger1 = 1
value = 4

[state 3107, Freeze Position]
type = posfreeze
trigger1 = 1
value = 1

[state 3107, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NP,SP,HP
time = -1

[state 3107, Hit Override]
type = hitoverride
trigger1 = 1
attr = SCA,NP,SP,HP
stateno = 3107
slot = 0
time = -1
forceair = 0

[state 3107, Invulnerability]
type = nothitby
trigger1 = var(0) >= 5
value = SCA
time = -1

[state 3107, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 3107, Miss]
type = hitdef
trigger1 = 1
attr = S, HP
hitflag = 

[state 3107, End State]
type = changestate
trigger1 = time > 10
value = 3105 + 3 * (var(0) >= 5)

;=========================================================================
; Proj End
;=========================================================================
[Statedef 3108]
type = S
movetype = I
physics = N
ctrl = 0
velset = vel x * (prevstateno != 3107), vel y * (prevstateno != 3107)
movehitpersist = 1

[state 3108, Change Animation]
type = changeanim
trigger1 = !time && prevstateno = 3107
value = anim + 3

[state 3108, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 3108, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = -1

[state 3108, Attack Distance]
type = attackdist
trigger1 = !time
value = 0

[state 3108, Destroy Helper]
type = destroyself
trigger1 = frontedgedist <= -96
trigger2 = anim = stateno && !animtime