; Super Fighter Team

;=========================================================================
; Chopping Hands
;=========================================================================
[Statedef 1000]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 0

[state 1000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1000, Change Animation]
type = changeanim
trigger1 = !time
value = 1000

[state 1000, Shadow]
type = varset
trigger1 = 1
var(16) = 2 * (animelemtime(1) >= 0) + 2 * (animelemtime(2) >= 0) + 2 * (animelemtime(3) >= 0)

[state 1000, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f0, 0
volumescale = 100
channel = 0

[state 1200, Width]
type = helper
trigger1 = !animelemtime(3)
name = "Width"
ID = 6010
stateno = 6010
postype = p1
pos = 0, 0
ownpal = 1
keyctrl = 0
size.ground.front = 0
size.ground.back = 0

[state 1000, Slash]
type = helper
trigger1 = !animelemtime(1)
name = "Slash"
ID = 2
stateno = 1005
postype = p1
pos = 0, 0
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 1000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 0 || var(13) := 80

[state 1000, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 1000, Idle]
type = statetypeset
trigger1 = animelemtime(3) >= 17
movetype = I
persistent = 0

[state 1000, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Proj Start
;=========================================================================
[Statedef 1005]
type = S
movetype = A
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 4

[state 1005, Juggling and Dampener]
type = null
trigger1 = var(3) := root,var(3) || var(4) := root,var(4) || fvar(1) := root,fvar(1)

[state 1005, Change Animation]
type = changeanim
trigger1 = !time
value = 1005

[state 1005, Root Bind]
type = bindtoroot
trigger1 = animelemtime(3) < 0
trigger1 = root,stateno = 1000 && root,movetype != H && !root,gethitvar(isbound)
pos = 0, 0

[state 1005, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 1005, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NP,SP,HP
time = -1

[state 1005, Hit Override]
type = hitoverride
trigger1 = 1
attr = SCA,NP,SP,HP
stateno = 1007
slot = 0
time = -1
forceair = 0

[state 1005, Increment Position]
type = posadd
trigger1 = !animelemtime(3)
x = 56.0
y = -56.0
persistent = 0

[state 1005, Set Velocity]
type = velset
trigger1 = !time
x = 3.515625
y = 0.0

[state 1005, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 1005, Miss]
type = hitdef
trigger1 = 1
attr = S, SP
hitflag = 

[state 1005, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
ID = 2
attr = S, SP 
damage = 17, 2
fall.envshake.phase = 18 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 0, 6
guard.pausetime = 1, 1
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = -1 ; 195 + 5 * teamside
guard.sparkno = -1 ; 195 + 5 * teamside
sparkxy = 0, 0
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -6.8359375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = back
; forcestand = 1
p2facing = p2statetype != A

[state 1005, End State]
type = changestate
trigger1 = movecontact || movereversed
value = stateno + 1
ignorehitpause = 1

[state 1005, Destroy Helper]
type = destroyself
trigger1 = frontedgedist <= -96
trigger2 = animelemtime(3) < 0
trigger2 = root,stateno != 1000 || root,movetype = H || root,gethitvar(isbound)

;=========================================================================
; Proj Contact
;=========================================================================
[Statedef 1006]
type = S
movetype = A
physics = N
ctrl = 0
movehitpersist = 1

[state 1006, Juggle]
type = parentvaradd
trigger1 = movehit = 1 && numtarget
var(3) = 1

[state 1006, Dampener]
type = parentvaradd
trigger1 = movehit = 1 && numtarget
var(5) = 1

[state 1006, Pause Frame]
type = changeanim
trigger1 = 1
value = anim
elem = animelemno(0)

[state 1006, Hit Sound]
type = playsnd
trigger1 = movecontact = 1 && numtarget
value = f200, cond(movehit, var(1), var(2))
channel = 2

[state 1006, Hit Spark]
type = explod
trigger1 = movecontact = 1 && numtarget
ID = 195 + 5 * teamside
anim = f195 + 5 * teamside
postype = p1
pos = enemy,const(size.ground.front), 0
bindtime = 1
removetime = -2
removeongethit = 0
ownpal = 1
scale = 1.0, 1.0
sprpriority = 5

[state 1006, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 1006, Priority]
type = sprpriority
trigger1 = 1
value = 4

[state 1006, Freeze Position]
type = posfreeze
trigger1 = 1
value = 1

[state 1006, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NP,SP,HP
time = -1

[state 1006, Hit Override]
type = hitoverride
trigger1 = 1
attr = SCA,NP,SP,HP
stateno = 1007
slot = 0
time = -1
forceair = 0

[state 1006, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = -1

[state 1006, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 1006, Miss]
type = hitdef
trigger1 = 1
attr = S, SP
hitflag = 

[state 1006, End State]
type = changestate
trigger1 = time > 6
value = 1008

;=========================================================================
; Proj Canceled
;=========================================================================
[Statedef 1007]
type = S
movetype = A
physics = N
ctrl = 0
movehitpersist = 1

[state 1007, Pause Frame]
type = changeanim
trigger1 = 1
value = anim
elem = animelemno(0)

[state 1007, Hit Sound]
type = null ; playsnd
trigger1 = !time
value = f200, 120
channel = 2

[state 1007, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 1007, Priority]
type = sprpriority
trigger1 = 1
value = 4

[state 1007, Freeze Position]
type = posfreeze
trigger1 = 1
value = 1

[state 1007, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NP,SP,HP
time = -1

[state 1007, Hit Override]
type = hitoverride
trigger1 = 1
attr = SCA,NP,SP,HP
stateno = 1007
slot = 0
time = -1
forceair = 0

[state 1007, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = -1

[state 1007, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 1007, Miss]
type = hitdef
trigger1 = 1
attr = S, SP
hitflag = 

[state 1007, End State]
type = changestate
trigger1 = time > 6
value = 1008

;=========================================================================
; Proj End
;=========================================================================
[Statedef 1008]
type = S
movetype = I
physics = N
ctrl = 0
velset = 0, 0
movehitpersist = 1

[state 1008, Change Animation]
type = changeanim
trigger1 = !time
value = anim + 3

[state 1008, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 1008, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = -1

[state 1008, Destroy Helper]
type = destroyself
trigger1 = !animtime

;=========================================================================
; Double Kick
;=========================================================================
[Statedef 1100]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1100, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1100, Change Animation]
type = changeanim
trigger1 = !time
value = 1100

[state 1100, Set State Type]
type = statetypeset
trigger1 = animelemtime(3) >= 0
statetype = A
persistent = 0

[state 1100, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f0, 0
volumescale = 100
channel = 0

[state 1300, Sound]
type = playsnd
trigger1 = !animelemtime(3) || !animelemtime(6)
value = f100, 0
volumescale = 100

[state 1100, Increment Position]
type = posadd
trigger1 = !animelemtime(3)
x = 20.0

[state 1100, Increment Position]
type = posadd
trigger1 = !animelemtime(6)
x = 8.0

[state 1100, Set Velocity]
type = velset
trigger1 = !animelemtime(3)
x = 3.90625
y = -2.9296875

[state 1100, Increment Velocity]
type = veladd
trigger1 = animelemtime(3) > 0
y = const(movement.yaccel) * 0.3
 
[state 1100, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 6 + (animelemtime(6) >= 0) || var(13) := 40 + 24 * (animelemtime(6) >= 0)

[state 1100, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(4)
ID = 2
attr = A, SA
damage = 10, 1
fall.envshake.phase = 10 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -56
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 25
ground.hittime = 25
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1100, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(7)
ID = 2
attr = A, SA
damage = 10, 1
fall.envshake.phase = 10 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1100, Idle]
type = statetypeset
trigger1 = animelemtime(7) >= 11
movetype = I
persistent = 0

[state 1100, End State]
type = changestate
trigger1 = pos y + vel y > 24 * !movecontact
value = 1105
ctrl = 0

;=========================================================================
; Land
;=========================================================================
[Statedef 1105]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 1105, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1105, Change Animation]
type = changeanim
trigger1 = !time
value = 1105

[state 1105, Control]
type = null ; ctrlset
trigger1 = time >= 0
value = 1
persistent = 0

[state 1105, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Buddha Kick
;=========================================================================
[Statedef 1200]
type = A
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1200, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1200, Change Animation]
type = changeanim
trigger1 = !time
value = 1200

[state 1200, Change Animation]
type = changeanim
trigger1 = movecontact = 1
value = 1200
elem = 4

[state 1200, Shadow]
type = varset
trigger1 = 1
var(16) = 8 * (animelemtime(1) >= 0) + 8 * (animelemtime(2) >= 0) - 8 * (animelemtime(4) >= 0) - 8 * (animelemtime(5) >= 0)

[state 1200, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f1, 0
volumescale = 100
channel = 0

[state 1200, Sound]
type = playsnd
trigger1 = !animelemtime(3)
value = f100, 0
volumescale = 100

[state 1200, Increment Position]
type = posadd
trigger1 = !time
y = -8.0

[state 1200, Increment Position]
type = posadd
trigger1 = animelemtime(2) >= 0 && animelemtime(2) <= 8
x = 8.0 - 1.0 * animelemtime(2)

[state 1200, Set Velocity]
type = velset
trigger1 = !animelemtime(4)
x = -1.953125
y = -3.90625

[state 1200, Increment Velocity]
type = veladd
trigger1 = animelemtime(4) > 0
y = const(movement.yaccel) * 0.75

[state 1200, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 2 || var(13) := 72

[state 1200, Cornerpush]
type = varset
trigger1 = movecontact = 1
fvar(2) = 0.0

[state 1200, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(3)
ID = 2
attr = A, SA
damage = 18, 2
fall.envshake.phase = 18 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1200, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(3) && (enemy,name = "Onimaru" || enemy,name = "Widow")
ID = 2
attr = A, SA
damage = 18, 2
fall.envshake.phase = 13 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1200, Idle]
type = statetypeset
trigger1 = animelemtime(4) >= 0
movetype = I
persistent = 0

[state 1200, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 1205
ctrl = 0

;=========================================================================
; Land
;=========================================================================
[Statedef 1205]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 1205, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1205, Change Animation]
type = changeanim
trigger1 = !time
value = 1205

[state 1205, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Tornado
;=========================================================================
[Statedef 1300]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1300, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1300, Change Animation]
type = changeanim
trigger1 = !time
value = 1300

[state 1300, Turn]
type = turn
trigger1 = p2dist x <= 0 && !animtime

[state 1300, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f6, 0
volumescale = 100
channel = 0

[state 1300, Sound]
type = playsnd
trigger1 = movetype = A
trigger1 = (animelemno(0) + 22) % 3 = 0
trigger1 = !animelemtime(animelemno(0))
value = f100, 0
volumescale = 100

[state 1300, Set Velocity]
type = velset
trigger1 = !animelemtime(2)
x = 5.859375

[state 1300, Increment Velocity]
type = veladd
trigger1 = animelemtime(2) > 0
x = -0.06813226744186046511627906976744

[state 1300, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 2 || var(13) := 40

[state 1300, Cornerpush]
type = varset
trigger1 = numtarget && movecontact = 1
fvar(2) = target,gethitvar(xvel) * 1.5

[state 1300, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy && movetype = A
trigger1 = (animelemno(0) + 22) % 3 = 1 && !animelemtime(animelemno(0))
ID = 2
attr = A, SA
damage = 10, 1
fall.envshake.phase = 5 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1300, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy && movetype = A
trigger1 = (animelemno(0) + 22) % 3 = 1 && !animelemtime(animelemno(0)) && enemy,name = "Onimaru"
ID = 2
attr = A, SA
damage = 10, 1
fall.envshake.phase = 5 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1300, Idle]
type = statetypeset
trigger1 = animelemtime(16) >= 0
movetype = I
persistent = 0

[state 1300, End State]
type = changestate
trigger1 = !animtime
value = 1205
ctrl = 0