; Super Fighter Team

;=========================================================================
; Rocket Rocket
;=========================================================================
[Statedef 3000]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 1

[state 3000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3000, Change Animation]
type = changeanim
trigger1 = !time
value = 3000

[state 3000, Add Power]
type = poweradd
trigger1 = !time
value = -power

[state 3000, Super Config]
type = helper
trigger1 = !animelemtime(1)
name = "Super Config"
id = 6120
stateno = 6120
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 65536
pausemovetime = 65536

[state 3000, Super Pause]
type = superpause
trigger1 = !animelemtime(1)
time = 48
movetime = 48
unhittable = 1
anim = -1
sound = -1
p2defmul = 1
poweradd = 0
darken = 0

[state 3000, Invulnerability]
type = nothitby
trigger1 = animelemtime(1) <= 48
value = SCA
time = 24

[state 3000, Set State Type]
type = statetypeset
trigger1 = animelemtime(5) >= 0
statetype = A
physics = N
persistent = 0

[state 3000, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f5, 0
volumescale = 100
channel = 0

[state 3000, Sound]
type = playsnd
trigger1 = !animelemtime(4)
value = f100, 0
volumescale = 100

[state 3000, Solidity]
type = playerpush
trigger1 = animelemtime(5) >= 0
value = 0

[state 3000, Set Velocity]
type = velset
trigger1 = !animelemtime(5)
x = 16.0
y = -7.03125 ; -3.515625

[state 3010, Increment Velocity]
type = veladd
trigger1 = animelemtime(5) = [0, 16)
x = -1.0

[state 3000, Increment Velocity]
type = veladd
trigger1 = animelemtime(5) > 0
y = const(movement.yaccel) * 1.0

[state 3000, Width]
type = null ; helper
trigger1 = !animelemtime(5)
name = "Width"
ID = 6010
stateno = 6010
postype = p1
pos = 0, 0
ownpal = 1
keyctrl = 0
size.ground.front = 0
size.ground.back = 0

[state 3000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 2 || var(13) := 64

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(5)
ID = 3
attr = A, HA
damage = 8, 0
fall.envshake.phase = 3 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 8, 8
guard.pausetime = 8, 8
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -64
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 120
ground.hittime = 120
guard.slidetime = 32
guard.hittime = 32
air.hittime = 120
ground.velocity = 0.0
guard.velocity = 0.0
air.velocity = 0.0, 0.0
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = hard
forcestand = 1
forcenofall = 1
p1stateno = 3010
kill = 0

[state 3000, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 3005
ctrl = 0

;=========================================================================
; Land
;=========================================================================
[Statedef 3005]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 3005, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3005, Change Animation]
type = changeanim
trigger1 = !time
value = 3005

[state 3005, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Rocket Rocket
;=========================================================================
[Statedef 3010]
type = A
movetype = A
physics = N
ctrl = 0
sprpriority = 1

[state 3010, Change Animation]
type = changeanim
trigger1 = !time
value = 3010

[state 3010, Solidity]
type = playerpush
trigger1 = 1
value = 0

[state 3010, Target State]
type = targetstate
trigger1 = !time
value = 3020

[state 3010, Target Facing]
type = targetfacing
trigger1 = !time
value = -1

[state 3015, Target State]
type = targetstate
trigger1 = pos y + vel y > 0
value = 3021
persistent = 0

[state 3010, Set Velocity]
type = velset
trigger1 = !time
x = fvar(21) := (abs(p2dist x) + 16) / 8.0

[state 3010, Increment Velocity]
type = veladd
trigger1 = time = [8, 24)
trigger1 = fvar(22) := fvar(21) / 16.0
x = -fvar(22)

[state 3010, Increment Velocity]
type = veladd
trigger1 = 1
y = const(movement.yaccel) * 1.0

[state 3010, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 3005
ctrl = 0

;=========================================================================
; Target Shocked
;=========================================================================
[Statedef 3020]
type = S
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 3020, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3020, Change Animation]
type = changeanim
trigger1 = !time
value = cond(random < 500, 5000, 5010)

[state 3020, Change Animation]
type = changeanim
trigger1 = anim = 5000 || anim = 5010
trigger1 = !animtime
value = anim + 5

[state 3020, Bound]
type = screenbound
trigger1 = 1
value = 1
movecamera = 1, 1

[state 3020, Width]
type = null ; width
trigger1 = !time && backedgedist <= 32
edge = 0, 96

[state 3020, Own State]
type = selfstate
trigger1 = !gethitvar(isbound)
trigger1 = time > 200
value = 5050

;=========================================================================
; Target Destroy
;=========================================================================
[Statedef 3021]
type = S
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 3021, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3021, Change Animation]
type = changeanim
trigger1 = time < 32
trigger1 = time % 8 = 0
value = cond(time = 8 || time = 24, 5000, 5010)

[state 3021, Change Animation]
type = changeanim
trigger1 = anim = 5000 || anim = 5010
trigger1 = !animtime
value = anim + 5

[state 3021, Bound]
type = screenbound
trigger1 = 1
value = 1
movecamera = 1, 1

[state 3021, Background Effect]
type = bgpalfx
trigger1 = time < 32
trigger1 = time % 8 = 0
time = 2
color = 256
invertall = 1

[state 3021, Hit Sound]
type = playsnd
trigger1 = time < 32
trigger1 = time % 8 = 0
value = f200, 10
volumescale = 100
channel = 2

[state 3021, Shake]
type = envshake
trigger1 = time < 32
trigger1 = time % 8 = 0
time = 8
ampl = 4

[state 3021, Hit Spark]
type = explod
trigger1 = time < 32
trigger1 = time % 8 = 0
ID = 210 - 5 * teamside
anim = f210 - 5 * teamside
postype = p1
pos = 0, const(size.mid.pos.y)
random = 32, 32
bindtime = 1
removetime = -2
removeongethit = 0
ownpal = 1
scale = 1.0, 1.0
sprpriority = 5

[state 3021, Add Life]
type = lifeadd
trigger1 = time < 32
trigger1 = time % 8 = 0
value = -10
kill = time >= 24

[state 3021, Add Power]
type = poweradd
trigger1 = time < 32
trigger1 = time % 8 = 0
value = 4

[state 3021, End State]
type = changestate
trigger1 = time >= 32
value = 3022 + !alive
ctrl = 0

[state 3021, Own State]
type = selfstate
trigger1 = !gethitvar(isbound)
trigger1 = time > 200
value = 5050

;=========================================================================
; Target Destroyed
;=========================================================================
[Statedef 3022]
type = A
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 3022, Set Hit Fall]
type = hitfallset
trigger1 = !time
value = 1

[state 3022, Change Animation]
type = changeanim
trigger1 = !time
value = 5050

[state 3022, Change Animation]
type = changeanim
trigger1 = vel y > 0
value = 5060
persistent = 0

[state 3022, Set Velocity]
type = velset
trigger1 = !time
; x = -2.34375
y = -9.375

[state 3022, Increment Velocity]
type = veladd
trigger1 = 1
y = 0.5859375

[state 3022, Own State]
type = selfstate
trigger1 = pos y >= const(movement.air.gethit.groundrecover.ground.threshold)
trigger1 = vel y > 0
value = 5100
ctrl = 0

;=========================================================================
; Target Killed
;=========================================================================
[Statedef 3023]
type = S
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 3023, Set Hit Fall]
type = hitfallset
trigger1 = !time
value = 0

[state 3023, Change Animation]
type = changeanim
trigger1 = !time
value = 5300

[state 3023, Change Animation]
type = changeanim
trigger1 = anim = 5300 && animelemtime(1) = 14
value = 5070

[state 3023, Increment Velocity]
type = veladd
trigger1 = anim = 5070
y = 0.5859375 * 0.5

[state 3022, Own State]
type = selfstate
trigger1 = pos y + vel y > 16
value = 5110
ctrl = 0