; Super Fighter Team

;=========================================================================
; Scorpion Tail
;=========================================================================
[Statedef 1000]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1000, Change Animation]
type = changeanim
trigger1 = !time
value = 1000

[state 1000, Shadow]
type = varset
trigger1 = 1
var(16) = 16 * (animelemtime(1) >= 0) + 16 * (animelemtime(2) >= 0) - 16 * (animelemtime(4) >= 0)

[state 1000, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f3, 0
volumescale = 100
channel = 0

[state 1000, Sound]
type = playsnd
trigger1 = !animelemtime(2)
value = f100, 0
volumescale = 100
channel = 1

[state 1000, Width]
type = helper
trigger1 = !animelemtime(2)
name = "Width"
ID = 6010
stateno = 6010
postype = p1
pos = 0, 0
ownpal = 1
keyctrl = 0
size.ground.front = 0
size.ground.back = 0

[state 1000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 3 || var(13) := 104

[state 1000, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(3)
ID = 2
attr = S, SA
damage = 15, 1
fall.envshake.phase = 14 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -88
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1000, Idle]
type = statetypeset
trigger1 = animelemtime(4) >= 0
movetype = I
persistent = 0

[state 1000, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Spiral Blade
;=========================================================================
[Statedef 1100]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1100, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1100, Change Animation]
type = changeanim
trigger1 = !time
value = 1100

[state 1100, Set State Type]
type = statetypeset
trigger1 = animelemtime(3) >= 0
statetype = A
persistent = 0

[state 1100, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f3, 0
volumescale = 100
channel = 0

[state 1100, Increment Position]
type = posadd
trigger1 = !animelemtime(1)
x = -16.0

[state 1100, Increment Position]
type = posadd
trigger1 = !animelemtime(2)
x = -4.0

[state 1100, Increment Position]
type = posadd
trigger1 = !animelemtime(3)
x = 24.0
y = -8.0

[state 1100, Set Velocity]
type = velset
trigger1 = !animelemtime(3)
x = 3.125
y = -4.6875

[state 1100, Increment Velocity]
type = veladd
trigger1 = animelemtime(3) > 0 && animelemtime(6) < 0
x = -0.13020833333333333333333333333333

[state 1100, Increment Velocity]
type = veladd
trigger1 = animelemtime(3) > 0
y = const(movement.yaccel)

[state 1100, Energy]
type = null ; helper
trigger1 = !animelemtime(3)
name = "Energy"
ID = 1110
stateno = 7000
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 1100, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 6 || var(13) := 104

[state 1100, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(4)
ID = 2
attr = A, SA
damage = 25, 2
fall.envshake.phase = 24 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -72
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -2.34375, -6.8359375
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 1
air.fall = 1
fall.recover = 0
fall.animtype = back

[state 1100, Idle]
type = statetypeset
trigger1 = animelemtime(5) >= 0
movetype = I
persistent = 0

[state 1100, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 1105
ctrl = 0

;=========================================================================
; Land
;=========================================================================
[Statedef 1105]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 1105, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1105, Change Animation]
type = changeanim
trigger1 = !time
value = 1105

[state 1105, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Somersault Attack
;=========================================================================
[Statedef 1200]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1200, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1200, Change Animation]
type = changeanim
trigger1 = !time
value = 1200

[state 1200, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f3, 0
volumescale = 100
channel = 0

[state 1200, Sound]
type = playsnd
trigger1 = !animelemtime(2)
value = f100, 0
volumescale = 100
channel = 1

[state 1200, Increment Position]
type = posadd
trigger1 = animelemtime(4) > 0 && animelemtime(6) < 0
x = 4.0 - animelemtime(4) * 0.5

[state 1200, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 7 - (animelemtime(4) >= 0) || var(13) := 48

[state 1200, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(3) || !animelemtime(4)
ID = 2
attr = S, SA
damage = 10, 1
fall.envshake.phase = 10 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48 - random % 16
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1200, Idle]
type = statetypeset
trigger1 = animelemtime(6) >= 0
movetype = I
persistent = 0

[state 1200, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Phoenix Fire
;=========================================================================
[Statedef 1300]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1300, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1300, Change Animation]
type = changeanim
trigger1 = !time
value = 1300

[state 1300, Shadow]
type = varset
trigger1 = 1
var(16) = 8 * (animelemtime(1) >= 0) + 8 * (animelemtime(3) >= 0) - 8 * (animelemtime(11) >= 0)

[state 1300, Width]
type = width
trigger1 = animelemtime(3) >= 0 && animelemtime(10) < 0
edge = 64 - const(size.ground.front),0

[state 1300, Invulnerability]
type = nothitby
trigger1 = animelemtime(11) < 0
value = ,AT
time = 1

[state 1300, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f3, 1
volumescale = 100
channel = 0

[state 1300, Increment Position]
type = posadd
trigger1 = !animelemtime(2)
x = 24.0

[state 1300, Increment Position]
type = velset
trigger1 = !animelemtime(3)
x = 6.25

[state 1300, Increment Position]
type = velset
trigger1 = !animelemtime(11)
x = 0.0

[state 1300, Energy]
type = helper
trigger1 = !animelemtime(1)
name = "Energy"
ID = 1305
stateno = 7000
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 1300, Energy]
type = helper
trigger1 = !animelemtime(11)
name = "Energy"
ID = 1306
stateno = 7000
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 1300, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 4 || var(13) := 80

[state 1300, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(animelemno(0)) && animelemno(0) % 2 = 0 && animelemno(0) = [3, 10]
ID = 10 ; phoenix fire
attr = S, SA
damage = 30, 1
fall.envshake.phase = 30 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48 - random % 16
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 5
guard.hittime = 5
air.hittime = 15
ground.velocity = -2.34375, -4.296875
guard.velocity = -3.90625
air.velocity = -2.34375, -4.296875
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 1
air.fall = 1
fall.recover = 0
fall.animtype = back

[state 1300, Idle]
type = statetypeset
trigger1 = animelemtime(11) >= 0
movetype = I
persistent = 0

[state 1300, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Back Flip
;=========================================================================
[Statedef 1400]
type = A
movetype = I
physics = N
ctrl = 0
sprpriority = 1

[state 1400, Change Animation]
type = changeanim
trigger1 = !time
value = 1400

[state 1400, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA

[state 1400, Set Velocity]
type = velset
trigger1 = !time
x = const(velocity.jump.back.x)
y = const(velocity.jump.y) * 0.75

[state 1400, Increment Velocity]
type = veladd
trigger1 = 1
y = 0.7109375 ; const(movement.yaccel)

[state 1400, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 1405

;=========================================================================
; Hand Land
;=========================================================================
[Statedef 1405]
type = S
movetype = I
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 1

[state 1405, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1405, Change Animation]
type = changeanim
trigger1 = !time
value = 1405

[state 1405, Set State Type]
type = statetypeset
trigger1 = animelemtime(2) >= 0
statetype = A
persistent = 0

[state 1405, Invulnerability]
type = nothitby
trigger1 = 1 ; animelemtime(2) < 0
value = SCA

[state 1405, Increment Velocity]
type = velset
trigger1 = !animelemtime(2)
x = const(velocity.jump.back.x) * 0.5
y = const(velocity.jump.y) * 0.5

[state 1405, Increment Velocity]
type = veladd
trigger1 = animelemtime(2) > 0
y = 0.7109375 ; const(movement.yaccel)

[state 1405, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 1410

;=========================================================================
; Land
;=========================================================================
[Statedef 1410]
type = S
movetype = I
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 1410, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1410, Change Animation]
type = changeanim
trigger1 = !time
value = 1410

[state 1410, Special Effect]
type = assertspecial
trigger1 = 1
flag = nowalk

[state 1410, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1