; Super Fighter Team

;=========================================================================
; Tyrant's Raid
;=========================================================================
[Statedef 3000]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 1

[state 3000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3000, Change Animation]
type = changeanim
trigger1 = !time
value = 3000

[state 3000, Add Power]
type = poweradd
trigger1 = !time
value = -power

[state 3000, Super Config]
type = helper
trigger1 = !animelemtime(1)
name = "Super Config"
id = 6120
stateno = 6120
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 65536
pausemovetime = 65536

[state 3000, Super Pause]
type = superpause
trigger1 = !animelemtime(1)
time = 48
movetime = 48
unhittable = 1
anim = -1
sound = -1
p2defmul = 1
poweradd = 0
darken = 0

[state 3000, Invulnerability]
type = nothitby
trigger1 = animelemtime(1) <= 48
value = SCA
time = 8

[state 3000, Voice]
type = playsnd
trigger1 = !animelemtime(2)
value = f9, 0
volumescale = 100
channel = 0

[state 3000, Sound]
type = playsnd
trigger1 = !animelemtime(2)
value = f100, 0
volumescale = 100
channel = 1

[state 3000, Set Velocity]
type = velset
trigger1 = !animelemtime(2)
x = 9.9609375

[state 3000, Set Velocity]
type = velset
trigger1 = !animelemtime(14)
x = 0.0

[state 3000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 4 || var(13) := 32

[state 3000, Cornerpush]
type = varset
trigger1 = 1
fvar(2) = 0

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(2)
ID = 3
attr = S, HA
damage = 20, 5
fall.envshake.phase = 64 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -64
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -3.125, -3.515625
guard.velocity = -3.90625
air.velocity = -3.125, -3.515625
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 1
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1
kill = 0

[state 3000, Attack Continuation]
type = changestate
trigger1 = movecontact
value = 3005
ctrl = 0

[state 3000, Idle]
type = statetypeset
trigger1 = animelemtime(14) >= 0
movetype = I
persistent = 0

[state 3000, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Flip Backward
;=========================================================================
[Statedef 3005]
type = A
movetype = A
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 3005, Change Animation]
type = changeanim
trigger1 = !time
value = 3005

[state 3005, Set Velocity]
type = velset
trigger1 = !time
x = const(velocity.jump.y) * 0.5
y = const(velocity.jump.y)

[state 3005, Increment Velocity]
type = veladd
trigger1 = time > 0
y = const(movement.yaccel)

[state 3005, Attack Distance]
type = attackdist
trigger1 = !time
value = 0

[state 3005, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 3010

;=========================================================================
; Land & Taunt
;=========================================================================
[Statedef 3010]
type = S
movetype = A
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 3010, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3010, Change Animation]
type = changeanim
trigger1 = !time
value = 3010

[state 3010, End State]
type = changestate
triggerall = !animelemtime(3)
trigger1 = !numtarget
trigger2 = cond(numtarget, !target,alive, 0)
value = 0
ctrl = 1

[state 3010, Voice]
type = null ; playsnd
trigger1 = !animelemtime(3)
value = f10, 1
volumescale = 100
channel = 0

[state 3010, Attack Distance]
type = attackdist
trigger1 = !time
value = 0

[state 3010, End State]
type = changestate
trigger1 = !animelemtime(3) ; !animtime
value = 3015

;=========================================================================
; Powerful Shockwave
;=========================================================================
[Statedef 3015]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 0

[state 3015, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3015, Change Animation]
type = changeanim
trigger1 = !time
value = 3015

[state 3015, Super Config]
type = helper
trigger1 = !animelemtime(1)
name = "Super Config"
id = 6120
stateno = 6120
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 65536
pausemovetime = 65536

[state 3010, Voice]
type = null ; playsnd
trigger1 = !animelemtime(1)
value = f10, 1
volumescale = 100
channel = 0

[state 3015, Voice]
type = playsnd
trigger1 = !animelemtime(2)
value = f10, 0
volumescale = 100
channel = 0

[state 3015, Shockwave]
type = helper
trigger1 = !animelemtime(2)
name = "Shockwave"
ID = 8
stateno = 3020
postype = p1
pos = 74, -42
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 3015, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 0 || var(13) := 80

[state 3015, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 3015, Idle]
type = statetypeset
trigger1 = animelemtime(2) >= 16
movetype = I
persistent = 0

[state 3015, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Proj Start
;=========================================================================
[Statedef 3020]
type = S
movetype = A
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 4

[state 3020, Juggling and Dampener]
type = null
trigger1 = var(3) := root,var(3) || var(4) := root,var(4) || fvar(1) := root,fvar(1)

[state 3020, Change Animation]
type = changeanim
trigger1 = !time
value = 3020

[state 3020, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 3020, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NP,SP,HP
time = -1

[state 3020, Hit Override]
type = hitoverride
trigger1 = 1
attr = SCA,NP,SP,HP
stateno = 3022
slot = 0
time = -1
forceair = 0

[state 3020, Invulnerability]
type = nothitby
trigger1 = cond(numenemy, !enemy,numhelper(8), 0)
value = SCA,NP,SP,HP
time = 1

[state 3020, Set Velocity]
type = velset
trigger1 = !time
x = 5.2734375
y = 0.0

[state 3020, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 3020, Miss]
type = hitdef
trigger1 = 1
attr = S, HP
hitflag = 

[state 3020, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !var(3) && 
ID = 3
attr = S, HP 
damage = 63, 5
fall.envshake.phase = 0 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 0, 6
guard.pausetime = 1, 1
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = -1 ; 195 + 5 * teamside
guard.sparkno = -1 ; 195 + 5 * teamside
sparkxy = 0, 0
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -2.34375, -6.8359375
guard.velocity = -7.8125
air.velocity = -2.34375, -6.8359375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 1
air.fall = 1
fall.recover = 0
fall.animtype = back
forcestand = 1
p2facing = p2statetype != A

[state 3020, End State]
type = changestate
trigger1 = movecontact || movereversed
value = stateno + 1
ignorehitpause = 1

[state 3020, Destroy Helper]
type = destroyself
trigger1 = frontedgedist <= -96

;=========================================================================
; Proj Contact
;=========================================================================
[Statedef 3021]
type = S
movetype = A
physics = N
ctrl = 0
movehitpersist = 1
hitcountpersist = 1

[state 3021, Hit Counter]
type = varadd
trigger1 = !time
var(0) = 1

[state 3021, Hit Counter]
type = varadd
trigger1 = numtarget
trigger1 = target,movetype = H && target,stateno = [5000, 5999]
trigger1 = target,time <= 1 && time <= 1 && !target,hitshakeover
trigger2 = moveguarded || movereversed
var(0) = 65536

[state 3021, Juggle]
type = parentvaradd
trigger1 = movehit = 1 && numtarget
var(3) = 1

[state 3021, Dampener]
type = parentvaradd
trigger1 = movehit = 1 && numtarget
var(5) = 1

[state 3021, Pause Frame]
type = changeanim
trigger1 = 1
value = anim
elem = 1 + var(0) % 2

[state 3021, Hit Sound]
type = playsnd
trigger1 = movecontact = 1 && numtarget
value = f200, cond(movehit, var(1), var(2))
channel = 2

[state 3021, Hit Spark]
type = explod
trigger1 = movecontact = 1 && numtarget
ID = 195 + 5 * teamside
anim = f195 + 5 * teamside
postype = p1
pos = enemy,const(size.ground.front), 0
bindtime = 1
removetime = -2
removeongethit = 0
ownpal = 1
scale = 1.0, 1.0
sprpriority = 5

[state 3021, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 3021, Priority]
type = sprpriority
trigger1 = 1
value = 4

[state 3021, Freeze Position]
type = posfreeze
trigger1 = 1
value = 1

[state 3021, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NP,SP,HP
time = -1

[state 3021, Hit Override]
type = hitoverride
trigger1 = 1
attr = SCA,NP,SP,HP
stateno = 3022
slot = 0
time = -1
forceair = 0

[state 3021, Invulnerability]
type = nothitby
trigger1 = var(0) >= 65536
trigger2 = cond(numenemy, !enemy,numhelper(8), 0)
value = SCA
time = 1

[state 3021, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 3021, Miss]
type = hitdef
trigger1 = 1
attr = S, HP
hitflag = 

[state 3021, End State]
type = changestate
trigger1 = time > 6
value = 3020 + 3 * (var(0) >= 65536)

;=========================================================================
; Proj Canceled
;=========================================================================
[Statedef 3022]
type = S
movetype = A
physics = N
ctrl = 0
movehitpersist = 1
hitcountpersist = 1

[state 3022, Hit Counter]
type = varadd
trigger1 = !time
var(0) = 1

[state 3022, Pause Frame]
type = changeanim
trigger1 = 1
value = anim
elem = 1 + var(0) % 2

[state 3022, Hit Sound]
type = null ; playsnd
trigger1 = !time
value = f200, 120
channel = 2

[state 3022, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 3022, Priority]
type = sprpriority
trigger1 = 1
value = 4

[state 3022, Freeze Position]
type = posfreeze
trigger1 = 1
value = 1

[state 3022, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NP,SP,HP
time = -1

[state 3022, Hit Override]
type = hitoverride
trigger1 = 1
attr = SCA,NP,SP,HP
stateno = 3022
slot = 0
time = -1
forceair = 0

[state 3022, Invulnerability]
type = nothitby
trigger1 = var(0) >= 1
trigger2 = cond(numenemy, !enemy,numhelper(8), 0)
value = SCA
time = 1

[state 3022, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 3022, Miss]
type = hitdef
trigger1 = 1
attr = S, HP
hitflag = 

[state 3022, End State]
type = changestate
trigger1 = time > 6
value = 3020 + 3 * (var(0) >= 1)

;=========================================================================
; Proj End
;=========================================================================
[Statedef 3023]
type = S
movetype = I
physics = N
ctrl = 0
velset = 0, 0
movehitpersist = 1

[state 3023, Change Animation]
type = changeanim
trigger1 = !time
value = 3023

[state 3023, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 3023, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = -1

[state 3023, Destroy Helper]
type = destroyself
trigger1 = !animtime