; Super Fighter Team

;=========================================================================
; Centrifugal - Attempt
;=========================================================================
[Statedef 1000]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = vel x * (prevstateno = 1 || prevstateno = 20), 0
sprpriority = 0

[state 1000, Change Animation]
type = changeanim
trigger1 = !time
value = 1000 + 1 * (anim = 6 || anim = [10, 11]) + 2 * (anim = 20) + 3 * (anim = 21)
elem = animelemno(0)

[state 1000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 0 || var(13) := 0

[state 1000, Throw]
type = hitdef
trigger1 = time > 2
ID = 2
attr = S, ST
damage = 0
fall.envshake.phase = 0 ; dizzy points
hitflag = M-
priority = 1, miss
pausetime = 0, 0
hitsound = -1 + 0 * (var(1) := -1)
guardsound = -1 + 0 * (var(2) := -1)
sparkno = -1
guard.sparkno = -1
ground.slidetime = 0
ground.hittime = 0
ground.velocity = 0.0, 0.0
ground.cornerpush.veloff = 0.0
yaccel = 0.5859375
fall = 1
fall.recover = 0
p1facing = 1
p2facing = 1
p1stateno = 1005
ID = 1

[state 1000, Throw]
type = hitdef
trigger1 = time > 2 && numenemy
trigger1 = enemy,stateno = 5300
ID = 2
attr = S, ST
damage = 0
fall.envshake.phase = 20 ; dizzy points
hitflag = M
priority = 1, miss
pausetime = 0, 0
hitsound = -1 + 0 * (var(1) := -1)
guardsound = -1 + 0 * (var(2) := -1)
sparkno = -1
guard.sparkno = -1
ground.slidetime = 0
ground.hittime = 0
ground.velocity = 0.0, 0.0
ground.cornerpush.veloff = 0.0
yaccel = 0.5859375
fall = 1
fall.recover = 0
p1facing = 1
p2facing = 1
p1stateno = 1005
ID = 1

[state 1000, Idle]
type = statetypeset
trigger1 = time > 8
movetype = I
persistent = 0

[state 1000, End State]
type = changestate
trigger1 = time > 8
value = 11 * (prevstateno = [10, 11]) + 20 * (prevstateno = 1 || prevstateno = 20)
ctrl = 1

;=========================================================================
; Centrifugal - Success
;=========================================================================
[Statedef 1005]
type = S
movetype = A
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 1

[state 1005, Change Animation]
type = changeanim
trigger1 = !time
value = 1005

[state 1005, Width]
type = width
trigger1 = !time || !animelemtime(animelemno(0)) && animelemno(0) % 2 = 1 || !animelemtime(2)
edge = 40 * (!animelemtime(1) || !animelemtime(5)), 24 * !animelemtime(2) + 40 * !animelemtime(3)

[state 1005, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f1, 0
volumescale = 100
channel = 0

[state 1005, Attack Distance]
type = attackdist
trigger1 = !time
value = 0

[state 1005, Target State]
type = targetstate
trigger1 = !time
value = 1010

[state 1005, Target Facing]
type = targetfacing
trigger1 = !time || !animelemtime(4)
value = -1

[state 1005, Target Facing]
type = targetfacing
trigger1 = !animelemtime(3)
value = 1

[state 1005, Target Bind]
type = targetbind
trigger1 = animelemtime(1) >= 0 && animelemtime(2) < 0
pos = 16, -72

[state 1005, Target Bind]
type = targetbind
trigger1 = animelemtime(2) >= 0 && animelemtime(3) < 0
pos = -12, -76

[state 1005, Target Bind]
type = targetbind
trigger1 = animelemtime(3) >= 0 && animelemtime(4) < 0
pos = -32, -72

[state 1005, Target Bind]
type = targetbind
trigger1 = animelemtime(4) >= 0 && animelemtime(5) < 0
pos = 0, -74

[state 1005, Target Bind]
type = targetbind
trigger1 = !animelemtime(5)
pos = 40, -56

[state 1005, Target Damage]
type = targetlifeadd
trigger1 = !time
value = -40 + 25 * (prevstateno = 1300)

[state 1005, Target Power]
type = targetpoweradd
trigger1 = !time
value = 10

[state 1005, Target State]
type = targetstate
trigger1 = !animelemtime(5)
value = 1011

[state 1005, Add Power]
type = poweradd
trigger1 = !time
value = 10

[state 1005, Juggle and Dampener Hit Counters]
type = null
trigger1 = !time
trigger1 = var(3) := var(3) + 1 || var(4) := 1 || var(5) := var(5) + 1

[state 1005, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Target Grabbed
;=========================================================================
[Statedef 1010]
type = S
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 1010, Change Animation]
type = changeanim2
trigger1 = !time
value = 1010

[state 1010, Bound]
type = screenbound
trigger1 = 1
value = 0
movecamera = 1, 1

[state 1010, Priority]
type = sprpriority
trigger1 = numenemy
trigger1 = enemy,stateno = 1005 && !enemy,animelemtime(4)
value = 2

[state 1010, Own State]
type = selfstate
trigger1 = !gethitvar(isbound)
trigger1 = time > 100
value = 5050

;=========================================================================
; Target Thrown
;=========================================================================
[Statedef 1011]
type = A
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 1011, Set Hit Fall]
type = hitfallset
trigger1 = !time
value = 1

[state 1011, Change Animation]
type = changeanim
trigger1 = !time
value = 5050

[state 1011, Change Animation]
type = changeanim
trigger1 = vel y > 0
value = 5060
persistent = 0

[state 1011, Increment Position]
type = posadd
trigger1 = !time
y = -const(size.mid.pos.y)

[state 1011, Set Velocity]
type = velset
trigger1 = !time
x = -3.90625
y = -9.765625

[state 1011, Increment Velocity]
type = veladd
trigger1 = 1
y = 0.5859375

[state 1011, Set Velocity]
type = velset
trigger1 = pos y >= const(movement.air.gethit.groundlevel)
trigger1 = vel y > 0
x = -1.171875

[state 1011, Own State]
type = selfstate
trigger1 = pos y >= const(movement.air.gethit.groundlevel)
trigger1 = vel y > 0
value = 5100
ctrl = 0

;=========================================================================
; Head Breaker
;=========================================================================
[Statedef 1100]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1100, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1100, Change Animation]
type = changeanim
trigger1 = !time
value = 1100

[state 1100, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f1, 0
volumescale = 100
channel = 0

[state 1100, Sound]
type = playsnd
trigger1 = !animelemtime(3)
value = f5100, 0
volumescale = 100

[state 1100, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 7 || var(13) := 56

[state 1100, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(3) && p2dist x >= 0
ID = 2
attr = S, SA
damage = 15, 1
fall.envshake.phase = 16 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -6.8359375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = back

[state 1100, Idle]
type = statetypeset
trigger1 = animtime >= 0
movetype = I
persistent = 0

[state 1100, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Air Crash - Attempt
;=========================================================================
[Statedef 1200]
type = A
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = vel x, vel y
sprpriority = 0

[state 1200, Change Animation]
type = changeanim
trigger1 = !time && anim = [41, 43]
value = 1200 + 1 * (anim = 42) + 2 * (anim = 43)
elem = animelemno(0)

[state 1200, Change Animation]
type = changeanim
trigger1 = time = 1
value = 41 + 1 * (anim = 1201) + 2 * (anim = 1202)
elem = animelemno(0)

[state 1200, Increment Velocity]
type = veladd
trigger1 = 1
y = const(movement.yaccel)

[state 1200, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 0 || var(13) := 0

[state 1200, Throw]
type = hitdef
trigger1 = !time
ID = 11 ; air crash
attr = A, ST
damage = 0
fall.envshake.phase = 32 ; dizzy points
hitflag = A-
priority = 1, miss
pausetime = 0, 0
hitsound = -1 + 0 * (var(1) := -1)
guardsound = -1 + 0 * (var(2) := -1)
sparkno = -1
guard.sparkno = -1
ground.slidetime = 0
ground.hittime = 0
ground.velocity = 0.0, 0.0
ground.cornerpush.veloff = 0.0
yaccel = 0.5859375
fall = 1
fall.recover = 0
p1facing = 1
p2facing = 1
p1stateno = 1205

[state 1200, Miss]
type = hitdef
trigger1 = time = 1
ID = 2
attr = A, ST
hitflag = 

[state 1200, Idle]
type = statetypeset
trigger1 = time = 1
movetype = I
persistent = 0

[state 1200, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 52

;=========================================================================
; Air Crash - Success
;=========================================================================
[Statedef 1205]
type = A
movetype = A
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 1

[state 1205, Change Animation]
type = changeanim
trigger1 = !time
value = 1205

[state 1205, Width]
type = width
trigger1 = !time
edge = 40, 0

[state 1205, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f1, 0
volumescale = 100
channel = 0

[state 1205, Increment Velocity]
type = veladd
trigger1 = animelemtime(2) >= 0
y = const(movement.yaccel)

[state 1205, Attack Distance]
type = attackdist
trigger1 = !time
value = 0

[state 1205, Target State]
type = targetstate
trigger1 = !time
value = 1210

[state 1205, Target Facing]
type = targetfacing
trigger1 = !time
value = -1

[state 1205, Target Bind]
type = targetbind
trigger1 = animelemtime(1) >= 0 && animelemtime(2) < 0
pos = 8, -104

[state 1205, Target Bind]
type = targetbind
trigger1 = animelemtime(2) >= 0
pos = 16, -48

[state 1205, Target Damage]
type = targetlifeadd
trigger1 = !time
value = -30

[state 1205, Target Power]
type = targetpoweradd
trigger1 = !time
value = 10

[state 1205, Add Power]
type = poweradd
trigger1 = !time
value = 10

[state 1205, Juggle and Dampener Hit Counters]
type = null
trigger1 = !time
trigger1 = var(3) := var(3) + 1 || var(4) := 1 || var(5) := var(5) + 1

[state 1205, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 1206
ctrl = 0

;=========================================================================
; Air Crash - Crash
;=========================================================================
[Statedef 1206]
type = A
movetype = A
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 1

[state 1206, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1206, Change Animation]
type = changeanim
trigger1 = !time
value = 1206

[state 1206, Width]
type = width
trigger1 = !animelemtime(2)
edge = 40, 0

[state 1206, Sound]
type = playsnd
trigger1 = !animelemtime(2)
value = f5100, 0
volumescale = 100

[state 1206, Attack Distance]
type = attackdist
trigger1 = 1
value = 0

[state 1206, Target Bind]
type = targetbind
trigger1 = animelemtime(1) >= 0 && animelemtime(2) < 0
pos = 16, -48

[state 1206, Target Bind]
type = targetbind
trigger1 = animelemtime(2) >= 0 && animelemtime(2) < 8
pos = 36, -24

[state 1206, Target Bind]
type = targetbind
trigger1 = animelemtime(2) = 8
pos = 36, -16

[state 1005, Target State]
type = targetstate
trigger1 = animelemtime(2) = 8
value = 1211

[state 1206, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Target Grabbed
;=========================================================================
[Statedef 1210]
type = S
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 1210, Change Animation]
type = changeanim2
trigger1 = !time
value = 1210

[state 1210, Bound]
type = screenbound
trigger1 = 1
value = 0
movecamera = 1, 1

[state 1210, Own State]
type = selfstate
trigger1 = !gethitvar(isbound)
trigger1 = time > 100
value = 5050

;=========================================================================
; Target Slammed
;=========================================================================
[Statedef 1211]
type = A
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 1211, Set Hit Fall]
type = hitfallset
trigger1 = !time
value = 1

[state 1211, Change Animation]
type = changeanim
trigger1 = !time
value = 5050

[state 1211, Change Animation]
type = changeanim
trigger1 = vel y > 0
value = 5060
persistent = 0

[state 1211, Increment Position]
type = posadd
trigger1 = !time
y = -const(size.mid.pos.y) * 0.5

[state 1211, Set Velocity]
type = velset
trigger1 = !time
x = -3.90625
y = -6.640625

[state 1211, Increment Velocity]
type = veladd
trigger1 = 1
y = 0.5859375

[state 1211, Own State]
type = selfstate
trigger1 = pos y >= const(movement.air.gethit.groundlevel)
trigger1 = vel y > 0
value = 5100
ctrl = 0

;=========================================================================
; Centrifugal Strut
;=========================================================================
[Statedef 1300]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 0

[state 1300, Change Animation]
type = changeanim
trigger1 = !time
value = 1300

[state 1300, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f1, 0
volumescale = 100
channel = 0

[state 1300, Set Velocity]
type = velset
trigger1 = !animelemtime(1)
x = const(velocity.walk.fwd.x) * 2.0

[state 1300, Set Velocity]
type = velset
trigger1 = !animelemtime(7)
x = 0.0

[state 1300, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 0 || var(13) := 0

[state 1300, Throw]
type = hitdef
trigger1 = movetype = A && animelemtime(3) >= 0
ID = 2
attr = S, ST
damage = 0
fall.envshake.phase = 15 ; dizzy points
hitflag = M-
priority = 1, miss
pausetime = 0, 0
hitsound = -1 + 0 * (var(1) := -1)
guardsound = -1 + 0 * (var(2) := -1)
sparkno = -1
guard.sparkno = -1
ground.slidetime = 0
ground.hittime = 0
ground.velocity = 0.0, 0.0
ground.cornerpush.veloff = 0.0
yaccel = 0.5859375
fall = 1
fall.recover = 0
p1facing = 1
p2facing = 1
p1stateno = 1005

[state 1300, Throw]
type = hitdef
trigger1 = movetype = A && animelemtime(3) >= 0 && numenemy
trigger1 = enemy,stateno = 5300
ID = 2
attr = S, ST
damage = 0
fall.envshake.phase = 15 ; dizzy points
hitflag = M
priority = 1, miss
pausetime = 0, 0
hitsound = -1 + 0 * (var(1) := -1)
guardsound = -1 + 0 * (var(2) := -1)
sparkno = -1
guard.sparkno = -1
ground.slidetime = 0
ground.hittime = 0
ground.velocity = 0.0, 0.0
ground.cornerpush.veloff = 0.0
yaccel = 0.5859375
fall = 1
fall.recover = 0
p1facing = 1
p2facing = 1
p1stateno = 1005

[state 1300, Idle]
type = statetypeset
trigger1 = animelemtime(7) >= 0
movetype = I
persistent = 0

[state 1300, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1
