; Super Fighter Team

;=========================================================================
;  Acrobatic Assault
;=========================================================================
[Statedef 3000]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 1

[state 3000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3000, Change Animation]
type = changeanim
trigger1 = !time
value = 3000

[state 3000, Add Power]
type = poweradd
trigger1 = !time
value = -power

[state 3000, Super Config]
type = helper
trigger1 = !animelemtime(1)
name = "Super Config"
id = 6120
stateno = 6120
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 65536
pausemovetime = 65536

[state 3000, Super Pause]
type = superpause
trigger1 = !animelemtime(1)
time = 48
movetime = 48
unhittable = 1
anim = -1
sound = -1
p2defmul = 1
poweradd = 0
darken = 0

[state 3000, Invulnerability]
type = nothitby
trigger1 = animelemtime(1) <= 48
value = SCA
time = 1

[state 3000, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f8, 0
volumescale = 100
channel = 0

[state 3000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 0 || var(13) := 0

[state 3000, Throw]
type = hitdef
trigger1 = !animelemtime(2) && numenemy
ID = 3
attr = S, HT
damage = 0
fall.envshake.phase = 8 ; dizzy points
hitflag = MA
priority = 1, miss
pausetime = 0, 0
hitsound = -1 + 0 * (var(1) := -1)
guardsound = -1 + 0 * (var(2) := -1)
sparkno = -1
guard.sparkno = -1
ground.slidetime = 0
ground.hittime = 0
ground.velocity = 0.0, 0.0
ground.cornerpush.veloff = 0.0
yaccel = 0.5859375
fall = 1
fall.recover = 0
p1facing = 1
p2facing = 1
p1stateno = 3005

[state 3000, Idle]
type = statetypeset
trigger1 = animelemtime(3) >= 0
movetype = I
persistent = 0

[state 3000, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Assault
;=========================================================================
[Statedef 3005]
type = S
movetype = A
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 1

[state 3005, Change Animation]
type = changeanim
trigger1 = !time
value = 3005

[state 3005, Width]
type = width
trigger1 = !time
edge = 40, 0

[state 3005, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f8, 0
volumescale = 100
channel = 0

[state 3005, Set Velocity]
type = velset
trigger1 = !animelemtime(2)
x = -3.515625
y = -7.03125

[state 3005, Increment Velocity]
type = veladd
trigger1 = animelemtime(2) > 0
y = const(movement.yaccel)

[state 3005, Attack Distance]
type = attackdist
trigger1 = !time
value = 0

[state 3005, Target State]
type = targetstate
trigger1 = !time
value = 3015

[state 3005, Target Facing]
type = targetfacing
trigger1 = !time
value = 1

[state 3005, Target Bind]
type = targetbind
trigger1 = animelemtime(1) >= 0 && animelemtime(2) < 0
pos = 8, 0

[state 3005, Target Bind]
type = targetbind
trigger1 = animelemtime(2) >= 0 && animelemtime(3) < 0
pos = -12, -80

[state 3005, Target Bind]
type = targetbind
trigger1 = animelemtime(3) >= 0
pos = -8, -16

[state 3005, Juggle and Dampener Hit Counters]
type = null
trigger1 = !time
trigger1 = var(3) := var(3) + 1 || var(4) := 1 || var(5) := var(5) + 1

[state 3005, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 3006

;=========================================================================
; Suplex
;=========================================================================
[Statedef 3006]
type = S
movetype = A
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 1

[state 3006, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3006, Change Animation]
type = changeanim
trigger1 = !time
value = 3006

[state 3006, Sound]
type = playsnd
trigger1 = !time
value = f5100, 0
volumescale = 100

[state 3006, Solidity]
type = playerpush
trigger1 = animelemtime(2) >= 0
value = 0

[state 3006, Set Velocity]
type = velset
trigger1 = !animelemtime(2)
x = -3.125
y = -9.375

[state 3006, Increment Velocity]
type = veladd
trigger1 = animelemtime(2) > 0
y = const(movement.yaccel)

[state 3005, Attack Distance]
type = attackdist
trigger1 = !time
value = 0

[state 3005, Target State]
type = targetstate
trigger1 = !time
value = 3016

[state 3006, Target Bind]
type = targetbind
trigger1 = animelemtime(1) >= 0 && animelemtime(2) < 0
pos = -8, -16

[state 3006, Target Bind]
type = targetbind
trigger1 = !animelemtime(2)
pos = -16, -32

[state 3006, Target Damage]
type = targetlifeadd
trigger1 = !time
value = -30
kill = 0

[state 3006, Target Power]
type = targetpoweradd
trigger1 = !time
value = 5

[state 3006, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 3007

;=========================================================================
; Land
;=========================================================================
[Statedef 3007]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 3007, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3007, Change Animation]
type = changeanim
trigger1 = !time
value = 3007

[state 3007, End State]
type = changestate
trigger1 = !animtime
value = 3010
ctrl = 0

;=========================================================================
; Slicing Whip & Trip
;=========================================================================
[Statedef 3010]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 1

[state 3010, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3010, Change Animation]
type = changeanim
trigger1 = !time
value = 3010

[state 3010, Change Animation]
type = changeanim
trigger1 = numtarget && animelemtime(2) < 0 && time < 128
trigger1 = target,stateno != 5300
value = anim
elem = 1

[state 3010, Shadow]
type = varset
trigger1 = 1
var(16) = -2 * (animelemtime(1) >= 0) + 2 * (animelemtime(2) >= 0) - 2 * (animelemtime(4) >= 0)

[state 3010, Shadow]
type = varset
trigger1 = 1
var(16) = 4 * (animelemtime(5) >= 0) + 8 * (animelemtime(6) >= 0) - 8 * (animelemtime(8) >= 0)

[state 3010, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f8, 0
volumescale = 100
channel = 0
persistent = 0

[state 3010, Sound]
type = playsnd
trigger1 = !animelemtime(2) || !animelemtime(5)
value = f100, 0
volumescale = 100
channel = 1

[state 3010, Set Velocity]
type = velset
trigger1 = !animelemtime(6)
x = 7.8125

[state 3010, Increment Velocity]
type = veladd
trigger1 = animelemtime(6) > 0 && animelemtime(8) < 0 
x = -0.55803571428571428571428571428571

[state 3010, Set Velocity]
type = velset
trigger1 = !animelemtime(8)
x = 0.0

[state 3010, Energy]
type = helper
trigger1 = !animelemtime(2)
name = "Energy"
ID = 1005
stateno = 7000
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 3010, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 4 - 3 * (animelemtime(5) >= 0)

[state 3010, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(3)
ID = 3
attr = S, HA
damage = 15, 1
fall.envshake.phase = 8 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 8, 8
guard.pausetime = 8, 8
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -32
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 27
ground.hittime = 27
guard.slidetime = 27
guard.hittime = 27
air.hittime = 27
ground.velocity = -3.90625
guard.velocity = -3.90625
air.velocity = -3.125, -3.515625
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1
kill = 0

[state 3010, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(7)
ID = 3
attr = S, HA
damage = 15, 1
fall.envshake.phase = 8 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 8, 8
guard.pausetime = 8, 8
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -8
animtype = hard
ground.type = trip
air.animtype = back
air.type = trip
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -1.5625, -6.640625
guard.velocity = -7.8125
air.velocity = -1.5625, -6.640625
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 1
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3010, Idle]
type = statetypeset
trigger1 = animelemtime(8) >= 0
movetype = I
persistent = 0

[state 3010, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Target Grabbed
;=========================================================================
[Statedef 3015]
type = S
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 3015, Change Animation]
type = changeanim2
trigger1 = !time
value = 3015

[state 3015, Bound]
type = screenbound
trigger1 = 1
value = 0
movecamera = 1, 1

[state 3015, Own State]
type = selfstate
trigger1 = !gethitvar(isbound)
trigger1 = time > 100
value = 5050

;=========================================================================
; Target Slammed
;=========================================================================
[Statedef 3016]
type = A
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 3016, Dizzy Points]
type = varset
trigger1 = !time
fvar(3) = 0.0 + (var(10) := 1)

[state 3016, Set Hit Fall]
type = hitfallset
trigger1 = !time
value = 1

[state 3016, Change Animation]
type = changeanim2
trigger1 = !time
value = 3016

[state 3016, Background Effect]
type = bgpalfx
trigger1 = !time
time = 2
color = 256
invertall = 1

[state 3016, Shake]
type = envshake
trigger1 = !time
time = 8
ampl = 4

[state 3016, Set Velocity]
type = null ; velset
trigger1 = time > 16
x = 3.125

[state 3016, Own State]
type = selfstate
trigger1 = time > 16
value = 5110
ctrl = 0