; Super Fighter Team

;=========================================================================
; Stand
;=========================================================================
[StateDef 0]
type = S
movetype = I
physics = N
velset = 0, 0
sprpriority = 0

; Prevent helpers, their explods, and sounds from existing in this state
[state 0, Destroy]
type = stopsnd
trigger1 = ishelper
channel = -1
[state 0, Destroy]
type = removeexplod
trigger1 = ishelper
[state 0, Destroy]
type = destroyself
trigger1 = ishelper

; Stand from grab attempt
[state 0, Change Animation]
type = changeanim
trigger1 = prevstateno = 800 && anim = 800
trigger2 = name = "Sarkov"
trigger2 = prevstateno = 1000 && anim = 1000
value = 0
elem = 1 + (animelemno(0) - 1)
persistent = 0

[state 0, Continue Walking]
type = changestate
trigger1 = prevstateno != 1 && prevstateno = 20
trigger1 = anim = [20, 21]
trigger1 = !time
value = 1

[state 0, Change Animation]
type = changeanim
trigger1 = anim != 0 && anim != 5
trigger2 = anim = 5 && !animtime
value = 0

; Send this character to the death state if it is not alive
[state 0, End State]
type = changestate
trigger1 = !alive
value = 5050

; Jaan
[state 0, Shadow]
type = varset
trigger1 = name = "Jaan"
var(16) = 0 * (animelemtime(1) >= 0) + 0 * (animelemtime(2) >= 0)

; Sarkov
[state 0, Shadow]
type = varset
trigger1 = name = "Sarkov"
var(16) = 0 * (animelemtime(1) >= 0) + 0 * (animelemtime(2) >= 0)

; Bullet
[state 0, Shadow]
type = varset
trigger1 = name = "Bullet"
var(16) = 0 * (animelemtime(1) >= 0) + 0 * (animelemtime(2) >= 0)

; Phoenix
[state 0, Shadow]
type = varset
trigger1 = name = "Phoenix"
var(16) = 0 * (animelemtime(1) >= 0) + 0 * (animelemtime(2) >= 0)

; Frank
[state 0, Shadow]
type = varset
trigger1 = name = "Frank"
var(16) = 0 * (animelemtime(1) >= 0) + 1 * (animelemtime(2) >= 0) + 2 * (animelemtime(3) >= 0) - 1 * (animelemtime(4) >= 0)

; Onimaru
[state 0, Shadow]
type = varset
trigger1 = name = "Onimaru"
var(16) = 0 * (animelemtime(1) >= 0) + 0 * (animelemtime(2) >= 0)

; Lan
[state 0, Shadow]
type = varset
trigger1 = name = "Lan"
var(16) = 0 * (animelemtime(1) >= 0) + 0 * (animelemtime(2) >= 0)

; Kim Tai Chi
[state 0, Shadow]
type = varset
trigger1 = name = "Kim Tai Chi"
var(16) = 0 * (animelemtime(1) >= 0) + 0 * (animelemtime(2) >= 0)

; Widow
[state 0, Shadow]
type = varset
trigger1 = name = "Widow"
var(16) = 0 * (animelemtime(1) >= 0) + 0 * (animelemtime(2) >= 0)

; Joker
[state 0, Shadow]
type = varset
trigger1 = name = "Joker"
var(16) = 0 * (animelemtime(1) >= 0) + 0 * (animelemtime(2) >= 0)

; Red Man
[state 0, Shadow]
type = varset
trigger1 = name = "Red Man"
var(16) = 0 * (animelemtime(1) >= 0) + 0 * (animelemtime(2) >= 0)

;=========================================================================
; Finish Walking
;=========================================================================
[StateDef 1]
type = S
movetype = I
physics = N
velset = fvar(0), 0
sprpriority = 0

[state 1, Special Effect]
type = assertspecial
trigger1 = 1
flag = noautoturn

; Jaan
[state 1, Walk Velocity]
type = velset
trigger1 = name = "Jaan"
trigger1 = vel x && animelemtime(4) > 6
x = 0.0

; Sarkov
[state 1, Walk Velocity]
type = velset
trigger1 = name = "Sarkov"
trigger1 = vel x && !animtime
x = 0.0

; Bullet
[state 1, Walk Velocity]
type = velset
trigger1 = name = "Bullet"
trigger1 = vel x && animelemtime(4) > 6
x = 0.0

; Phoenix
[state 1, Walk Velocity]
type = velset
trigger1 = name = "Phoenix"
trigger1 = vel x && !animtime
x = 0.0

; Frank
[state 1, Walk Velocity]
type = velset
trigger1 = name = "Frank"
trigger1 = vel x && !animtime
x = 0.0

; Onimaru
[state 1, Walk Velocity]
type = velset
trigger1 = name = "Onimaru"
trigger1 = vel x && !animtime
x = 0.0

; Onimaru
[state 20, Set Velocity]
type = posfreeze
trigger1 = name = "Onimaru"
trigger1 = anim = 20 && animelemtime(2) < 0 || anim = 21 && animelemtime(6) >= 0
value = 1

; Lan
[state 1, Walk Velocity]
type = velset
trigger1 = name = "Lan"
trigger1 = vel x && !animtime
x = 0.0

; Kim Tai Chi
[state 1, Walk Velocity]
type = velset
trigger1 = name = "Kim Tai Chi"
trigger1 = vel x && !animtime
x = 0.0

; Widow
[state 1, Walk Velocity]
type = velset
trigger1 = name = "Widow"
trigger1 = vel x && !animtime
x = 0.0

; Joker
[state 1, Walk Velocity]
type = velset
trigger1 = name = "Joker"
trigger1 = vel x && !animtime
x = 0.0

; Red Man
[state 1, Walk Velocity]
type = velset
trigger1 = name = "Red Man"
trigger1 = vel x && !animtime
x = 0.0

[state 1, Set Velocity]
type = velset
trigger1 = p2dist x < 0
x = fvar(0) * -1.0

[state 1, Turn]
type = turn
trigger1 = p2dist x < 0

[state 1, End State]
type = changestate
trigger1 = !animtime || !vel x
value = 0

;=========================================================================
; Stand to Crouch
;=========================================================================
[Statedef 10]
type = C
movetype = I
physics = C
velset = 0, 0
sprpriority = 0

[state 10, Change Animation]
type = changeanim
trigger1 = !time
value = 10

; Lan
[state 10, Shadow]
type = varset
trigger1 = name = "Lan"
var(16) = 8

[state 10, Multiply Velocity]
type = velmul
trigger1 = !time
x = 0.75

[state 10, Set Velocity]
type = velset
trigger1 = abs(vel x) < const(movement.crouch.friction.threshold)
x = 0.0

[state 10, End State]
type = changestate
trigger1 = !animtime
value = 11

;=========================================================================
; Crouching
;=========================================================================
[Statedef 11]
type = C
movetype = I
physics = C
velset = 0, 0
sprpriority = 0

[state 11, Change Animation]
type = changeanim
trigger1 = !time
value = 11

; Crouch from grab attempt
[state 11, Change Animation]
type = changeanim
trigger1 = prevstateno = 800 && anim = 801
trigger2 = name = "Sarkov"
trigger2 = prevstateno = 1000 && anim = 1001
value = 11
elem = 1 + (animelemno(0) - 1)
persistent = 0

[state 11, Change Animation]
type = changeanim
trigger1 = anim = 6
trigger1 = !animtime
value = 11

; Lan
[state 11, Shadow]
type = varset
trigger1 = name = "Lan"
var(16) = 8

; Kim Tai Chi
[state 11, Shadow]
type = varset
trigger1 = name = "Kim Tai Chi"
var(16) = 8

;=========================================================================
; Crouch to Stand
;=========================================================================
[Statedef 12]
type = S
movetype = I
physics = S
velset = 0, 0
sprpriority = 0

[state 12, Change Animation]
type = changeanim
trigger1 = !time
value = 12

[state 12, End State]
type = changestate
trigger1 = !animtime
value = 0

;=========================================================================
; Walking
;=========================================================================
[StateDef 20]
type = S
movetype = I
physics = N
ctrl = 1
sprpriority = 0

; Walk forward
[state 20, Set Velocity]
type = velset
trigger1 = command = "holdfwd"
x = const(velocity.walk.fwd.x)

; Walk backward
[state 20, Set Velocity]
type = velset
trigger1 = command = "holdback"
x = const(velocity.walk.back.x)

; Onimaru
[state 20, Set Velocity]
type = posfreeze
trigger1 = name = "Onimaru"
trigger1 = anim = 20 && animelemtime(2) < 0 || anim = 21 && animelemtime(6) >= 0
value = 1

; Walk forward from grab attempt
[state 20, Change Animation]
type = changeanim
trigger1 = prevstateno = 800 && anim = 802
trigger2 = name = "Sarkov"
trigger2 = prevstateno = 1000 && anim = 1002
value = 20
elem = 1 + (animelemno(0) - 1)
persistent = 0

; Walk backward from grab attempt
[state 20, Change Animation]
type = changeanim
trigger1 = prevstateno = 800 && anim = 803
trigger2 = name = "Sarkov"
trigger2 = prevstateno = 1000 && anim = 1003
value = 21
elem = 1 + (animelemno(0) - 1)
persistent = 0

[state 20, Change Animation]
type = changeanim
trigger1 = anim != 20 + (vel x < 0)
value = 20 + (vel x < 0)

[state 20, Walk Velocity]
type = varset
trigger1 = 1
fvar(0) = vel x

;=========================================================================
; Jump Start
;=========================================================================
[Statedef 40]
type = S
movetype = I
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 1

[state 40, Change Animation]
type = changeanim
trigger1 = !time
value = cond(command = "holdback", 40, cond(command = "holdfwd", 39, 38))

[state 40, Jump Direction]
type = varset
trigger1 = !ailevel
sysvar(1) = cond(!time, 0, cond(command = "holdfwd", 1, cond(command = "holdback", -1, sysvar(1))))

[state 40, Jump Direction]
type = varset
trigger1 = ailevel
sysvar(1) = cond(p2movetype != A || backedgebodydist <= 16 || random < 50, 1, cond(p2movetype = A, -1, 0))

[state 40, Jump Direction]
type = varset
trigger1 = ailevel && var(17) = 1 ; && numenemy && random < 496 * (ailevel ** 2.0 / 64.0)
; trigger1 = enemy,hitdefattr = SC, AT && enemy,vel x >= 0 && random < 128
sysvar(1) = random % 2

[state 40, Jump Direction]
type = varset
trigger1 = ailevel && var(17) = 2 ; && numenemy && random < 1000 * (ailevel ** 2.0 / 64.0)
trigger1 = enemy,var(14) = 1 || enemy,var(14) = 2 || enemy,var(14) = 4
trigger1 = enemy,fvar(6) = [64, 128]
sysvar(1) = 1 - (p2bodydist x = [-8, 56])

[state 40, Jump Direction]
type = varset
trigger1 = ailevel && var(17) = 3 ; && random < 1000 * (ailevel ** 2.0 / 64.0)
; trigger1 = backedgedist > frontedgedist && enemy,stateno = 5120 && enemy,anim >= -8
sysvar(1) = -1

[state 40, Change Animation]
type = null ; changeanim
trigger1 = !time
value = 38 + 1 * (sysvar(1) = 1) + 2 * (sysvar(1) = -1)

[state 40, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NA,SA,HA,NP,SP,HP

[state 40, Set Velocity]
type = velset
trigger1 = !animtime
x = const(velocity.jump.back.x) * (sysvar(1) = -1) + 0.0 * (sysvar(1) = 0) + const(velocity.jump.fwd.x) * (sysvar(1) = 1)
y = fvar(5) := const(velocity.jump.y)

; Jaan
[state 40, Jump Suspension]
type = null
trigger1 = !animtime && name = "Jaan"
trigger1 = var(15) := 8 * (sysvar(1) = -1) + 8 * (sysvar(1) = 0) + 8 * (sysvar(1) = 1)

; Sarkov
[state 40, Jump Suspension]
type = null
trigger1 = !animtime && name = "Sarkov"
trigger1 = var(15) := 8 * (sysvar(1) = -1) + 6 * (sysvar(1) = 0) + 8 * (sysvar(1) = 1)

; Bullet
[state 40, Jump Suspension]
type = null
trigger1 = !animtime && name = "Bullet"
trigger1 = var(15) := 5 * (sysvar(1) = -1) + 5 * (sysvar(1) = 0) + 5 * (sysvar(1) = 1)

; Phoenix
[state 40, Jump Suspension]
type = null
trigger1 = !animtime && name = "Phoenix"
trigger1 = var(15) := 2 * (sysvar(1) = -1) + 2 * (sysvar(1) = 0) + 2 * (sysvar(1) = 1)

; Frank
[state 40, Jump Suspension]
type = null
trigger1 = !animtime && name = "Frank"
trigger1 = var(15) := 7 * (sysvar(1) = -1) + 7 * (sysvar(1) = 0) + 7 * (sysvar(1) = 1)

; Onimaru
[state 40, Jump Suspension]
type = null
trigger1 = !animtime && name = "Onimaru"
trigger1 = var(15) := 6 * (sysvar(1) = -1) + 6 * (sysvar(1) = 0) + 6 * (sysvar(1) = 1)

; Lan
[state 40, Jump Suspension]
type = null
trigger1 = !animtime && name = "Lan"
trigger1 = var(15) := 5 * (sysvar(1) = -1) + 5 * (sysvar(1) = 0) + 5 * (sysvar(1) = 1)

; Kim Tai Chi
[state 40, Jump Suspension]
type = null
trigger1 = !animtime && name = "Kim Tai Chi"
trigger1 = var(15) := 8 * (sysvar(1) = -1) + 5 * (sysvar(1) = 0) + 8 * (sysvar(1) = 1)

; Widow
[state 40, Jump Suspension]
type = null
trigger1 = !animtime && name = "Widow"
trigger1 = var(15) := 0 * (sysvar(1) = -1) + 0 * (sysvar(1) = 0) + 0 * (sysvar(1) = 1)

; Joker
[state 40, Jump Suspension]
type = null
trigger1 = !animtime && name = "Joker"
trigger1 = var(15) := 4 * (sysvar(1) = -1) + 4 * (sysvar(1) = 0) + 4 * (sysvar(1) = 1)

; Red Man
[state 40, Jump Suspension]
type = null
trigger1 = !animtime && name = "Red Man"
trigger1 = var(15) := 5 * (sysvar(1) = -1) + 5 * (sysvar(1) = 0) + 5 * (sysvar(1) = 1)

[state 40, End State]
type = changestate
trigger1 = !animtime
value = 50
ctrl = 1

;=========================================================================
; Jumping
;=========================================================================
[Statedef 50]
type = A
movetype = I
physics = N
sprpriority = 1

[state 50, Change Animation]
type = changeanim
trigger1 = !time
value = 43 * (sysvar(1) = -1) + 41 * (sysvar(1) = 0) + 42 * (sysvar(1) = 1)

[state 50, Increment Velocity]
type = veladd
trigger1 = 1
y = const(movement.yaccel)

[state 50, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 52

;=========================================================================
; Jump Land
;=========================================================================
[Statedef 52]
type = S
movetype = I
physics = N
ctrl = 0
velset = 0 - 1.28 * (name = "Phoenix" && (prevstateno = 5040 || anim = 5040 || prevstateno = 5210)), 0
sprpriority = 0

[state 52, Set Position]
type = posset
trigger1 = !time
y = 0

; Jaan
[state 52, Change Animation]
type = changeanim
trigger1 = !time && name = "Jaan"
value = 47

; Sarkov
[state 52, Change Animation]
type = changeanim
trigger1 = !time && name = "Sarkov"
value = 47 + abs(sysvar(1))

; Bullet
[state 52, Change Animation]
type = changeanim
trigger1 = !time && name = "Bullet"
value = 47

; Phoenix
[state 52, Change Animation]
type = changeanim
trigger1 = !time && name = "Phoenix"
value = 47 + (prevstateno = 5040 || anim = 5040 || prevstateno = 5210 || anim = 5210)

; Frank
[state 52, Change Animation]
type = changeanim
trigger1 = !time && name = "Frank"
value = 47

; Onimaru
[state 52, Change Animation]
type = changeanim
trigger1 = !time && name = "Onimaru"
value = 47

; Lan
[state 52, Change Animation]
type = changeanim
trigger1 = !time && name = "Lan"
value = 47

; Kim Tai Chi
[state 52, Change Animation]
type = changeanim
trigger1 = !time && name = "Kim Tai Chi"
value = 47

; Widow
[state 52, Change Animation]
type = changeanim
trigger1 = !time && name = "Widow"
value = 47 + abs(sysvar(1))

; Joker
[state 52, Change Animation]
type = changeanim
trigger1 = !time && name = "Joker"
value = 47

; Red Man
[state 52, Change Animation]
type = changeanim
trigger1 = !time && name = "Red Man"
value = 47

[state 52, Special Effect]
type = assertspecial
trigger1 = 1
flag = nowalk

; Phoenix
[state 52, Special Effect]
type = assertspecial
trigger1 = name = "Phoenix"
trigger1 = anim = 48 && animelemtime(3) < 0
flag = nostandguard
flag2 = nocrouchguard

; Phoenix
[state 52, Invulnerability]
type = nothitby
trigger1 = name = "Phoenix"
trigger1 = anim = 48 && animelemtime(3) < 0
value = SCA

[state 52, Sound]
type = playsnd
trigger1 = !time
value = f52, 0
volumescale = 100

; Phoenix
[state 52, Control]
type = ctrlset
trigger1 = name = "Phoenix"
trigger1 = anim = 48 && animelemtime(3) > 3
value = 1

[state 52, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Into Guard
;=========================================================================
[Statedef 120]
type = U
physics = U

[state 120, Set Velocity]
type = velset
trigger1 = !time && statetype != A
x = 0.0
y = 0.0

[state 120, Change Animation]
type = changeanim
trigger1 = !time
value = 120 + (statetype = C) + (statetype = A) * 2

[state 120, Set State Type]
type = statetypeset
trigger1 = !time && statetype = S
physics = S

[state 120, Set State Type]
type = statetypeset
trigger1 = !time && statetype = C
physics = C

[state 120, Set State Type]
type = statetypeset
trigger1 = !time && statetype = A
physics = A

[state 120, High -> Low]
type = statetypeset
trigger1 = !ailevel && statetype = S && command = "holddown"
trigger2 = ailevel && statetype = S && enemy,movetype = A && enemy,statetype = C
statetype = C
physics = C

[state 120, Low -> High]
type = statetypeset
trigger1 = !ailevel && statetype = C && command != "holddown"
trigger2 = ailevel && statetype = C && enemy,movetype = A && enemy,statetype!= C
statetype = S
physics = S

[state 120, AI Fix]
type = ctrlset
trigger1 = ailevel && numenemy
value = enemy,time >= 70 || time >= 70

[state 120, End State]
type = changestate
trigger1 = !animtime
value = 130 + (statetype = C) + (statetype = A) * 2

[state 120, End State]
type = changestate
trigger1 = !ailevel && command != "holdback"
trigger2 = !inguarddist
trigger3 = ailevel && numenemy
trigger3 = enemy,hitdefattr = SCA,AT
value = 140

;=========================================================================
; Stand Guard (guarding)
;=========================================================================
[Statedef 130]
type = S
physics = S

[state 130, Change Animation]
type = changeanim
trigger1 = anim!= 130
value = 130

[state 130, AI Fix]
type = ctrlset
trigger1 = ailevel && numenemy
value = enemy,time >= 70 || time >= 70

[state 130, High -> Low]
type = changestate
trigger1 = !ailevel && command = "holddown"
trigger2 = ailevel && enemy,movetype = A && enemy,statetype = C && random < (900 * (ailevel ** 2.0 / 64.0))
value = 131

[state 130, End State]
type = changestate
trigger1 = !ailevel && command != "holdback"
trigger2 = !inguarddist
trigger3 = ailevel && numenemy
trigger3 = enemy,hitdefattr = SCA,AT
value = 140

;=========================================================================
; Crouch Guard (guarding)
;=========================================================================
[Statedef 131]
type = C
physics = C

[state 131, Change Animation]
type = changeanim
trigger1 = anim != 131
value = 131

[state 131, AI Fix]
type = ctrlset
trigger1 = ailevel && numenemy
value = enemy,time >= 70 || time >= 70

[state 131, Low -> High]
type = changestate
trigger1 = !ailevel && command != "holddown"
trigger2 = ailevel && enemy,movetype = A && enemy,statetype != C && random < (450 * (ailevel ** 2.0 / 64.0))
value = 130

[state 131, End State]
type = changestate
trigger1 = !ailevel && command != "holdback"
trigger2 = !inguarddist
trigger3 = ailevel && numenemy
trigger3 = enemy,hitdefattr = SCA,AT
value = 140

;=========================================================================
; Air Guard (guarding)
;=========================================================================
[Statedef 132]
type = A
physics = N

[state 132, Change Animation]
type = changeanim
trigger1 = anim != 132
value = 132

[state 132, Increment Velocity]
type = veladd
trigger1 = 1
y = const(movement.yaccel)

[state 132, Detect Position]
type = varset
trigger1 = 1
sysvar(0) = (pos y >= 0 && vel y > 0)

[state 132, Set Velocity]
type = velset
trigger1 = sysvar(0)
y = 0.0

[state 132, Set Position]
type = posset
trigger1 = sysvar(0)
y = 0

[state 132, AI Fix]
type = ctrlset
trigger1 = ailevel && numenemy
value = enemy,time >= 70 || time >= 70

[state 132, End State]
type = changestate
triggerall = sysvar(0)
triggerall = inguarddist
trigger1 = !ailevel
trigger1 = command = "holdback"
trigger2 = ailevel
value = 130

[state 132, End State]
type = changestate
trigger1 = sysvar(0)
value = 52

[state 132, End State]
type = changestate
trigger1 = !ailevel
trigger1 = command != "holdback"
trigger2 = !inguarddist
trigger3 = ailevel && numenemy
trigger3 = enemy,hitdefattr = SCA,AT
value = 140

;=========================================================================
; Guard (end)
;=========================================================================
[Statedef 140]
type = U
physics = U
ctrl = 1

[state 140, Change Animation]
type = changeanim
trigger1 = !time
value = 140 + (statetype = C) + (statetype = A) * 2

[state 140, Set State Type]
type = statetypeset
trigger1 = !time && statetype = S
physics = S

[state 140, Set State Type]
type = statetypeset
trigger1 = !time && statetype = C
physics = C

[state 140, Set State Type]
type = statetypeset
trigger1 = !time && statetype = A
physics = A

[state 140, High -> Low]
type = statetypeset
trigger1 = !ailevel && statetype = S && command = "holddown"
trigger2 = ailevel && statetype = S && enemy,movetype = A && enemy,statetype = C && random < (900 * (ailevel ** 2.0 / 64.0))
statetype = C
physics = C

[state 140, Low -> High]
type = statetypeset
trigger1 = !ailevel && statetype = C && command != "holddown"
trigger2 = ailevel && statetype = C && enemy,movetype = A && enemy,statetype != C && random < (450 * (ailevel ** 2.0 / 64.0))
statetype = S
physics = S

[state 140, End State]
type = changestate
trigger1 = !animtime
value = 0 + (statetype = C) * 11 + (statetype = A) * 50

;=========================================================================
; Stand Guard Hit (shaking)
;=========================================================================
[Statedef 150]
type = S
movetype = H
physics = N
velset = 0, 0

[state 150, Change Animation]
type = changeanim
trigger1 = 1
value = 150

[state 150, End State]
type = changestate
trigger1 = hitshakeover
value = 151 + 2 * ((!ailevel && command = "holddown") || (ailevel && enemy,movetype = A && enemy,statetype = C))

[state 150, High -> Low]
type = statetypeset
trigger1 = !ailevel && statetype = S && command = "holddown"
trigger2 = ailevel && statetype = S && enemy,movetype = A && enemy,statetype = C && random < (900 * (ailevel ** 2.0 / 64.0))
statetype = C
physics = C

[state 150, Low -> High]
type = statetypeset
trigger1 = !ailevel && statetype = C && command != "holddown"
trigger2 = ailevel && statetype = C && enemy,movetype = A && enemy,statetype != C && random < (450 * (ailevel ** 2.0 / 64.0))
statetype = S
physics = S

[state 150, FFB]
type = forcefeedback
trigger1 = !time
waveform = square
time = 3

;=========================================================================
; Stand Guard Hit 2 (knocked back)
;=========================================================================
[Statedef 151]
type = S
movetype = H
physics = S

[state 151, Change Animation]
type = changeanim
trigger1 = !time
value = 150

[state 151, Set Hit Velocity]
type = hitvelset
trigger1 = !time
x = 1
[state 151, Set Velocity]
type = velset
trigger1 = time = gethitvar(slidetime)
trigger2 = hitover
x = 0.0

[state 151, Control]
type = ctrlset
trigger1 = time = gethitvar(ctrltime)
value = 1

[state 151, High -> Low]
type = statetypeset
trigger1 = !ailevel && statetype = S && command = "holddown"
trigger2 = ailevel && statetype = S && enemy,movetype = A && enemy,statetype = C && random < (900 * (ailevel ** 2.0 / 64.0))
statetype = C
physics = C

[state 151, Low -> High]
type = statetypeset
trigger1 = !ailevel && statetype = C && command != "holddown"
trigger2 = ailevel && statetype = C && enemy,movetype = A && enemy,statetype != C && random < ( 450 * (ailevel ** 2.0 / 64.0))
statetype = S
physics = S

[state 151, End State]
type = changestate
trigger1 = hitover
value = 130
ctrl = 1

;=========================================================================
; Crouch Guard Hit (shaking)
;=========================================================================
[Statedef 152]
type = C
movetype = H
physics = N
velset = 0, 0

[state 152, Change Animation]
type = changeanim
trigger1 = 1
value = 151

[state 152, End State]
type = changestate
trigger1 = hitshakeover
value = 151 + 2 * ((!ailevel && command = "holddown") || (ailevel && enemy,movetype = A && enemy,statetype = C))

[state 152, High -> Low]
type = statetypeset
trigger1 = !ailevel && statetype = S && command = "holddown"
trigger2 = ailevel && statetype = S && enemy,movetype = A && enemy,statetype = C && random < (900 * (ailevel ** 2.0 / 64.0))
statetype = C
physics = C

[state 152, Low -> High]
type = statetypeset
trigger1 = !ailevel && statetype = C && command != "holddown"
trigger2 = ailevel && statetype = C && enemy,movetype = A && enemy,statetype != C && random < (450 * (ailevel ** 2.0 / 64.0))
statetype = S
physics = S

[state 152, FFB]
type = forcefeedback
trigger1 = !time
waveform = square
time = 4

;=========================================================================
; Crouch Guard Hit 2 (knocked back)
;=========================================================================
[Statedef 153]
type = C
movetype = H
physics = C

[state 153, Change Animation]
type = changeanim
trigger1 = !time
value = 151

[state 153, Set Hit Velocity]
type = hitvelset
trigger1 = !time
x = 1
[state 153, Set Velocity]
type = velset
trigger1 = time = gethitvar(slidetime)
trigger2 = hitover
x = 0.0

[state 153, Control]
type = ctrlset
trigger1 = time = gethitvar(ctrltime)
value = 1

[state 153,High -> Low]
type = statetypeset
trigger1 = !ailevel && statetype = S && command = "holddown"
trigger2 = ailevel && statetype = S && enemy,movetype = A && enemy,statetype = C && random < (900 * (ailevel ** 2.0 / 64.0))
statetype = C
physics = C

[state 153,Low -> High]
type = statetypeset
trigger1 = !ailevel && statetype = C && command != "holddown"
trigger2 = ailevel && statetype = C && enemy,movetype = A && enemy,statetype != C && random < (450 * (ailevel ** 2.0 / 64.0))
statetype = S
physics = S

[state 153, End State]
type = changestate
trigger1 = hitover
value = 131
ctrl = 1

;=========================================================================
; Air Guard Hit (shaking)
;=========================================================================
[Statedef 154]
type = A
movetype = H
physics = N
velset = 0, 0

[state 154, Change Animation]
type = changeanim
trigger1 = 1
value = 152

[state 154, End State]
type = changestate
trigger1 = hitshakeover
value = 155

[state 154, FFB]
type = forcefeedback
trigger1 = !time
waveform = square
time = 4

;=========================================================================
; Air Guard Hit 2 (knocked away)
;=========================================================================
[Statedef 155]
type = A
movetype = H
physics = N

[state 155, Change Animation]
type = changeanim
trigger1 = !time
value = 152


[state 155, Set Hit Velocity]
type = hitvelset
trigger1 = !time
x = 1
y = 1
[state 155, Increment Velocity]
type = veladd
trigger1 = 1
y = const(movement.yaccel)

[state 155, Control]
type = ctrlset
trigger1 = time = gethitvar(ctrltime)
value = 1

[state 155, Detect Position]
type = varset
trigger1 = 1
sysvar(0) = (pos y >= 0 && vel y > 0)

[state 155, Set Velocity]
type = velset
trigger1 = sysvar(0)
y = 0.0

[state 155, Set Position]
type = posset
trigger1 = sysvar(0)
y = 0

[state 155, End State]
type = changestate
trigger1 = sysvar(0)
trigger1 = command = "holdback"
trigger1 = inguarddist
value = 130

[state 155, End State]
type = changestate
trigger1 = sysvar(0)
value = 52

;=========================================================================
; Lose Pose
;=========================================================================
[Statedef 170]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 1

[state 170, Set Position]
type = posset
trigger1 = !time
y = 0

[state 170, Change Animation]
type = changeanim
trigger1 = 1
value = 5300
elem = animelemno(0)


[state 170, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = 1

;=========================================================================
; Draw Game / time Over
;=========================================================================
[Statedef 175]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 1

[state 175, End State]
type = changestate
trigger1 = !time
value = 170

[state 175, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = 1

;=========================================================================
; Win Pose
;=========================================================================
[statedef 180]
type = S
movetype = I
physics = S
velset = 0, 0
sprpriority = 2

[state 180, Calculate Score Bonus]
type = null
triggerall = !time
trigger1 = var(19) := var(18) || 1
trigger1 = var(18) := var(18) + 100 * life + 100 * (100 - cond(fvar(7) > 99, 99, floor(fvar(7))))

[state 180, Set Position]
type = posset
trigger1 = !time
y = 0

[state 180, Change Animation]
type = changeanim
trigger1 = !time
value = 180 + (random < 500 && name = "Lan")

[state 180, Victory Quote]
type = victoryquote
trigger1 = 0
value = 0

[state 180, Special Effect]
type = assertspecial
trigger1 = time < 240
flag = roundnotover

[state 180, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = 1

; Sarkov
[state 180, Voice]
type = playsnd
trigger1 = name = "Sarkov"
trigger1 = !animelemtime(animelemno(0)) && animelemno(0) % 2 = 0
value = f1, 0
volumescale = 100
channel = 0

; Onimaru
[state 180, Voice]
type = playsnd
trigger1 = name = "Onimaru"
trigger1 = !animelemtime(animelemno(0)) && animelemno(0) % 2 = 1
value = f5, 1
volumescale = 100
channel = 0

; Red Man
[state 180, Voice]
type = playsnd
trigger1 = name = "Red Man"
trigger1 = !animelemtime(1)
value = f10, 1
volumescale = 100
channel = 0

;=========================================================================
; Introduction
;=========================================================================
[Statedef 190]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 1

[state 190, Change Animation]
type = changeanim
trigger1 = !time
value = 0

[state 190, Special Effect]
type = assertspecial
trigger1 = 1
flag = intro

[state 190, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = 1

[state 190, End State]
type = changestate
trigger1 = !time
value = 0

;=========================================================================
; S. Gethit Shaking
;=========================================================================
[Statedef 5000]
type = S
movetype = H
physics = N
velset = 0, 0

; Widow
[state 5000, Change Animation]
type = null ; changeanim
trigger1 = name = "Widow"
trigger1 = life <= 0 && !alive
trigger1 = (prevstateno = [10, 11]) || (prevstateno = [400, 430])
value = 5020
ignorehitpause = 1

; Widow
[state 5000, End State]
type = null ; changestate
trigger1 = name = "Widow" && prevstateno = [10, 11]
trigger1 = life <= 0 && !alive
value = 5955
ignorehitpause = 1

[state 5000, Change Animation]
type = changeanim
trigger1 = !time
trigger1 = gethitvar(animtype) != [3, 5]
value = ifelse((gethitvar(groundtype) = 1), 5000, 5010) + gethitvar(animtype)

[state 5000, Change Animation]
type = changeanim
trigger1 = time <= 1
trigger1 = gethitvar(animtype) = [3, 5]
value = 5030 + 20 * hitfall

[state 5000, Change Animation]
type = changeanim
trigger1 = time <= 1 && (life <= 0 || !alive)
trigger1 = selfanimexist(5051)
value = 5051

[state 5000, Change Animation]
type = changeanim
trigger1 = time <= 1 && gethitvar(chainid) = 10
trigger1 = selfanimexist(5900)
value = 5900

[state 5000, Change Animation]
type = changeanim
trigger1 = time > 0
value = anim

[state 5000, Set State Type]
type = statetypeset
trigger1 = !time
trigger1 = gethitvar(yvel) || gethitvar(fall)
trigger2 = pos y != 0
statetype = A

[state 5000, FFB Light]
type = forcefeedback
trigger1 = anim = 5000
trigger2 = anim = 5010
time = 6
waveform = square
persistent = 0

[state 5000, FFB Medium]
type = forcefeedback
trigger1 = anim = 5001
trigger2 = anim = 5011
time = 8
waveform = sinesquare
ampl = 110, -1, -0.3
persistent = 0

[state 5000, FFB Hard]
type = forcefeedback
trigger1 = anim = 5012
trigger2 = anim = 5002
trigger3 = anim = 5030
time = 15
waveform = sinesquare
ampl = 140
persistent = 0

[state 5000, End State]
type = null ; changestate
trigger1 = !time && fvar(3) >= 40.0
value = 5035

[state 5000, End State]
type = changestate
trigger1 = hitshakeover
trigger1 = !gethitvar(yvel) && !gethitvar(fall)
value = 5001

[state 5000, End State]
type = changestate
trigger1 = hitshakeover
value = 5030

;=========================================================================
; S. Gethit Sliding
;=========================================================================
[Statedef 5001]
type = S
movetype = H
physics = S

[state 5001, Set Hit Velocity]
type = hitvelset
trigger1 = !time
x = 1

[state 5001, Change Animation]
type = changeanim
trigger1 = !animtime
value = 5005 + gethitvar(animtype) + (gethitvar(groundtype) = 2) * 10

[state 5001, Multiply Velocity]
type = velmul
trigger1 = time >= gethitvar(slidetime)
x = 0.6

[state 5001, Set Velocity]
type = velset
trigger1 = hitover
x = 0.0

[state 5001, Set Defense]
type = defencemulset
trigger1 = hitover
value = 1

[state 5001, End State]
type = changestate
trigger1 = hitover
value = 0
ctrl = 1

;=========================================================================
; C. Gethit Shaking
;=========================================================================
[Statedef 5010]
type = C
movetype = H
physics = N
velset = 0, 0

[state 5010, Change Animation]
type = changeanim
trigger1 = time <= 1
trigger1 = gethitvar(animtype) != [3, 5]
value = 5020 + gethitvar(animtype)

[state 5010, Change Animation]
type = changeanim
trigger1 = time <= 1
trigger1 = gethitvar(animtype) = [3, 5]
value = 5030 + 20 * hitfall

[state 5010, Change Animation]
type = changeanim
trigger1 = time <= 1 && (life <= 0 || !alive)
trigger1 = selfanimexist(5051)
value = 5051

[state 5010, Change Animation]
type = changeanim
trigger1 = time <= 1 && gethitvar(chainid) = 10
trigger1 = selfanimexist(5900)
value = 5900

[state 5010, Change Animation]
type = changeanim
trigger1 = time > 0
value = anim

[state 5010, Set State Type]
type = statetypeset
triggerall = !time
trigger1 = gethitvar(yvel) || gethitvar(fall)
trigger2 = pos y != 0
statetype = A

[state 5010, End State]
type = null ; changestate
trigger1 = !time && fvar(3) >= 40.0
value = 5035

[state 5010, End State]
type = changestate
trigger1 = hitshakeover
trigger1 = !gethitvar(yvel) && !gethitvar(fall)
value = 5011

[state 5010, End State]
type = changestate
trigger1 = hitshakeover
value = 5030

[state 5010, FFB Light]
type = forcefeedback
trigger1 = anim = 5020
time = 6
waveform = square
persistent = 0

[state 5010, FFB Medium]
type = forcefeedback
trigger1 = anim = 5021
time = 8
waveform = sinesquare
ampl = 110, -1, -0.3
persistent = 0

[state 5010, FFB Hard]
type = forcefeedback
trigger1 = anim = 5022
time = 15
waveform = sinesquare
ampl = 140
persistent = 0

;=========================================================================
; C. Gethit Sliding
;=========================================================================
[Statedef 5011]
type = C
movetype = H
physics = C

[state 5011, Set Hit Velocity]
type = hitvelset
trigger1 = !time
x = 1

[state 5011, Change Animation]
type = changeanim
trigger1 = !animtime
value = 5025 + gethitvar(animtype)

[state 5011, Multiply Velocity]
type = velmul
trigger1 = time >= gethitvar(slidetime)
x = 0.6

[state 5011, Set Velocity]
type = velset
trigger1 = hitover
x = 0.0

[state 5011, Set Defense]
type = defencemulset
trigger1 = hitover
value = 1

[state 5011, End State]
type = changestate
trigger1 = hitover
value = 11
ctrl = 1

;=========================================================================
; A. Gethit Shaking
;=========================================================================
[Statedef 5020]
type = A
movetype = H
physics = N
velset = 0, 0

[state 5020, Change Animation]
type = changeanim
trigger1 = time <= 1
trigger1 = gethitvar(animtype) != [3, 5]
value = ifelse((gethitvar(airtype) = 1), 5000, 5010) + gethitvar(animtype)

[state 5020, Change Animation]
type = changeanim
trigger1 = time <= 1
trigger1 = gethitvar(animtype) = [3, 5]
value = 5030 + 20 * hitfall

[state 5020, Change Animation]
type = changeanim
trigger1 = time <= 1 && (life <= 0 || !alive)
trigger1 = selfanimexist(5051)
value = 5051

[state 5020, Change Animation]
type = changeanim
trigger1 = time <= 1 && gethitvar(chainid) = 10
trigger1 = selfanimexist(5900)
value = 5900

[state 5020, Change Animation]
type = changeanim
trigger1 = time > 1
value = anim

[state 5020, End State]
type = null ; changestate
trigger1 = !time && fvar(3) >= 40.0
value = 5035

[state 5020, End State]
type = changestate
trigger1 = hitshakeover
value = 5030

[state 5020, FFB Light]
type = forcefeedback
trigger1 = anim = 5000
trigger2 = anim = 5010
time = 6
waveform = square
persistent = 0

[state 5020, FFB Medium]
type = forcefeedback
trigger1 = anim = 5001
trigger2 = anim = 5011
time = 8
waveform = sinesquare
ampl = 110, -1, -0.3
persistent = 0

[state 5020, FFB Hard]
type = forcefeedback
trigger1 = anim = 5012
trigger2 = anim = 5002
trigger3 = anim = 5030
trigger4 = anim = [5051,5059]
time = 15
waveform = sinesquare
ampl = 140
persistent = 0

;=========================================================================
; A. Gethit Flying
;=========================================================================
[Statedef 5030]
type = A
movetype = H
physics = N
ctrl = 0

[state 5030, Change Animation]
type = changeanim
trigger1 = anim != [5000, 5199]
trigger1 = selfanimexist(5030 + 20 * hitfall)
value = 5030 + 20 * hitfall

[state 5030, Change Animation]
type = changeanim
trigger1 = life <= 0 || !alive
trigger1 = anim != 5051 && selfanimexist(5051) 
value = 5051

[state 5030, Change Animation]
type = changeanim
trigger1 = gethitvar(chainid) = 10
trigger1 = anim != 5900 && selfanimexist(5900)
value = 5900

[state 5030, Increment Velocity]
type = veladd
trigger1 = 1
y = gethitvar(yaccel)

[state 5030, Set Hit Fall]
type = hitfallset
trigger1 = !alive
value = 1

[state 5030, Set Hit Velocity]
type = hitvelset
trigger1 = !time
x = 1
y = 1

[state 5030, End State]
type = changestate
triggerall = hitfall && (life <= 0 || !alive)
triggerall = selfanimexist(5051)
trigger1 = hitover || !animtime
trigger2 = vel y > 0
value = 5051

[state 5030, End State]
type = changestate
triggerall = !hitfall
; trigger1 = name != "Phoenix"
trigger1 = hitover || !animtime
trigger2 = vel y > 0
value = 5040

[state 5030, End State]
type = changestate
triggerall = hitfall
trigger1 = hitover
trigger2 = vel y > 0
value = 5050

;=========================================================================
; A. Gethit Dizzied
;=========================================================================
[Statedef 5035]
type = A
movetype = H
physics = N

[state 5035, Dizzy Points: Endurance Detection]
type = varset
trigger1 = !time
var(10) = 1

[state 5035, Change Animation]
type = changeanim
trigger1 = !time && anim < 5030
value = 5050 + (selfanimexist(5051) && !alive)

[state 5035, Change Animation]
type = changeanim
trigger1 = !hitshakeover
value = anim
ignorehitpause = 1

[state 5035, Set Hit Fall]
type = hitfallset
trigger1 = !time
value = 1

[state 5035, Turn]
type = turn
trigger1 = !time
trigger1 = p2dist x < 0

[state 5035, Set Velocity]
type = velset
trigger1 = hitshakeover
x = -2.34375
y = -7.8125
persistent = 0

[state 5035, Increment Velocity]
type = veladd
trigger1 = hitshakeover
y = gethitvar(yaccel)

[state 5035, End State]
type = changestate
trigger1 = gethitvar(groundtype) != 3
trigger1 = hitover || vel y > 0
trigger1 = selfanimexist(5051) && (life <= 0 || !alive)
value = 5051

[state 5035, End State]
type = changestate
trigger1 = gethitvar(groundtype) != 3
trigger1 = hitover || vel y > 0
value = 5050

[state 5035, End State]
type = changestate
trigger1 = hitshakeover
trigger1 = vel y > 0
trigger1 = pos y >= Const(movement.air.gethit.trip.groundlevel)
value = 5110

;=========================================================================
; A. Gethit Recovering
;=========================================================================
[Statedef 5040]
type = A
movetype = H
physics = N

[state 5040, End State]
type = changestate
trigger1 = !alive
value = 5050
ctrl = 0

[state 5040, Recover Direction]
type = varset
trigger1 = !time
sysvar(1) = -1 * (vel x < 0) + 0 * (vel x = 0) + 1 * (vel x > 0)

[state 5040, Change Animation]
type = changeanim
trigger1 = !time
value = 5040

[state 5040, Set State Type]
type = statetypeset
trigger1 = hitover
movetype = I

[state 5040, Increment Velocity]
type = veladd
trigger1 = 1
y = gethitvar(yaccel)

[state 5040, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 52

;=========================================================================
; A. Gethit Falling
;=========================================================================
[Statedef 5050]
type = A
movetype = H
physics = N

[state 5050, End State]
type = changestate
trigger1 = life <= 0 || !alive
trigger1 = selfanimexist(5051)
trigger1 = !time
value = 5051

[state 5050, Change Animation]
type = changeanim
trigger1 = !time && anim != 5050 && anim != 5900
value = 5050

[state 5050, Change Animation]
type = changeanim
trigger1 = anim != 5090 && anim != 5900
trigger1 = vel y > 0
value = 5060
persistent = 0

[state 5050, Increment Velocity]
type = veladd
trigger1 = 1
y = gethitvar(yaccel)

[state 5050, End State]
type = changestate
trigger1 = vel y > 0
trigger1 = pos y >= const(movement.air.gethit.groundlevel)
value = 5100

;=========================================================================
; A. Gethit Falling KO
;=========================================================================
[Statedef 5051]
type = A
movetype = H
physics = N

[state 5051, Change Animation]
type = changeanim
trigger1 = !time && anim != 5051
value = 5051

[state 5051, Change Animation]
type = changeanim
trigger1 = vel y > 0
value = 5061
persistent = 0

[state 5051, Increment Velocity]
type = veladd
trigger1 = 1
y = gethitvar(yaccel)

[state 5051, End State]
type = changestate
trigger1 = vel y > 0
trigger1 = pos y >= const(movement.air.gethit.groundlevel)
value = 5100

;=========================================================================
; T. Gethit Shaking
;=========================================================================
[Statedef 5070]
type = A
movetype = H
physics = N
velset = 0, 0

[state 5070, Change Animation]
type = changeanim
trigger1 = 1
value = 5070 + (selfanimexist(5071) && !alive)

[state 5070, End State]
type = null ; changestate
trigger1 = !time && fvar(3) >= 40.0
value = 5035

[state 5070, End State]
type = changestate
trigger1 = hitshakeover
value = 5071

[state 5070, FFB]
type = forcefeedback
trigger1 = !time
time = 12
waveform = sinesquare
ampl = 140

;=========================================================================
; T. Gethit Flying
;=========================================================================
[Statedef 5071]
type = A
movetype = H
physics = N

[state 5071, Set Hit Velocity]
type = hitvelset
trigger1 = !time
x = 1
y = 1

[state 5071, Increment Velocity]
type = veladd
trigger1 = 1
y = gethitvar(yaccel)

[state 5071, End State]
type = changestate
trigger1 = pos y + vel y > 0
; trigger1 = vel y > 0
; trigger1 = pos y >= Const(movement.air.gethit.trip.groundlevel)
value = 5110 - 10 * (anim = 5071 && !alive)

;=========================================================================
; L. Gethit Shaking
;=========================================================================
[Statedef 5080]
type = L
movetype = H
physics = N
velset = 0, 0

[state 5080, Detect Animation Type]
type = varset
trigger1 = !time
sysvar(2) = ifelse (!gethitvar(yvel), 5080, 5090)

[state 5080, Detect Animation Type]
type = varadd
trigger1 = !time
trigger1 = (anim = [5081, 5089]) || (anim = [5111, 5119])
trigger1 = selfanimexist(sysvar(2) + (anim % 10))
sysvar(2) = anim % 10

[state 5080, Detect Animation Type]
type = varset
trigger1 = !time
trigger1 = sysvar(2) = 5090
trigger1 = !selfanimexist(5090)
sysvar(2) = 5030

[state 5080, Change Animation]
type = changeanim
trigger1 = 1
value = sysvar(2)

[state 5080, End State]
type = null ; changestate
trigger1 = !time && fvar(3) >= 40.0
value = 5035

[state 5080, End State]
type = changestate
trigger1 = hitshakeover
trigger1 = !gethitvar(yvel)
value = 5081

[state 5080, End State]
type = changestate
trigger1 = hitshakeover
trigger1 = gethitvar(yvel)
value = 5030

;=========================================================================
; L. Gethit Sliding
;=========================================================================
[Statedef 5081]
type = L
movetype = H
physics = C

[state 5081, Set Hit Velocity]
type = hitvelset
trigger1 = !time
x = 1

[state 5081, Set Velocity]
type = velset
trigger1 = hitover
x = 0.0

[state 5081, Dtect Animation Type]
type = varset
trigger1 = !time
sysvar(0) = 1

[state 5081, End State]
type = changestate
trigger1 = hitover
value = 5110

;=========================================================================
; Hit Ground
;=========================================================================
[Statedef 5100]
type = L
movetype = H
physics = N

[state 5100, Shake]
type = fallenvshake
trigger1 = !time

[state 5100, Y Velocity]
type = varset
trigger1 = !time
sysvar(1) = floor(vel y)

[state 5100, Change Animation]
type = changeanim
trigger1 = !time
value = 5100 + ((anim = 5061 || anim = 5071) && !alive)

[state 5100, Set Position]
type = posset
trigger1 = !time
y = 0

[state 5100, Set Velocity]
type = velset
trigger1 = !time
y = 0.0

[state 5100, Multiply Velocity]
type = velmul
trigger1 = !time
x = 0.75

[state 5100, End State]
type = changestate
trigger1 = !time
trigger1 = !gethitvar(fall.yvel)
value = 5110

[state 5100, Hit Fall Damage]
type = hitfalldamage
trigger1 = time = 3

[state 5100, Sound]
type = playsnd
trigger1 = !time
value = f5100, 0

[state 5100, Freeze Position]
type = posfreeze
trigger1 = 1

[state 5100, End State]
type = changestate
trigger1 = !animtime
value = 5101

[state 5100, FFB]
type = forcefeedback
trigger1 = !time
waveform = sinesquare
ampl = 128, -3, -0.2, 0.005
time = 20

;=========================================================================
; Bounce from Ground
;=========================================================================
[Statedef 5101]
type = L
movetype = H
physics = N

[state 5101, Change Animation]
type = changeanim
trigger1 = !time
value = 5160 + (anim = 5101)

[state 5101, Change Animation]
type = changeanim
trigger1 = vel y > 0
value = 5165 + (anim = 5161)
persistent = 0

[state 5101, Hit Fall Velocity]
type = hitfallvel
trigger1 = !time

[state 5101, Set Position]
type = posset
trigger1 = !time
y = const(movement.down.bounce.offset.y)

[state 5101, Increment Position]
type = posadd
trigger1 = !time
x = const(movement.down.bounce.offset.x)

[state 5101, Increment Velocity]
type = veladd
trigger1 = 1
y = const(movement.down.bounce.yaccel)

[state 5101, End State]
type = changestate
trigger1 = vel y > 0
trigger1 = pos y >= Const(movement.down.bounce.groundlevel)
value = 5110

;=========================================================================
; L. Gethit Static
;=========================================================================
[Statedef 5110]
type = L
movetype = H
physics = N

[state 5110, Shake]
type = fallenvshake
trigger1 = !time

[state 5110, Change Animation]
type = changeanim
trigger1 = !time && anim != 5110
value = 5170 + (anim = 5166 && !alive)

[state 5110, Hit Fall Damage]
type = hitfalldamage
trigger1 = !time

[state 5110, Set Position]
type = posset
trigger1 = !time
y = 0

[state 5110, Y Velocity]
type = varset
trigger1 = !time
trigger1 = gethitvar(fall.yvel)
sysvar(1) = floor(vel y)

[state 5110, Sound]
type = playsnd
trigger1 = !time
value = f5100, 0

[state 5110, Set Velocity]
type = velset
trigger1 = !time
y = 0.0

[state 5110, End State]
type = changestate
trigger1 = alive && var(10)
value = 5295

[state 5110, Change Animation]
type = changeanim
trigger1 = !animtime
trigger2 = sysvar(0)
value = 5110 + (anim = 5171 && !alive)
persistent = 0

[state 5110, End State]
type = changestate
triggerall = !alive
trigger1 = !animtime
trigger2 = sysvar(0)
trigger3 = anim = [5110, 5119]
value = 5150

[state 5110, Reset Sysvar]
type = varset
trigger1 = sysvar(0)
trigger1 = !time
sysvar(0) = 0

[state 5110, Multiply Velocity]
type = velmul
trigger1 = 1
x = 0.85

[state 5110, Set Velocity]
type = velset
trigger1 = abs(vel x) < const(movement.down.friction.threshold)
x = 0.0
persistent = 0

[state 5110, FFB]
type = forcefeedback
trigger1 = alive
trigger1 = !time
time = 8
ampl = 240
waveform = sine

[state 5110, FFB]
type = forcefeedback
trigger1 = !alive
trigger1 = !time
ampl = 200, 7, -0.467
time = 30
waveform = sine

;=========================================================================
; Get Up
;=========================================================================
[Statedef 5120]
type = L
movetype = I
physics = N
ctrl = 0
velset = 0, 0

[state 5120, Change Animation]
type = changeanim
trigger1 = !time
value = 5120

[state 5120, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = 1

[state 5120, Set Hit Fall]
type = hitfallset
trigger1 = !animtime
value = 1

[state 5120, Invulnerability]
type = nothitby
trigger1 = !animtime
value = ,NT,ST,HT
time = 12

[state 5120, Invulnerability]
type = nothitby
trigger1 = !animtime
value2 = SCA
time = 3

[state 5120, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Lie Dead
;=========================================================================
[Statedef 5150]
type = L
movetype = H
physics = N
sprpriority = -3

[state 5150, Change Animation]
type = changeanim
trigger1 = !time && anim != [5110, 5111]
trigger1 = anim != 5950
value = 5110 + (anim = 5171)

[state 5150, Multiply Velocity]
type = velmul
trigger1 = 1
x = 0.85

[state 5150, Set Velocity]
type = velset
trigger1 = abs(vel x) < const(movement.down.friction.threshold)
x = 0.0
persistent = 0

[state 5150, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = 1

; Disallow helpers to survive in this state
[state 5150, Transparency]
type = trans
trigger1 = ishelper
trans = addalpha
alpha = 256 - 16 * time, 16 * time

[state 5150, Destroy Helper]
type = destroyself
trigger1 = ishelper
trigger1 = time > 16

;=========================================================================
; Ground Recovery
;=========================================================================
[Statedef 5200]
type = A
movetype = H
physics = N

[state 5200, Set Position]
type = posset
trigger1 = pos y > 0
y = 0

[state 5200, Change Animation]
type = changeanim
trigger1 = anim = 5035
trigger1 = !animtime
value = 5050

[state 5200, Increment Velocity]
type = veladd
trigger1 = 1
y = gethitvar(yaccel)

[state 5200, Own State]
type = selfstate
trigger1 = vel y > 0
trigger1 = pos y >= -5
value = 5201

;=========================================================================
; Ground Recovery
;=========================================================================
[Statedef 5201]
type = S
movetype = I
physics = N
ctrl = 0

[state 5201, Set Position]
type = posset
trigger1 = !time
y = 0

[state 5201, Change Animation]
type = changeanim
trigger1 = !time
value = 5200

[state 5201, Palette Effect]
type = palfx
trigger1 = !time
time = 3
add = 128, 128, 128

[state 5201, Turn]
type = turn
trigger1 = !time
trigger1 = p2dist x < const720p(-20)

[state 5201, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = 1

[state 5201, Set Velocity]
type = velset
trigger1 = !time
x = 0.0
y = 0.0

[state 5201, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Air Recovery
;=========================================================================
[Statedef 5210]
type = A
movetype = I
physics = N
ctrl = 0

[state 5210, Change Animation]
type = changeanim
trigger1 = !time
value = 5210

[state 5210, Palette Effect]
type = palfx
trigger1 = !time
time = 3
add = 128, 128, 128

[state 5210, Turn]
type = turn
trigger1 = !time
trigger1 = p2dist x < const720p(-80)

[state 5210, Invulnerability]
type = nothitby
trigger1 = !time
value = SCA
time = 20

[state 5210, Set Velocity]
type = velset
trigger1 = time <= 1
x = (4.296875 * command = "holdfwd") - (4.296875 * command = "holdback")
y = -8.7890625 + (4.39453125 * command = "holddown")

[state 5210, Increment Velocity]
type = veladd
trigger1 = 1
y = 0.5859375

[state 5210, Control]
type = ctrlset
trigger1 = time = 21
value = 1

[State 5210, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 52
ctrl = 1

;=========================================================================
; Wall Gethit Shaking
;=========================================================================
[statedef 5230]
type = A
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 5230, Destroy Explod]
type = removeexplod
trigger1 = ishelper

[state 5230, Destroy Helper]
type = destroyself
trigger1 = ishelper

[state 5230, Change Animation]
type = changeanim
trigger1 = !time
trigger1 = gethitvar(animtype) != [3, 5]
value = cond((gethitvar(groundtype) = 1), 5000, 5010) + gethitvar(animtype)

[state 5230, Change Animation]
type = changeanim
trigger1 = !time
trigger1 = gethitvar(animtype) = [3, 5]
value = 5030

[state 5230, Change Animation]
type = changeanim
trigger1 = !time
trigger1 = (gethitvar(animtype) = [4, 5]) && selfanimexist(5047 + gethitvar(animtype))
value = 5047 + gethitvar(animtype)

[state 5230, Change Animation]
type = changeanim
trigger1 = !hitshakeover
value = anim

[state 5230, Change Animation]
type = changeanim
trigger1 = hitshakeover
value = 5230
persistent = 0

[state 5230, Set Hit Fall]
type = hitfallset
trigger1 = !time
value = 1

[state 5230, Bound]
type = screenbound
trigger1 = 1
value = 0
movecamera = 1, 1

[state 5230, Solidity]
type = playerpush
trigger1 = 1
value = 0

[state 5230, Set Velocity]
type = velset
trigger1 = hitshakeover
x = gethitvar(xvel) * facing
y = gethitvar(yvel)
persistent = 0

[state 5230, Set Velocity]
type = velset
trigger1 = hitshakeover
y = 0.0
persistent = 0

[state 5230, End State]
type = changestate
trigger1 = hitshakeover
trigger1 = cond(vel x > 0, frontedgebodydist <= 0, backedgebodydist <= 0)
value = 5231
ctrl = 0

[state 5230, Own State]
type = selfstate
trigger1 = hitshakeover
trigger1 = pos y + vel y > 0
value = 5100

[state 5230, Own State]
type = selfstate
trigger1 = hitshakeover
trigger1 = !gethitvar(isbound)
trigger1 = time > 100
value = 5050

;=========================================================================
; Wall Gethit Impact
;=========================================================================
[statedef 5231]
type = A
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 5231, Change Animation]
type = changeanim
trigger1 = !time
value = 5231

[state 5231, Bound]
type = screenbound
trigger1 = 1
value = 0
movecamera = 1, 1

[state 5231, Solidity]
type = playerpush
trigger1 = 1
value = 0

[state 5231, Turn]
type = turn
trigger1 = backedgedist < frontedgedist
trigger1 = !animtime

[state 5231, Sound]
type = playsnd
trigger1 = !time
value = f5100, 0
volumescale = 100

[state 5231, Shake]
type = envshake
trigger1 = !time
time = 8
ampl = 4

[state 5231, Set Velocity]
type = velset
trigger1 = !animtime
x = -2.1484375 ; -0.9765625
y = -6.4453125 ; -8.59375

[state 5231, Effect]
type = null ; explod
trigger1 = backedgedist < frontedgedist
trigger1 = !time
anim = f72
postype = back
pos = 0, ceil(screenpos y + const(size.mid.pos.y))
facing = 1
bindtime = 2
random = 0, 0
velocity = 0.0, 0.0
accel = 0.0, 0.0
ownpal = 1
scale = 1.0, 1.0
sprpriority = 5
supermovetime = -1
pausemovetime = -1

[state 5231, Effect]
type = null ; explod
trigger1 = frontedgedist < backedgedist
trigger1 = !time
anim = f72
postype = front
pos = 0, ceil(screenpos y + const(size.mid.pos.y))
facing = -facing
bindtime = 2
random = 0, 0
velocity = 0.0, 0.0
accel = 0.0, 0.0
ownpal = 1
scale = 1.0, 1.0
sprpriority = 5
supermovetime = -1
pausemovetime = -1

[state 5231, End State]
type = changestate
trigger1 = !animtime
value = 5232
ctrl = 0

[state 5231, Own State]
type = selfstate
trigger1 = !gethitvar(isbound)
trigger1 = time > 100
value = 5050

;=========================================================================
; Wall Gethit Fall
;=========================================================================
[Statedef 5232]
type = A
movetype = H
physics = N
ctrl = 0
sprpriority = -1

[state 5232, Change Animation]
type = changeanim
trigger1 = !time
value = 5050

[state 5232, Change Animation]
type = changeanim
trigger1 = vel y > 0
value = 5060
persistent = 0

[state 5232, Bound]
type = screenbound
trigger1 = 1
value = 1
movecamera = 1, 1

[state 5232, Increment Velocity]
type = veladd
trigger1 = 1
y = gethitvar(yaccel)

[state 5232, Own State]
type = selfstate
trigger1 = pos y + vel y > 0
value = 5100

[state 5232, Own State]
type = selfstate
trigger1 = !gethitvar(isbound)
trigger1 = time > 300
value = 5050

;=========================================================================
; Dizzy Get Up
;=========================================================================
[Statedef 5295]
type = L
movetype = H
physics = N
ctrl = 0
velset = 0, 0

[state 5295, Change Animation]
type = changeanim
trigger1 = !animtime && anim != [5110, 5120]
value = 5110

[state 5295, Change Animation]
type = changeanim
trigger1 = anim = 5110 && animelemtime(1) > 32
value = 5120
persistent = 0

[state 5295, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = 1

[state 5295, Dizzy Points]
type = varset
trigger1 = anim = 5120 && !animtime
fvar(3) = 0.0 + (var(10) := 0)

[state 5295, End State]
type = changestate
trigger1 = anim = 5120 && !animtime
value = 5300
ctrl = 0

;=========================================================================
; Dizzy State
;=========================================================================
[Statedef 5300]
type = S
movetype = H
physics = S
ctrl = 0
velset = 0, 0

[state 5300, Stop Sound]
type = stopsnd
trigger1 = !alive || roundstate != 2
channel = 3

[state 5300, Destroy Explod]
type = removeexplod
trigger1 = !alive || roundstate != 2
ID = 5300

[state 5300, End State]
type = changestate
trigger1 = !alive
value = 5050

[state 5300, End State]
type = changestate
trigger1 = roundstate != 2
value = 0
ctrl = 1

[state 5300, Change Animaton]
type = changeanim
trigger1 = !time
value = 5300

[state 5300, Set Hit Fall]
type = hitfallset
trigger1 = !time
value = 0

[state 5300, Sound]
type = null ; playsnd
trigger1 = time % 28 = 0
value = f5300, 0
volumescale = 100
channel = 3

[state 5300, Stars]
type = explod
trigger1 = !numexplod(5300)
ID = 5300
anim = f5300
postype = p1
facing = 1
bindtime = -1
removetime = -1
removeongethit = 1
ownpal = 1
scale = 1.0, 1.0
sprpriority = 5

; Jaan
[state 5300, Modify Stars]
type = modifyexplod
trigger1 = name = "Jaan"
trigger1 = numexplod(5300)
postype = p1
pos = cond(animelemno(0) % 2 = 1, 8, 16), cond(animelemno(0) % 2 = 1, -88, -84)
ID = 5300

; Sarkov
[state 5300, Modify Stars]
type = modifyexplod
trigger1 = name = "Sarkov"
trigger1 = numexplod(5300)
postype = p1
pos = cond(animelemno(0) % 2 = 1, -12, 8), cond(animelemno(0) % 2 = 1, -104, -100)
ID = 5300

; Bullet
[state 5300, Modify Stars]
type = modifyexplod
trigger1 = name = "Bullet"
trigger1 = numexplod(5300)
postype = p1
pos = cond(animelemno(0) % 2 = 1, 8, 16), cond(animelemno(0) % 2 = 1, -88, -84)
ID = 5300

; Phoenix
[state 5300, Modify Stars]
type = modifyexplod
trigger1 = name = "Phoenix"
trigger1 = numexplod(5300)
postype = p1
pos = cond(animelemno(0) % 2 = 1, 0, -12), cond(animelemno(0) % 2 = 1, -80, -80)
ID = 5300

; Frank
[state 5300, Modify Stars]
type = modifyexplod
trigger1 = name = "Frank"
trigger1 = numexplod(5300)
postype = p1
pos = cond(animelemno(0) % 2 = 1, -8, 4), cond(animelemno(0) % 2 = 1, -96, -96)
ID = 5300

; Onimaru
[state 5300, Modify Stars]
type = modifyexplod
trigger1 = name = "Onimaru"
trigger1 = numexplod(5300)
postype = p1
pos = cond(animelemno(0) % 2 = 1, 0, -4), cond(animelemno(0) % 2 = 1, -64, -64)
ID = 5300

; Lan
[state 5300, Modify Stars]
type = modifyexplod
trigger1 = name = "Lan"
trigger1 = numexplod(5300)
postype = p1
pos = cond(animelemno(0) % 2 = 1, 0, -12), cond(animelemno(0) % 2 = 1, -84, -92)
ID = 5300

; Kim Tai Chi
[state 5300, Modify Stars]
type = modifyexplod
trigger1 = name = "Kim Tai Chi"
trigger1 = numexplod(5300)
postype = p1
pos = cond(animelemno(0) % 2 = 1, 4, -18), cond(animelemno(0) % 2 = 1, -84, -96)
ID = 5300

; Widow
[state 5300, Modify Stars]
type = modifyexplod
trigger1 = name = "Widow"
trigger1 = numexplod(5300)
postype = p1
pos = cond(animelemno(0) % 2 = 1, 0, -8), cond(animelemno(0) % 2 = 1, -56, -56)
ID = 5300

; Joker
[state 5300, Modify Stars]
type = modifyexplod
trigger1 = name = "Joker"
trigger1 = numexplod(5300)
postype = p1
pos = cond(animelemno(0) % 2 = 1, 0, 12), cond(animelemno(0) % 2 = 1, -80, -76)
ID = 5300

; Red Man
[state 5300, Modify Stars]
type = modifyexplod
trigger1 = name = "Red Man"
trigger1 = numexplod(5300)
postype = p1
pos = cond(animelemno(0) % 2 = 1, 16, 4), cond(animelemno(0) % 2 = 1, -80, -84)
ID = 5300

[state 5300, Stop Sound]
type = stopsnd
trigger1 = !animtime
channel = 3

[state 5300, Destroy Explod]
type = removeexplod
trigger1 = !animtime
ID = 5300

[state 5300, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Continue screen animation
;=========================================================================
[Statedef 5500]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0

[state 5500, Change Animaton]
type = changeanim
trigger1 = !time
value = 5300 + 200 * selfanimexist(5500)

;=========================================================================
; Initiate System
;=========================================================================
[Statedef 5900]
type = S

[state 5900, Reset Variables at Beginning of Every Round?]
type = null
triggerall = 1
; Integers
trigger1 = var(00) := 0000000 || var(01) := 0000000 || var(02) := 0000000 || var(03) := 0000000 || var(04) := 0000000 || var(05) := 0000000 || 1
trigger1 = var(06) := 0000000 || var(07) := 0000000 || var(08) := 0000000 || var(09) := 0000000 || var(10) := 0000000 || var(11) := var(11) || 1
trigger1 = var(12) := 0000000 || var(13) := 0000000 || var(14) := 0000000 || var(15) := 0000000 || var(16) := 0000000 || var(17) := 0000000 || 1
trigger1 = var(18) := var(18) || var(19) := var(19) || var(20) := 0000000 || var(21) := 0000000 || var(22) := 0000000 || var(23) := 0000000 || 1
trigger1 = var(24) := 0000000 || var(25) := 0000000 || var(26) := 0000000 || var(27) := 0000000 || var(28) := 0000000 || var(29) := 0000000 || 1
trigger1 = var(30) := 0000000 || var(31) := 0000000 || var(32) := 0000000 || var(33) := 0000000 || var(34) := 0000000 || var(35) := 0000000 || 1
trigger1 = var(36) := 0000000 || var(37) := 0000000 || var(38) := 0000000 || var(39) := 0000000 || var(40) := 0000000 || var(41) := 0000000 || 1
trigger1 = var(42) := 0000000 || var(43) := 0000000 || var(44) := 0000000 || var(45) := 0000000 || var(46) := 0000000 || var(47) := 0000000 || 1
trigger1 = var(48) := 0000000 || var(49) := 0000000 || var(50) := 0000000 || var(51) := 0000000 || var(52) := 0000000 || var(53) := 0000000 || 1
trigger1 = var(54) := 0000000 || var(55) := 0000000 || var(56) := 0000000 || var(57) := 0000000 || var(58) := 0000000 || var(59) := 0000000 || 1
; Floats
trigger1 = fvar(00) := 0000000 || fvar(01) := 0000000 || fvar(02) := 0000000 || fvar(03) := 0000000 || fvar(04) := 0000000 || fvar(05) := 0000000 || 1
trigger1 = fvar(06) := 0000000 || fvar(07) := 0000000 || fvar(08) := 0000000 || fvar(09) := 0000000 || fvar(10) := 0000000 || fvar(11) := 0000000 || 1
trigger1 = fvar(12) := 0000000 || fvar(13) := 0000000 || fvar(14) := 0000000 || fvar(15) := 0000000 || fvar(16) := 0000000 || fvar(17) := 0000000 || 1
trigger1 = fvar(18) := 0000000 || fvar(19) := 0000000 || fvar(20) := 0000000 || fvar(21) := 0000000 || fvar(22) := 0000000 || fvar(23) := 0000000 || 1
trigger1 = fvar(24) := 0000000 || fvar(25) := 0000000 || fvar(26) := 0000000 || fvar(27) := 0000000 || fvar(28) := 0000000 || fvar(29) := 0000000 || 1
trigger1 = fvar(30) := 0000000 || fvar(31) := 0000000 || fvar(32) := 0000000 || fvar(33) := 0000000 || fvar(34) := 0000000 || fvar(35) := 0000000 || 1
trigger1 = fvar(36) := 0000000 || fvar(37) := 0000000 || fvar(38) := 0000000 || fvar(39) := 0000000

[state 5900, Reset Variables at Beginning of Every Match?]
type = null
triggerall = !roundsexisted
; Integers
trigger1 = var(00) := 0000000 || var(01) := 0000000 || var(02) := 0000000 || var(03) := 0000000 || var(04) := 0000000 || var(05) := 0000000 || 1
trigger1 = var(06) := 0000000 || var(07) := 0000000 || var(08) := 0000000 || var(09) := 0000000 || var(10) := 0000000 || var(11) := 0000000 || 1
trigger1 = var(12) := 0000000 || var(13) := 0000000 || var(14) := 0000000 || var(15) := 0000000 || var(16) := 0000000 || var(17) := 0000000 || 1
trigger1 = var(18) := var(18) || var(19) := var(19) || var(20) := 0000000 || var(21) := 0000000 || var(22) := 0000000 || var(23) := 0000000 || 1
trigger1 = var(24) := 0000000 || var(25) := 0000000 || var(26) := 0000000 || var(27) := 0000000 || var(28) := 0000000 || var(29) := 0000000 || 1
trigger1 = var(30) := 0000000 || var(31) := 0000000 || var(32) := 0000000 || var(33) := 0000000 || var(34) := 0000000 || var(35) := 0000000 || 1
trigger1 = var(36) := 0000000 || var(37) := 0000000 || var(38) := 0000000 || var(39) := 0000000 || var(40) := 0000000 || var(41) := 0000000 || 1
trigger1 = var(42) := 0000000 || var(43) := 0000000 || var(44) := 0000000 || var(45) := 0000000 || var(46) := 0000000 || var(47) := 0000000 || 1
trigger1 = var(48) := 0000000 || var(49) := 0000000 || var(50) := 0000000 || var(51) := 0000000 || var(52) := 0000000 || var(53) := 0000000 || 1
trigger1 = var(54) := 0000000 || var(55) := 0000000 || var(56) := 0000000 || var(57) := 0000000 || var(58) := 0000000 || var(59) := 0000000 || 1
; Floats
trigger1 = fvar(00) := 0000000 || fvar(01) := 0000000 || fvar(02) := 0000000 || fvar(03) := 0000000 || fvar(04) := 0000000 || fvar(05) := 0000000 || 1
trigger1 = fvar(06) := 0000000 || fvar(07) := 0000000 || fvar(08) := 0000000 || fvar(09) := 0000000 || fvar(10) := 0000000 || fvar(11) := 0000000 || 1
trigger1 = fvar(12) := 0000000 || fvar(13) := 0000000 || fvar(14) := 0000000 || fvar(15) := 0000000 || fvar(16) := 0000000 || fvar(17) := 0000000 || 1
trigger1 = fvar(18) := 0000000 || fvar(19) := 0000000 || fvar(20) := 0000000 || fvar(21) := 0000000 || fvar(22) := 0000000 || fvar(23) := 0000000 || 1
trigger1 = fvar(24) := 0000000 || fvar(25) := 0000000 || fvar(26) := 0000000 || fvar(27) := 0000000 || fvar(28) := 0000000 || fvar(29) := 0000000 || 1
trigger1 = fvar(30) := 0000000 || fvar(31) := 0000000 || fvar(32) := 0000000 || fvar(33) := 0000000 || fvar(34) := 0000000 || fvar(35) := 0000000 || 1
trigger1 = fvar(36) := 0000000 || fvar(37) := 0000000 || fvar(38) := 0000000 || fvar(39) := 0000000

[state 5900, Reset Variables at Beginning of First Match]
type = varrangeset
trigger1 = !roundsexisted && matchno = 1
value = 0
[state 5900, Reset Variables at Beginning of First Match]
type = varrangeset
trigger1 = !roundsexisted && matchno = 1
fvalue = 0

[state 5900, System Helper]
type = helper
trigger1 = !numhelper(6000)
name = "System"
id = 6000
stateno = 6000
postype = p1
ownpal = 0
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 0
pausemovetime = 0

; Jaan
[state 5900, Palette]
type = remappal
trigger1 = name = "Jaan"
source = 1, 1
dest = 1, cond(teamside = 2 && p2name = "Jaan", 2, 1)

; Sarkov
[state 5900, Palette]
type = remappal
trigger1 = name = "Sarkov"
source = 1, 1
dest = 1, cond(teamside = 2 && p2name = "Sarkov", 2, 1)

; Bullet
[state 5900, Palette]
type = remappal
trigger1 = name = "Bullet"
source = 1, 1
dest = 1, cond(teamside = 2 && p2name = "Bullet", 2, 1)

; Phoenix
[state 5900, Palette]
type = remappal
trigger1 = name = "Phoenix"
source = 1, 1
dest = 1, cond(teamside = 2 && p2name = "Phoenix", 2, 1)

; Frank
[state 5900, Palette]
type = remappal
trigger1 = name = "Frank"
source = 1, 1
dest = 1, cond(teamside = 2 && p2name = "Frank", 2, 1)

; Onimaru
[state 5900, Palette]
type = remappal
trigger1 = name = "Onimaru"
source = 1, 1
dest = 1, cond(teamside = 2 && p2name = "Onimaru", 2, 1)

; Lan
[state 5900, Palette]
type = remappal
trigger1 = name = "Lan"
source = 1, 1
dest = 1, cond(teamside = 2 && p2name = "Lan", 2, 1)

; Kim Tai Chi
[state 5900, Palette]
type = remappal
trigger1 = name = "Kim Tai Chi"
source = 1, 1
dest = 1, cond(teamside = 2 && p2name = "Kim Tai Chi", 2, 1)

; Widow
[state 5900, Palette]
type = remappal
trigger1 = name = "Widow"
source = 1, 1
dest = 1, cond(teamside = 2 && p2name = "Widow", 2, 1)

; Joker
[state 5900, Palette]
type = remappal
trigger1 = name = "Joker"
source = 1, 1
dest = 1, cond(teamside = 2 && p2name = "Joker", 2, 1)

; Red Man
[state 5900, Palette]
type = remappal
trigger1 = name = "Red Man"
source = 1, 1
dest = 1, cond(teamside = 2 && p2name = "Red Man", 2, 1)

[state 5900, End State]
type = changestate
trigger1 = 1
value = 190 * (roundno = 1)

;=========================================================================
; Cheap KO
;=========================================================================
[Statedef 5950]
movetype = H
physics = S
ctrl = 0
velset = 0, 0

[state 5950, Set Position]
type = posset
trigger1 = 1
y = 0
ignorehitpause = 1

[state 5950, Change Animaton]
type = changeanim
trigger1 = !hitshakeover
value = 5950
ignorehitpause = 1

[state 5950, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = 1
ignorehitpause = 1

[state 5950, End State]
type = changestate
trigger1 = animelemtime(2) > 8
value = 5150

;=========================================================================
; Widow's Crouch Death
;=========================================================================
[Statedef 5955]
type = S
movetype = H
physics = S
ctrl = 0
velset = 0, 0

[state 5955, Set Position]
type = posset
trigger1 = !time
y = 0
ignorehitpause = 1

[state 5955, Change Animaton]
type = changeanim
trigger1 = !hitshakeover
value = 5950
ignorehitpause = 1

[state 5955, Set Hit Fall]
type = hitfallset
trigger1 = !time
value = 0
ignorehitpause = 1

[state 5955, End State]
type = changestate
trigger1 = animelemtime(3) > 8
value = 5150

;=========================================================================
; System Helper
;=========================================================================
[Statedef 6000]
type = A
movetype = I
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -65536

[state 6000, Shadow Position]
type = null
trigger1 = var(16) := root,var(16)

[state 6000, Change Animation]
type = changeanim
trigger1 = anim != 9999
value = 9999

[state 6000, Root Bind]
type = bindtoroot
trigger1 = 1
pos = 0, -5

[state 6000, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = -1

[state 6000, Invulnerability]
type = nothitby
trigger1 = 1
value2 = SCA
time = -1

[state 6000, Turn]
type = turn
trigger1 = facing != root,facing

[state 6000, Dizzy Meter]
type = null ; explod
trigger1 = !numexplod(2)
ID = 2
anim = f2
postype = left
pos = cond(teamside = 1, 145, 172), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 26)
bindtime = -1
facing = -1 + 2 * (teamside = 2)
ownpal = 0
scale = 1.0, 1.0 * (1.3333333333333333333333333333333 * gameheight / gamewidth)
ontop = 1
sprpriority = 65536
pausemovetime = -1
supermovetime = -1

[state 6000, Modify Dizzy Meter]
type = modifyexplod
trigger1 = numexplod(2)
scale = root,fvar(3) * (124.0 / 40.0) , 1.0
ID = 2

[state 6000, Dizzy Canvas]
type = null ; explod
trigger1 = !numexplod(0)
ID = 0
anim = f0 + (teamside = 2)
postype = left
pos = cond(teamside = 1, 145, 172), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 26)
bindtime = -1
facing = 1
ownpal = 0
scale = 0.5, 1.0 * (1.3333333333333333333333333333333 * gameheight / gamewidth)
ontop = 1
sprpriority = 65536
pausemovetime = -1
supermovetime = -1

[state 6000, Shadow]
type = explod
trigger1 = !numexplod(5)
ID = 5
anim = f5
postype = left
pos = ceil(screenpos x), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * (screenpos y - pos y))
facing = facing
bindtime = -1
removetime = -1
removeongethit = 0
ownpal = 1
scale = 1.0, 1.0
sprpriority = -5

[state 6000, Modify Shadow]
type = modifyexplod
trigger1 = numexplod(5)
postype = left
pos = ceil(screenpos x + var(16) * facing), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * (screenpos y - pos y))
facing = facing
ID = 5

[state 6000, Foreground]
type = explod
trigger1 = !numexplod(6180)
ID = 6180
anim = f6180
postype = left
pos = 0, 0
facing = facing
bindtime = -1
removetime = -1
removeongethit = 0
ownpal = 1
scale = 0.5, 0.5
ontop = 1

[state 6000, Display System]
type = displaytoclipboard
trigger1 = 1
text = "Shadow Position = %d"
params = var(16)

;=========================================================================
; Match Results
;=========================================================================
[Statedef 6005]
type = A
movetype = I
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -65536

;========================< Essential State Controllers >========================
 
[state 6005, Character Name]
type = null
trigger1 = name = "Jaan"
trigger1 = var(0) := 6010
trigger2 = name = "Sarkov"
trigger2 = var(0) := 6020
trigger3 = root, name = "Bullet"
trigger3 = var(0) := 6030
trigger4 = name = "Phoenix"
trigger4 = var(0) := 6040
trigger5 = name = "Frank"
trigger5 = var(0) := 6050
trigger6 = name = "Onimaru"
trigger6 = var(0) := 6060
trigger7 = name = "Lan"
trigger7 = var(0) := 6070
trigger8 = name = "Kim Tai Chi"
trigger8 = var(0) := 6080
trigger9 = name = "Widow"
trigger9 = var(0) := 6090
trigger10 = name = "Joker"
trigger10 = var(0) := 6100
trigger11 = name = "Red Man"
trigger11 = var(0) := 6110

[state 6005, Character Name]
type = null
triggerall = numenemy
trigger1 = enemy,name = "Jaan"
trigger1 = var(1) := 6010
trigger2 = enemy,name = "Sarkov"
trigger2 = var(1) := 6020
trigger3 = enemy,name = "Bullet"
trigger3 = var(1) := 6030
trigger4 = enemy,name = "Phoenix"
trigger4 = var(1) := 6040
trigger5 = enemy,name = "Frank"
trigger5 = var(1) := 6050
trigger6 = enemy,name = "Onimaru"
trigger6 = var(1) := 6060
trigger7 = enemy,name = "Lan"
trigger7 = var(1) := 6070
trigger8 = enemy,name = "Kim Tai Chi"
trigger8 = var(1) := 6080
trigger9 = enemy,name = "Widow"
trigger9 = var(1) := 6090
trigger10 = enemy,name = "Joker"
trigger10 = var(1) := 6100
trigger11 = enemy,name = "Red Man"
trigger11 = var(1) := 6110

[state 6005, Change Animation]
type = changeanim
trigger1 = anim != 9999
value = 9999

[state 6005, Background Effect]
type = allpalfx
trigger1 = var(2) < 80
trigger1 = var(2) := var(2) + 1
time = 1
mul = ceil(256 - 3.2 * var(2)), ceil(256 - 3.2 * var(2)), ceil(256 - 3.2 * var(2))
add = 0, 0, 0
color = 256
invertall = 0

[state 6005, Background Effect]
type = allpalfx
trigger1 = var(2) >= 80 && var(3) < 80
trigger1 = var(3) := var(3) + 1
time = 1
mul = ceil(3.2 * var(3)), ceil(3.2 * var(3)), ceil(3.2 * var(3))
add = 0, 0, 0
color = 256
invertall = 0

[state 6005, Press Start]
type = null
trigger1 = root,command = "start" || cond(numenemy, enemy,command = "start", 0)
trigger1 = var(4) := 4525
persistent = 0

[state 6005, Special Effect]
type = assertspecial
trigger1 = var(3) >= 0 && var(4) < 4525
trigger1 = var(4) := var(4) + 1
flag = roundnotover

[state 6005, Special Effect]
type = assertspecial
trigger1 = var(3)
flag = globalnoshadow
flag2 = nobardisplay

[state 6005, Special Effect]
type = assertspecial
trigger1 = var(3)
flag = nofg
flag2 = nobg
flag3 = nomusic

[state 6005, Opaque]
type = envcolor
trigger1 = var(3)
value = 4, 2, 4
time = 1

[state 6005, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA

[state 6005, Sound]
type = stopsnd
trigger1 = var(3) = 1
channel = -1

[state 6005, Sound]
type = playsnd
trigger1 = var(3) = 1
value = f6005, 0
volumescale = 100
channel = 2
loop = 1

[State -2, Sound Position]
type = sndpan
trigger1 = var(3) ; = 1
channel = 2
abspan = 0

[state 6005, Sound]
type = stopsnd
trigger1 = var(4) = 4525
channel = 2

;========================< Newspaper, Flags, and Portraits >========================
 
[state 6005, Results]
type = explod
trigger1 = !numexplod(6000 + root,var(11) + 5 *  (teamside = 1 && !ishometeam || teamside = 2 && ishometeam)) && var(3)
ID = 6000 + root,var(11) + 5 * (teamside = 1 && !ishometeam || teamside = 2 && ishometeam)
anim = f6000 + root,var(11) + 5 *  (teamside = 1 && !ishometeam || teamside = 2 && ishometeam)
postype = left
pos = 0, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 0)
facing = 1
bindtime = -1
removetime = -1
removeongethit = 0
ownpal = 1
scale = 1.0, 1.0
ontop = 1
sprpriority = 5

[state 6005, Winner Face]
type = explod
trigger1 = !numexplod(0) && var(3)
ID = 0
anim = f(var(0) + lose + 2 * (teamside = 2))
postype = left
pos = cond(teamside = 1, 18, 214), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 54)
facing = 1
bindtime = -1
removetime = -1
removeongethit = 0
ownpal = 1
scale = 1.0, 1.0
ontop = 1
sprpriority = 5

[state 6005, Winner Flag]
type = explod
trigger1 = !numexplod(1) && var(3)
ID = 1
anim = f(var(0) + 4)
postype = left
pos = cond(teamside = 1, 30, 226), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 168)
facing = 1
bindtime = -1
removetime = -1
removeongethit = 0
ownpal = 1
scale = 1.0, 1.0
ontop = 1
sprpriority = 5

[state 6005, Loser Face]
type = explod
trigger1 = numenemy
trigger1 = !numexplod(2) && var(3)
ID = 2
anim = f(var(1) + enemy,lose + 2 * (enemy,teamside = 2))
postype = left
pos = cond(enemy,teamside = 1, 18, 214), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 54)
facing = 1
bindtime = -1
removetime = -1
removeongethit = 0
ownpal = 1
scale = 1.0, 1.0
ontop = 1
sprpriority = 5

[state 6005, Loser Flag]
type = explod
trigger1 = numenemy
trigger1 = !numexplod(3) && var(3)
ID = 3
anim = f(var(1) + 4)
postype = left
pos = cond(enemy,teamside = 1, 30, 226), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 168)
facing = 1
bindtime = -1
removetime = -1
removeongethit = 0
ownpal = 1
scale = 1.0, 1.0
ontop = 1
sprpriority = 5

;========================< Initialize Score >========================

[state 6005, Calculate Score Bonus]
type = null
triggerall = !time
trigger1 = teamside = 1 && !ishometeam
trigger1 = var(5) := root,var(18)
trigger2 = teamside = 2 && ishometeam && numenemy
trigger2 = var(5) := enemy,var(18)

[state 6005, Length of Score]
type = null
trigger1 = var(06) := 0 || 1
trigger1 = var(06) := var(06) + (abs(var(5)) >= 1) + (abs(var(5)) >= 10) || 1
trigger1 = var(06) := var(06) + (abs(var(5)) >= 100) + (abs(var(5)) >= 1000) || 1
trigger1 = var(06) := var(06) + (abs(var(5)) >= 10000) + (abs(var(5)) >= 100000) || 1
trigger1 = var(06) := var(06) + (abs(var(5)) >= 1000000) + (abs(var(5)) >= 10000000) || 1
trigger1 = fvar(0) := var(06) * (var(07) := cond(var(06), 12, 1)) * 1.5 || 1 ; var(07) is the spacing between characters
trigger1 = fvar(1) := -var(06) * var(07) / 2.0
trigger1 = var(08) := numexplod ; already existing explods

;========================< Display Score >========================

[state 6005, Reset]
type = removeexplod
trigger1 = numexplod(4) + numexplod(5) + numexplod(6) + numexplod(7) + numexplod(8) + numexplod(9) + numexplod(10) + numexplod(11) < (fvar(0) / var(7) / 1.5)
ID = 4
[state 6005, Reset]
type = removeexplod
trigger1 = numexplod(4) + numexplod(5) + numexplod(6) + numexplod(7) + numexplod(8) + numexplod(9) + numexplod(10) + numexplod(11) < (fvar(0) / var(7) / 1.5)
ID = 5
[state 6005, Reset]
type = removeexplod
trigger1 = numexplod(4) + numexplod(5) + numexplod(6) + numexplod(7) + numexplod(8) + numexplod(9) + numexplod(10) + numexplod(11) < (fvar(0) / var(7) / 1.5)
ID = 6
[state 6005, Reset]
type = removeexplod
trigger1 = numexplod(4) + numexplod(5) + numexplod(6) + numexplod(7) + numexplod(8) + numexplod(9) + numexplod(10) + numexplod(11) < (fvar(0) / var(7) / 1.5)
ID = 7
[state 6005, Reset]
type = removeexplod
trigger1 = numexplod(4) + numexplod(5) + numexplod(6) + numexplod(7) + numexplod(8) + numexplod(9) + numexplod(10) + numexplod(11) < (fvar(0) / var(7) / 1.5)
ID = 8
[state 6005, Reset]
type = removeexplod
trigger1 = numexplod(4) + numexplod(5) + numexplod(6) + numexplod(7) + numexplod(8) + numexplod(9) + numexplod(10) + numexplod(11) < (fvar(0) / var(7) / 1.5)
ID = 9
[state 6005, Reset]
type = removeexplod
trigger1 = numexplod(4) + numexplod(5) + numexplod(6) + numexplod(7) + numexplod(8) + numexplod(9) + numexplod(10) + numexplod(11) < (fvar(0) / var(7) / 1.5)
ID = 10
[state 6005, Reset]
type = removeexplod
trigger1 = numexplod(4) + numexplod(5) + numexplod(6) + numexplod(7) + numexplod(8) + numexplod(9) + numexplod(10) + numexplod(11) < (fvar(0) / var(7) / 1.5)
ID = 11

[state 6005, Ten Millions]
type = explod
triggerall = !numexplod(11) && var(3) && var(5) >= 10000000
trigger1 = teamside = 1 && !ishometeam
trigger2 = teamside = 2 && ishometeam
ID = 11
anim = f6145 + floor(var(5) / 10000000) % 10
postype = left
pos = ceil(150 + (var(07) * (numexplod - var(08))) + fvar(1)), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 203)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
scale = 1.0, 1.0
pausemovetime = -1
supermovetime = -1
 
[state 6005, Millions]
type = explod
triggerall = !numexplod(10) && var(3) && var(5) >= 1000000
trigger1 = teamside = 1 && !ishometeam
trigger2 = teamside = 2 && ishometeam
ID = 10
anim = f6145 + floor(var(5) / 1000000) % 10
postype = left
pos = ceil(150 + (var(07) * (numexplod - var(08))) + fvar(1)), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 203)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
scale = 1.0, 1.0
pausemovetime = -1
supermovetime = -1
 
[state 6005, Hundred Thousands]
type = explod
triggerall = !numexplod(9) && var(3) && var(5) >= 100000
trigger1 = teamside = 1 && !ishometeam
trigger2 = teamside = 2 && ishometeam
ID = 9
anim = f6145 + floor(var(5) / 100000) % 10
postype = left
pos = ceil(150 + (var(07) * (numexplod - var(08))) + fvar(1)), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 203)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
scale = 1.0, 1.0
pausemovetime = -1
supermovetime = -1
 
[state 6005, Ten Thousands]
type = explod
triggerall = !numexplod(8) && var(3) && var(5) >= 10000
trigger1 = teamside = 1 && !ishometeam
trigger2 = teamside = 2 && ishometeam
ID = 8
anim = f6145 + floor(var(5) / 10000) % 10
postype = left
pos = ceil(150 + (var(07) * (numexplod - var(08))) + fvar(1)), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 203)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
scale = 1.0, 1.0
pausemovetime = -1
supermovetime = -1
 
[state 6005, Thousands]
type = explod
triggerall = !numexplod(7) && var(3) && var(5) >= 1000
trigger1 = teamside = 1 && !ishometeam
trigger2 = teamside = 2 && ishometeam
ID = 7
anim = f6145 + floor(var(5) / 1000) % 10
postype = left
pos = ceil(150 + (var(07) * (numexplod - var(08))) + fvar(1)), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 203)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
scale = 1.0, 1.0
pausemovetime = -1
supermovetime = -1
  
[state 6005, Hundreds]
type = explod
triggerall = !numexplod(6) && var(3) && var(5) >= 100
trigger1 = teamside = 1 && !ishometeam
trigger2 = teamside = 2 && ishometeam
ID = 6
anim = f6145 + floor(var(5) / 100) % 10
postype = left
pos = ceil(150 + (var(07) * (numexplod - var(08))) + fvar(1)), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 203)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
scale = 1.0, 1.0
pausemovetime = -1
supermovetime = -1
 
[state 6005, Tens]
type = explod
triggerall = !numexplod(5) && var(3) && var(5) >= 10
trigger1 = teamside = 1 && !ishometeam
trigger2 = teamside = 2 && ishometeam
ID = 5
anim = f6145 + floor(var(5) / 10) % 10
postype = left
pos = ceil(150 + (var(07) * (numexplod - var(08))) + fvar(1)), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 203)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
scale = 1.0, 1.0
pausemovetime = -1
supermovetime = -1

[state 6005, Ones]
type = explod
triggerall = !numexplod(4) && var(3)
trigger1 = teamside = 1 && !ishometeam
trigger2 = teamside = 2 && ishometeam
ID = 4
anim = f6145 + floor(var(5) / 1) % 10
postype = left
pos = ceil(150 + (var(07) * (numexplod - var(08))) + fvar(1)), ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 203)
bindtime = 1
facing = 1
ownpal = 0
ontop = 1
scale = 1.0, 1.0
pausemovetime = -1
supermovetime = -1
 
[state 6005, Final Score]
type = explod
triggerall = !numexplod(12) && var(3)
trigger1 = teamside = 1 && !ishometeam
trigger2 = teamside = 2 && ishometeam
ID = 12
anim = f6155
postype = left
pos = 106, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 181)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
scale = 1.0, 1.0
pausemovetime = -1
supermovetime = -1

;========================< Fail-safes >========================
 
[state 6005, Sound]
type = stopsnd
trigger1 = !matchover || roundstate < 4
channel = -1

[state 6005, Destroy Explod]
type = removeexplod
trigger1 = !matchover || roundstate < 4

[state 6005, Destroy Helper]
type = destroyself
trigger1 = !matchover || roundstate < 4

;=========================================================================
; Width Helper
;=========================================================================
[Statedef 6010]
type = U
movetype = I
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -5

[state 6010, Change Animation]
type = changeanim
trigger1 = root,movetype != H && root,stateno != [5000, 5999]
trigger1 = !root,gethitvar(isbound) && !root,gethitvar(chainid)
value = root,anim
elem = root,animelemno(0)

[state 6010, Special Effect]
type = assertspecial
trigger1 = 1
flag = invisible
flag2 = noshadow

[state 6010, Root Bind]
type = bindtoroot
trigger1 = 1
pos = 0, 0

[state 6010, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = -1

[state 6010, Invulnerability]
type = nothitby
trigger1 = 1
value2 = SCA
time = -1

[state 6010, Set State Type]
type = statetypeset
trigger1 = root,statetype = S
statetype = S

[state 6010, Set State Type]
type = statetypeset
trigger1 = root,statetype = C
statetype = C

[state 6010, Set State Type]
type = statetypeset
trigger1 = root,statetype = A
statetype = A

[state 6010, Turn]
type= turn
trigger1 = facing != root,facing

[state 6010, Solidity]
type = playerpush
trigger1 = 1
value = 1

[state 6010, Width]
type = varset
trigger1 = 1
var(0) = 0

; Jaan
[state 6010, Width]
type = width
trigger1 = name = "Jaan" && root,anim = 430
trigger1 = root,animelemno(0) = [1, 4]
player = var(0) := 40, 0

; Phoenix
[state 6010, Width]
type = width
trigger1 = name = "Phoenix" && root,anim = 1000
trigger1 = root,animelemno(0) = [2, 3]
trigger2 = name = "Phoenix" && root,anim = 3000
trigger2 = root,animelemno(0) = [9, 10]
player = var(0) := 40, 0

; Frank
[state 6010, Width]
type = width
trigger1 = name = "Frank" && root,anim = 1200
trigger1 = root,animelemno(0) = 2
player = var(0) := 40, 0

; Onimaru
[state 6010, Width]
type = width
trigger1 = name = "Onimaru" && root,anim = 1000
trigger1 = root,animelemno(0) = 4
trigger2 = name = "Onimaru" && root,anim = 3000
trigger2 = root,animelemno(0) = 5
player = var(0) := 40, 0

; Onimaru
[state 6010, Width]
type = width
trigger1 = name = "Onimaru" && root,anim = 1100
trigger1 = root,animelemno(0) = [4, 6]
player = var(0) := 72, 0

; Lan
[state 6010, Width]
type = width
trigger1 = name = "Lan" && (root,anim = 1000 || root,anim = 3100)
trigger1 = root,animelemno(0) = 3
player = var(0) := 40, 0

; Kim Tai Chi
[state 6010, Width]
type = width
trigger1 = name = "Kim Tai Chi" && root,anim = 430
trigger1 = root,animelemno(0) = [1, 4]
player = var(0) := 32, 0

; Kim Tai Chi
[state 6010, Width]
type = width
trigger1 = name = "Kim Tai Chi" && root,anim = 1000
trigger1 = root,animelemno(0) = [1, 2]
player = var(0) := 48, 0

; Widow
[state 6010, Width]
type = width
trigger1 = name = "Widow" && root,anim = 200 
trigger1 = root,animelemno(0) = [2, 3]
player = var(0) := 32, 0

; Widow
[state 6010, Width]
type = width
trigger1 = name = "Widow" && root,anim = 400 
trigger1 = root,animelemno(0) = [2, 3]
player = var(0) := 32, 0

[state 6010, Destroy Helper]
type = destroyself
trigger1 = !var(0) || root,movetype = H || root,stateno = [5000, 5999]
trigger2 = root,gethitvar(isbound) || root,gethitvar(chainid) = 5900

;=========================================================================
; Death Helper
;=========================================================================
[Statedef 6015]
type = A
movetype = I
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -5

[state 6015, Change Animation]
type = changeanim
trigger1 = anim != 9999
value = 9999

[state 6015, Voice]
type = playsnd
trigger1 = !root,gethitvar(isbound)
trigger2 = numenemy
trigger2 = root,gethitvar(chainid) = 11
trigger2 = enemy,anim = 1206 && enemy,animelemtime(2) >= 0
value = f5150, (name = "Phoenix" || name = "Widow")
persistent = 0

[state 6015, Destroy Helper]
type = destroyself
trigger1 = root,alive

;=========================================================================
; Pause Screen Helper
;=========================================================================
[Statedef 6020]
type = A
movetype = I
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 65536

[state 6020, Character Name]
type = null
triggerall = !time
trigger1 = name = "Jaan"
trigger1 = var(0) := 0
trigger2 = name = "Sarkov"
trigger2 = var(0) := 1
trigger3 = root, name = "Bullet"
trigger3 = var(0) := 2
trigger4 = name = "Phoenix"
trigger4 = var(0) := 3
trigger5 = name = "Frank"
trigger5 = var(0) := 4
trigger6 = name = "Onimaru"
trigger6 = var(0) := 5
trigger7 = name = "Lan"
trigger7 = var(0) := 6
trigger8 = name = "Kim Tai Chi"
trigger8 = var(0) := 7
trigger9 = name = "Widow"
trigger9 = var(0) := 8
trigger10 = name = "Joker"
trigger10 = var(0) := 9
trigger11 = name = "Red Man"
trigger11 = var(0) := 10

[state 6020, Pause Options]
type = null
; Darken Screen
trigger1 = 0 ; !time || root,command = "b" ; || enemy,command = "b"
trigger1 = var(1) := cond(var(1) != 1, 1, 2)
; Lifebars & Movelists
trigger2 = root,command = "a" ; || enemy,command = "a"
trigger2 = var(2) := cond(var(2), 0 ,1)

[state 6020, Change Animation]
type = changeanim
trigger1 = 1
value = 9999 ; root,anim
; elem = root,animelemno(0)

[state 6020, Root Bind]
type = bindtoroot
trigger1 = 1
pos = 0, 0

[state 6020, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = -1

[state 6020, Invulnerability]
type = nothitby
trigger1 = 1
value2 = SCA
time = -1

[state 6020, Special Effect]
type = assertspecial
trigger1 = 1
flag = nomusic

[state 6020, Special Effect]
type = null ; assertspecial
trigger1 = var(2)
flag = nobardisplay

[state 6020, Pause]
type = superpause
trigger1 = root,command = "start" ; || enemy,command = "start"
trigger2 = time >= 65534
time = 65535 * (!time || time >= 65534 && root,command != "start") ; && enemy,command != "start")
movetime = 65535 * (!time || time >= 65534 && root,command != "start") ; && enemy,command != "start")
unhittable = 0
anim = -1
sound = -1
p2defmul = 1
poweradd = 0
darken = 0

[state 6020, Background Effect]
type = bgpalfx
trigger1 = 1
time = 1
mul = 128, 128, 128
; mul = 128 * var(1), 128 * var(1), 128 * var(1)
add = 0, 0, 0
color = 256
invertall = 0

[state 6020, Increment Movelist]
type = removeexplod
triggerall = var(2)
trigger1 = root,command = "fwd" || root,command = "back"
trigger1 = var(0) := var(0) + cond(cond(root,facing = 1, root,command = "fwd", root,command = "back"), 1, -1) || 1
trigger1 = cond((var(0) != [0, 10]), var(0) := cond(var(0) < 0, 10, 0), 0) || 1

[state 6020, Pause Text]
type = explod
trigger1 = !var(2)
trigger1 = !numexplod(6175)
ID = 6175
anim = f6175
postype = left
pos = 87, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 101)
facing = 1
bindtime = -1
removetime = -1
removeongethit = 0
ownpal = 0
scale = 1.0, 1.0
ontop = 1
sprpriority = 65535
supermovetime = -1
pausemovetime = -1

[state 6020, Movelist]
type = explod
triggerall = var(2)
trigger1 = !time
trigger2 = root,command = "fwd" || root,command = "back"
trigger3 = root,command = "a" ; || enemy,command = "a"
ID = 6160 ; + var(0)
anim = f6160 + var(0)
postype = left
pos = 0, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 20)
facing = 1
bindtime = -1
removetime = -1
removeongethit = 0
ownpal = 0
scale = 0.5, 0.5
ontop = 1
sprpriority = 65535
supermovetime = -1
pausemovetime = -1

[state 6020, Fingers]
type = explod
triggerall = var(2)
trigger1 = root,command = "fwd" || root,command = "back"
ID = 6160 ; 6171 + cond(root,facing = 1, root,command = "fwd", root,command = "back")
anim = f6171 + cond(root,facing = 1, root,command = "fwd", root,command = "back")
postype = left
pos = 0, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 20)
facing = 1
bindtime = -1
removetime = 8
removeongethit = 0
ownpal = 0
scale = 0.5, 0.5
ontop = 1
sprpriority = 65536
supermovetime = -1
pausemovetime = -1

[state 6020, Sound]
type = playsnd
triggerall = var(2)
trigger1 = root,command = "fwd" || root,command ="back"
value = f6020, 0
volumescale = 100
channel = 1

[state 6020, Destroy Explod]
type = removeexplod
triggerall = numexplod(6175)
trigger1 = var(2)
ID = 6175

[state 6020, Destroy Explod]
type = removeexplod
triggerall = numexplod(6160)
trigger1 = !var(2)
ID = 6160

[state 6020, Destroy Explod]
type = removeexplod
triggerall = numexplod
trigger1 = time
trigger1 = root,command = "start" ; || enemy,command = "start"

[state 6020, Destroy Helper]
type = destroyself
trigger1 = time
trigger1 = root,command = "start" ; || enemy,command = "start"

;=========================================================================
; Super Effect
;=========================================================================
[StateDef 6120]
type = A
movetype = I
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 65536

[state 6120, Root State]
type = null
trigger1 = !time
trigger1 = var(0) := parent,stateno || var(1) := 48

; Jaan
[state 6120, Position X and Position Y]
type = null
triggerall = !time && name = "Jaan"
trigger1 = var(0) = 3000
trigger1 = var(2) := 10 || var(3) := -82  
trigger2 = var(0) = 3100
trigger2 = var(2) := -42 || var(3) := -76

; Sarkov
[state 6120, Position X and Position Y]
type = null
triggerall = !time && name = "Sarkov"
trigger1 = var(0) = 3000
trigger1 = var(2) := 16 || var(3) := -64

; Bullet
[state 6120, Position X and Position Y]
type = null
triggerall = !time && name = "Bullet"
trigger1 = var(0) = 3000
trigger1 = var(2) := 24 || var(3) := -78

; Phoenix
[state 6120, Position X and Position Y]
type = null
triggerall = !time && name = "Phoenix"
trigger1 = var(0) = 3000
trigger1 = var(2) := -8 || var(3) := -72
trigger2 = var(0) = 3100
trigger2 = var(2) := -4 || var(3) := -72

; Frank
[state 6120, Position X and Position Y]
type = null
triggerall = !time && name = "Frank"
trigger1 = var(0) = 3000
trigger1 = var(2) := 2 || var(3) := -44

; Onimaru
[state 6120, Position X and Position Y]
type = null
triggerall = !time && name = "Onimaru"
trigger1 = var(0) = 3000
trigger1 = var(2) := 8 || var(3) := -40

; Lan
[state 6120, Position X and Position Y]
type = null
triggerall = !time && name = "Lan"
trigger1 = var(0) = 3000
trigger1 = var(2) := 0 || var(3) := -48
trigger2 = var(0) = 3100
trigger2 = var(2) := 0 || var(3) := -72

; Kim Tai Chi
[state 6120, Position X and Position Y]
type = null
triggerall = !time && name = "Kim Tai Chi"
trigger1 = var(0) = 3000
trigger1 = var(2) := 0 || var(3) := -8

; Widow
[state 6120, Position X and Position Y]
type = null
triggerall = !time && name = "Widow"
trigger1 = var(0) = 3000
trigger1 = var(2) := 24 || var(3) := -24
trigger2 = var(0) = 3010
trigger2 = var(2) := 0 || var(3) := -56

; Joker
[state 6120, Position X and Position Y]
type = null
triggerall = !time && name = "Joker"
trigger1 = var(0) = 3000
trigger1 = var(2) := 24 || var(3) := -44
trigger2 = var(0) = 3100
trigger2 = var(2) := 0 || var(3) := -52

; Red Man
[state 6120, Position X and Position Y]
type = null
triggerall = !time && name = "Red Man"
trigger1 = var(0) = 3000
trigger1 = var(2) := 2 || var(3) := -86
trigger2 = var(0) = 3015
trigger2 = var(2) := 2 || var(3) := -86

[state 6120, Change Animation]
type = changeanim
trigger1 = !time
value = 9999

[state 6120, Parent Bind]
type = bindtoparent
trigger1 = 1
pos = var(2), var(3)

[state 6120, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 6120, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA

[state 6120, Background Effect]
type = bgpalfx
trigger1 = time <= ceil(var(1) * 0.5)
trigger1 = fvar(1) := (256.0 / (var(1) * 0.5)) || fvar(2) := (256.0 / (var(1) * 0.5))
time = 1
mul = floor(256 - fvar(1) * 0.75 * time), floor(256 - fvar(1) * 0.75 * time), floor(256 - fvar(1) * 0.75 * time)
add = 0, 0, 0
color = floor(256 - fvar(2) * time)
invertall = 0

[state 6120, Background Effect]
type = bgpalfx
trigger1 = time > ceil(var(1) * 0.5)
trigger1 = fvar(1) := (256.0 / (var(1) * 0.5)) || fvar(2) := (256.0 / (var(1) * 0.5))
time = 1
mul = ceil(64 + fvar(1) * 0.75 * (time - var(1) * 0.5)), ceil(64 + fvar(1) * 0.75 * (time - var(1) * 0.5)), ceil(64 + fvar(1) * 0.75 * (time - var(1) * 0.5))
add = 0, 0, 0
color = ceil(fvar(2) * (time - var(1) * 0.5))
invertall = 0

[state 6120, Sound]
type = playsnd
trigger1 = !time
value = f6120, 0
volumescale = 100

[state 6120, Stars]
type = explod
trigger1 = !numexplod(6120)
ID = 6120
anim = f6120
postype = p1
facing = 1
bindtime = -1
removeongethit = 1
ownpal = 1
scale = 1.0, 1.0
sprpriority = 65536
supermovetime = -1
pausemovetime = -1

[state 6120, Destroy Explod]
type = removeexplod
trigger1 = time >= var(1) || parent,stateno != var(0)
trigger2 = parent,movetype = H || numhelper(6120) > 1

[state 6120, Destroy Helper]
type = destroyself
trigger1 = time >= var(1) || parent,stateno != var(0)
trigger2 = parent,movetype = H || numhelper(6120) > 1
 
;==================================================================================================================================================
; Score Helper
;==================================================================================================================================================
[Statedef 6125]
type = A
movetype = I
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -65536
 
;========================< Essential State Controllers >========================
 
[state 6125, Change Animation]
type = changeanim
trigger1 = anim != 9999
value = 9999
 
[state 6125, Parent Bind]
type = bindtoparent
trigger1 = 1
pos = 0, -16
 
[state 6125, Vulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = -1
 
[state 6125, Background Effect]
type = bgpalfx
trigger1 = 1
time = 1
mul = 128, 128, 128
add = 0, 0, 0
color = 256
invertall = 0

[state 6125, Press Start]
type = null
trigger1 = root,command = "start"
trigger1 = var(0) := root,var(18) || 1
trigger1 = var(3) := 0 || var(4) := 88
persistent = 0

;========================< Initialize Score >========================

[state 6125, Calculate Score Bonus]
type = null
triggerall = !time
trigger1 = var(0) := root,var(19) || 1
trigger1 = var(1) := 100 * (100 - cond(root,fvar(7) > 99, 99, floor(root,fvar(7))))
trigger1 = var(2) := 100 * root,life || 1
trigger1 = var(3) := 100 * ceil((var(1) + var(2)) / 100)

;========================< Calculate Score >========================

[state 6125, Increase Score]
type = varadd
trigger1 = var(3) && time >= 80
trigger1 = time % 2 = 0
var(0) = 100

[state 6125, Reset]
type = removeexplod
trigger1 = 1
 
;========================< Display Score >========================

[state 6125, Score]
type = explod
trigger1 = !numexplod(0) && time > 2
anim = f6125
ID = 0
postype = left
pos = 80, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 72)
bindtime = 1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1

[state 6125, Ones]
type = explod
trigger1 = !numexplod(1) && time > 2
anim = f6130 + floor(var(0) / 1) % 10
ID = 1
postype = left
pos = 230, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 72)
bindtime = 1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Tens]
type = explod
trigger1 = !numexplod(2) && time > 2 && var(0) >= 10
anim = f6130 + floor(var(0) / 10) % 10
ID = 2
postype = left
pos = 218, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 72)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Hundreds]
type = explod
trigger1 = !numexplod(3) && time > 2 && var(0) >= 100
anim = f6130 + floor(var(0) / 100) % 10
ID = 3
postype = left
pos = 206, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 72)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Thousands]
type = explod
trigger1 = !numexplod(4) && time > 2 && var(0) >= 1000
anim = f6130 + floor(var(0) / 1000) % 10
ID = 4
postype = left
pos = 194, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 72)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Ten Thousands]
type = explod
trigger1 = !numexplod(5) && time > 2 && var(0) >= 10000
anim = f6130 + floor(var(0) / 10000) % 10
ID = 5
postype = left
pos = 182, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 72)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Hundred Thousands]
type = explod
trigger1 = !numexplod(6) && time > 2 && var(0) >= 100000
anim = f6130 + floor(var(0) / 100000) % 10
ID = 6
postype = left
pos = 170, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 72)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Millions]
type = explod
trigger1 = !numexplod(7) && time > 2 && var(0) >= 1000000
anim = f6130 + floor(var(0) / 1000000) % 10
ID = 7
postype = left
pos = 158, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 72)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Ten Millions]
type = explod
trigger1 = !numexplod(8) && time > 2 && var(0) >= 10000000
anim = f6130 + floor(var(0) / 10000000) % 10
ID = 8
postype = left
pos = 146, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 72)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
;========================< Display Time >========================

[state 6125, Score]
type = explod
trigger1 = !numexplod(10) && time > 2
anim = f6126
ID = 10
postype = left
pos = 80, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 104)
bindtime = 1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1

[state 6125, Ones]
type = explod
trigger1 = !numexplod(11) && time > 2
anim = f6130 + floor(var(1) / 1) % 10
ID = 11
postype = left
pos = 230, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 104)
bindtime = 1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Tens]
type = explod
trigger1 = !numexplod(12) && time > 2 && var(1) >= 10
anim = f6130 + floor(var(1) / 10) % 10
ID = 12
postype = left
pos = 218, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 104)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Hundreds]
type = explod
trigger1 = !numexplod(13) && time > 2 && var(1) >= 100
anim = f6130 + floor(var(1) / 100) % 10
ID = 13
postype = left
pos = 206, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 104)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Thousands]
type = explod
trigger1 = !numexplod(14) && time > 2 && var(1) >= 1000
anim = f6130 + floor(var(1) / 1000) % 10
ID = 14
postype = left
pos = 194, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 104)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Ten Thousands]
type = explod
trigger1 = !numexplod(15) && time > 2 && var(1) >= 10000
anim = f6130 + floor(var(1) / 10000) % 10
ID = 15
postype = left
pos = 182, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 104)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Hundred Thousands]
type = explod
trigger1 = !numexplod(16) && time > 2 && var(1) >= 100000
anim = f6130 + floor(var(1) / 100000) % 10
ID = 16
postype = left
pos = 170, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 104)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Millions]
type = explod
trigger1 = !numexplod(17) && time > 2 && var(1) >= 1000000
anim = f6130 + floor(var(1) / 1000000) % 10
ID = 17
postype = left
pos = 158, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 104)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Ten Millions]
type = explod
trigger1 = !numexplod(18) && time > 2 && var(1) >= 10000000
anim = f6130 + floor(var(1) / 10000000) % 10
ID = 18
postype = left
pos = 146, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 104)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
;========================< Display Blood >========================

[state 6125, Score]
type = explod
trigger1 = !numexplod(20) && time > 2
anim = f6127
ID = 20
postype = left
pos = 80, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = 1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1

[state 6125, Ones]
type = explod
trigger1 = !numexplod(21) && time > 2
anim = f6130 + floor(var(2) / 1) % 10
ID = 21
postype = left
pos = 230, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = 1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Tens]
type = explod
trigger1 = !numexplod(22) && time > 2 && var(2) >= 10
anim = f6130 + floor(var(2) / 10) % 10
ID = 22
postype = left
pos = 218, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Hundreds]
type = explod
trigger1 = !numexplod(23) && time > 2 && var(2) >= 100
anim = f6130 + floor(var(2) / 100) % 10
ID = 23
postype = left
pos = 206, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Thousands]
type = explod
trigger1 = !numexplod(24) && time > 2 && var(2) >= 1000
anim = f6130 + floor(var(2) / 1000) % 10
ID = 24
postype = left
pos = 194, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Ten Thousands]
type = explod
trigger1 = !numexplod(25) && time > 2 && var(2) >= 10000
anim = f6130 + floor(var(2) / 10000) % 10
ID = 25
postype = left
pos = 182, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Hundred Thousands]
type = explod
trigger1 = !numexplod(26) && time > 2 && var(2) >= 100000
anim = f6130 + floor(var(2) / 100000) % 10
ID = 26
postype = left
pos = 170, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Millions]
type = explod
trigger1 = !numexplod(27) && time > 2 && var(2) >= 1000000
anim = f6130 + floor(var(2) / 1000000) % 10
ID = 27
postype = left
pos = 158, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Ten Millions]
type = explod
trigger1 = !numexplod(28) && time > 2 && var(2) >= 10000000
anim = f6130 + floor(var(2) / 10000000) % 10
ID = 28
postype = left
pos = 146, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
;========================< Display Bonus >========================

[state 6125, Score]
type = explod
trigger1 = !numexplod(30) && time > 2
anim = f6128
ID = 30
postype = left
pos = 80, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 152)
bindtime = 1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1

[state 6125, Ones]
type = explod
trigger1 = !numexplod(31) && time > 2
anim = f6130 + floor(var(3) / 1) % 10
ID = 31
postype = left
pos = 230, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 152)
bindtime = 1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Tens]
type = explod
trigger1 = !numexplod(32) && time > 2 && var(3) >= 10
anim = f6130 + floor(var(3) / 10) % 10
ID = 32
postype = left
pos = 218, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 152)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Hundreds]
type = explod
trigger1 = !numexplod(33) && time > 2 && var(3) >= 100
anim = f6130 + floor(var(3) / 100) % 10
ID = 33
postype = left
pos = 206, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 152)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Thousands]
type = explod
trigger1 = !numexplod(34) && time > 2 && var(3) >= 1000
anim = f6130 + floor(var(3) / 1000) % 10
ID = 34
postype = left
pos = 194, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 152)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Ten Thousands]
type = explod
trigger1 = !numexplod(35) && time > 2 && var(3) >= 10000
anim = f6130 + floor(var(3) / 10000) % 10
ID = 35
postype = left
pos = 182, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 152)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Hundred Thousands]
type = explod
trigger1 = !numexplod(36) && time > 2 && var(3) >= 100000
anim = f6130 + floor(var(3) / 100000) % 10
ID = 36
postype = left
pos = 170, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 152)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Millions]
type = explod
trigger1 = !numexplod(37) && time > 2 && var(3) >= 1000000
anim = f6130 + floor(var(3) / 1000000) % 10
ID = 37
postype = left
pos = 158, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 152)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
[state 6125, Ten Millions]
type = explod
trigger1 = !numexplod(38) && time > 2 && var(3) >= 10000000
anim = f6130 + floor(var(3) / 10000000) % 10
ID = 38
postype = left
pos = 146, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 152)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1
 
;========================< Sounds and Special Effects >========================

[state 6125, Increase Score Sound]
type = playsnd
trigger1 = var(3) && time >= 80
trigger1 = time % 2 = 0
value = f6130, 0
volumescale = 100

[state 6125, Increase Score]
type = varadd
trigger1 = var(3) && time >= 80
trigger1 = time % 2 = 0
var(3) = -100

[state 6125, End Score]
type = varadd
trigger1 = !var(3)
var(4) = 1

[state 6125, Still Selecting]
type = assertspecial
trigger1 = !numhelper(6005) && var(4) < 176
flag = roundnotover

;========================< Reset Score System >========================
 
[state 6125, Destroy Explod]
type = removeexplod
trigger1 = roundstate < 4
trigger2 = cond(numhelper(6005), helper(6005),var(2) >= 80, 0)
trigger3 = cond(numhelper(6130), helper(6130),var(2) >= 80, 0)
trigger4 = time >= 65535
 
[state 6125, Destroy Helper]
type = destroyself
trigger1 = roundstate < 4
 
;========================< Debug Information >========================
 
[state 6125, Display System]
type = displaytoclipboard
trigger1 = 1
text = "Bonus = %d / %d / %d / %d / %d || RajaaBoy \n"
params = var(0), var(1), var(2), var(3), var(4)
 
;=========================================================================
; Final Score
;=========================================================================
[Statedef 6130]
type = A
movetype = I
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -65536

;========================< Essential State Controllers >========================
 
[state 6130, Character Name]
type = null
trigger1 = name = "Jaan"
trigger1 = var(0) := 6010
trigger2 = name = "Sarkov"
trigger2 = var(0) := 6020
trigger3 = root, name = "Bullet"
trigger3 = var(0) := 6030
trigger4 = name = "Phoenix"
trigger4 = var(0) := 6040
trigger5 = name = "Frank"
trigger5 = var(0) := 6050
trigger6 = name = "Onimaru"
trigger6 = var(0) := 6060
trigger7 = name = "Lan"
trigger7 = var(0) := 6070
trigger8 = name = "Kim Tai Chi"
trigger8 = var(0) := 6080
trigger9 = name = "Widow"
trigger9 = var(0) := 6090
trigger10 = name = "Joker"
trigger10 = var(0) := 6100
trigger11 = name = "Red Man"
trigger11 = var(0) := 6110

[state 6130, Change Animation]
type = changeanim
trigger1 = anim != 9999
value = 9999

[state 6130, Background Effect]
type = allpalfx
trigger1 = var(2) < 80
trigger1 = var(2) := var(2) + 1
time = 1
mul = ceil(256 - 3.2 * var(2)), ceil(256 - 3.2 * var(2)), ceil(256 - 3.2 * var(2))
add = 0, 0, 0
color = 256
invertall = 0

[state 6130, Background Effect]
type = allpalfx
trigger1 = var(2) >= 80 && var(3) < 80
trigger1 = var(3) := var(3) + 1
time = 1
mul = ceil(3.2 * var(3)), ceil(3.2 * var(3)), ceil(3.2 * var(3))
add = 0, 0, 0
color = 256
invertall = 0

[state 6130, Press Start]
type = null
trigger1 = root,command = "start"
trigger1 = var(4) := 600
persistent = 0

[state 6130, Special Effect]
type = assertspecial
trigger1 = var(3) >= 0 && var(4) < 600
trigger1 = var(4) := var(4) + 1
flag = roundnotover

[state 6130, Special Effect]
type = assertspecial
trigger1 = var(3)
flag = globalnoshadow
flag2 = nobardisplay

[state 6005, Special Effect]
type = assertspecial
trigger1 = var(3)
flag = nofg
flag2 = nobg
flag3 = nomusic

[state 6130, Opaque]
type = envcolor
trigger1 = var(3)
value = 4, 2, 4
time = 1

[state 6130, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA

;========================< Initialize Score >========================

[state 6130, Calculate Score Bonus]
type = null
triggerall = !time
trigger1 = var(5) := root,var(18)

[state 6130, Length of Score]
type = null
trigger1 = var(06) := 0 || 1
trigger1 = var(06) := var(06) + (abs(var(5)) >= 1) + (abs(var(5)) >= 10) || 1
trigger1 = var(06) := var(06) + (abs(var(5)) >= 100) + (abs(var(5)) >= 1000) || 1
trigger1 = var(06) := var(06) + (abs(var(5)) >= 10000) + (abs(var(5)) >= 100000) || 1
trigger1 = var(06) := var(06) + (abs(var(5)) >= 1000000) + (abs(var(5)) >= 10000000) || 1
trigger1 = var(06) := var(06) * (var(07) := 12) / 2 || 1 ; var(07) is the spacing between characters

;========================< Display Score >========================

[state 6130, Reset]
type = removeexplod
trigger1 = 1
 
[state 6130, Increase Score Sound]
type = playsnd
trigger1 = var(4) - 160 = [1, var(6) * 2]
trigger1 = (var(4) - 160) % 12 = 0
value = f6130, 0
volumescale = 100

[state 6130, Ones]
type = explod
trigger1 = var(4) >= 160
trigger1 = !numexplod(1) && var(3) && cond(var(8) < 12, var(8) := var(8) + 1, 1)
anim = f6130 + floor(var(5) / 1) % 10
ID = 1
postype = left
pos = (160 + var(06)) - var(07) * numexplod, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = 1
facing = 1
ownpal = 0
ontop = 1
scale = 10.0 - 0.75 * var(8), 10.0 - 0.75 * var(8)
pausemovetime = -1
supermovetime = -1
 
[state 6130, Tens]
type = explod
trigger1 = var(4) >= 172
trigger1 = !numexplod(2) && var(3) && var(5) >= 10 && cond(var(9) < 12, var(9) := var(9) + 1, 1)
anim = f6130 + floor(var(5) / 10) % 10
ID = 2
postype = left
pos = (160 + var(06)) - var(07) * numexplod, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
scale = 10.0 - 0.75 * var(9), 10.0 - 0.75 * var(9)
pausemovetime = -1
supermovetime = -1
 
[state 6130, Hundreds]
type = explod
trigger1 = var(4) >= 184
trigger1 = !numexplod(3) && var(3) && var(5) >= 100 && cond(var(10) < 12, var(10) := var(10) + 1, 1)
anim = f6130 + floor(var(5) / 100) % 10
ID = 3
postype = left
pos = (160 + var(06)) - var(07) * numexplod, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
scale = 10.0 - 0.75 * var(10), 10.0 - 0.75 * var(10)
pausemovetime = -1
supermovetime = -1
 
[state 6130, Thousands]
type = explod
trigger1 = var(4) >= 196
trigger1 = !numexplod(4) && var(3) && var(5) >= 1000 && cond(var(11) < 12, var(11) := var(11) + 1, 1)
anim = f6130 + floor(var(5) / 1000) % 10
ID = 4
postype = left
pos = (160 + var(06)) - var(07) * numexplod, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
scale = 10.0 - 0.75 * var(11), 10.0 - 0.75 * var(11)
pausemovetime = -1
supermovetime = -1
 
[state 6130, Ten Thousands]
type = explod
trigger1 = var(4) >= 208
trigger1 = !numexplod(5) && var(3) && var(5) >= 10000 && cond(var(12) < 12, var(12) := var(12) + 1, 1)
anim = f6130 + floor(var(5) / 10000) % 10
ID = 5
postype = left
pos = (160 + var(06)) - var(07) * numexplod, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
scale = 10.0 - 0.75 * var(12), 10.0 - 0.75 * var(12)
pausemovetime = -1
supermovetime = -1
 
[state 6130, Hundred Thousands]
type = explod
trigger1 = var(4) >= 220
trigger1 = !numexplod(6) && var(3) && var(5) >= 100000 && cond(var(13) < 12, var(13) := var(13) + 1, 1)
anim = f6130 + floor(var(5) / 100000) % 10
ID = 6
postype = left
pos = (160 + var(06)) - var(07) * numexplod, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
scale = 10.0 - 0.75 * var(13), 10.0 - 0.75 * var(13)
pausemovetime = -1
supermovetime = -1
 
[state 6130, Millions]
type = explod
trigger1 = var(4) >= 232
trigger1 = !numexplod(7) && var(3) && var(5) >= 1000000 && cond(var(14) < 12, var(14) := var(14) + 1, 1)
anim = f6130 + floor(var(5) / 1000000) % 10
ID = 7
postype = left
pos = (160 + var(06)) - var(07) * numexplod, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
scale = 10.0 - 0.75 * var(14), 10.0 - 0.75 * var(14)
pausemovetime = -1
supermovetime = -1
 
[state 6130, Ten Millions]
type = explod
trigger1 = var(4) >= 244
trigger1 = !numexplod(8) && var(3) && var(5) >= 10000000 && cond(var(15) < 12, var(15) := var(15) + 1, 1)
anim = f6130 + floor(var(5) / 10000000) % 10
ID = 8
postype = left
pos = (160 + var(06)) - var(07) * numexplod, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 120)
bindtime = -1
facing = 1
ownpal = 0
ontop = 1
scale = 10.0 - 0.75 * var(15), 10.0 - 0.75 * var(15)
pausemovetime = -1
supermovetime = -1
 
[state 6130, Final Score]
type = explod
trigger1 = !numexplod(0) && var(3)
anim = f6140
ID = 0
postype = left
pos = 160 - 55, ceil((1.3333333333333333333333333333333 * gameheight / gamewidth) * 98)
bindtime = 1
facing = 1
ownpal = 0
ontop = 1
pausemovetime = -1
supermovetime = -1

;========================< Reset Score System >========================
 
[state 6130, Destroy Explod]
type = removeexplod
trigger1 = !matchover || roundstate < 4 || var(4) >= 680

[state 6130, Destroy Helper]
type = destroyself
trigger1 = !matchover || roundstate < 4

;=========================================================================
; Effects
;=========================================================================
[Statedef 7000]
type = A
movetype = I
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 4

[state 7000, Level, Parent State, Parent Animation Element(For Synch(10))]
type = null
trigger1 = !time
trigger1 = var(0) := parent,stateno || var(1) := parent,anim || var(11) := parent,animelemno(0) - 1

; Jaan
[state 7000, Anim(2), Pos X(3), Pos Y(4), Bind(5), Palette(6), Priority(7), Hitpause(8/9), Synch(10)]
type = null
triggerall = !time && name = "Jaan"
trigger1 = ishelper(1210)
trigger1 = var(2) := 1210 || var(3) := 0 || var(4) := 0 || var(5) := 1 || var(6) := -1 || var(7) := 4 || var(8) := 1 || var(10) := 1

; Phoenix
[state 7000, Anim(2), Pos X(3), Pos Y(4), Bind(5), Palette(6), Priority(7), Hitpause(8/9), Synch(10)]
type = null
triggerall = !time && name = "Phoenix"
trigger1 = ishelper(205)
trigger1 = var(2) := 205 || var(3) := 0 || var(4) := 0 || var(5) := 1 || var(6) := -1 || var(7) := 4 || var(8) := 1 || var(10) := 1
trigger2 = ishelper(235)
trigger2 = var(2) := 235 || var(3) := 0 || var(4) := 0 || var(5) := 1 || var(6) := -1 || var(7) := 4 || var(8) := 1 || var(10) := 1
trigger3 = ishelper(405)
trigger3 = var(2) := 405 || var(3) := 0 || var(4) := 0 || var(5) := 1 || var(6) := -1 || var(7) := 4 || var(8) := 1 || var(10) := 1
trigger4 = ishelper(1110)
trigger4 = var(2) := 1110 || var(3) := 0 || var(4) := 0 || var(5) := 1 || var(6) := -1 || var(7) := 4 || var(8) := 1 || var(10) := 1
trigger5 = ishelper(1305)
trigger5 = var(2) := 1305 || var(3) := 0 || var(4) := 0 || var(5) := 1 || var(6) := -1 || var(7) := 4 || var(8) := 1 || var(10) := 1
trigger6 = ishelper(1306)
trigger6 = var(2) := 1306 || var(3) := 0 || var(4) := 0 || var(5) := 1 || var(6) := -1 || var(7) := 4 || var(8) := 1 || var(10) := 1
trigger7 = ishelper(3015)
trigger7 = var(2) := 3015 || var(3) := 0 || var(4) := 0 || var(5) := 1 || var(6) := -1 || var(7) := 4 || var(8) := 1 || var(10) := 1

; Kim Tai Chi
[state 7000, Anim(2), Pos X(3), Pos Y(4), Bind(5), Palette(6), Priority(7), Hitpause(8/9), Synch(10)]
type = null
triggerall = !time && name = "Kim Tai Chi"
trigger1 = ishelper(1205)
trigger1 = var(2) := 1205 || var(3) := 0 || var(4) := 0 || var(5) := 1 || var(6) := -1 || var(7) := 4 || var(8) := 1 || var(10) := 1

; Widow
[state 7000, Anim(2), Pos X(3), Pos Y(4), Bind(5), Palette(6), Priority(7), Hitpause(8/9), Synch(10)]
type = null
triggerall = !time && name = "Widow"
trigger1 = ishelper(1005)
trigger1 = var(2) := 1005 || var(3) := 0 || var(4) := 0 || var(5) := 1 || var(6) := -1 || var(7) := 4 || var(8) := 1 || var(10) := 1

; Destroy on Hit
[state 7000, Destroy]
type = destroyself
triggerall = parent,movetype = H 
trigger1 = var(2) != -1

; Destroy at Beginning of State
[state 7000, Destroy]
type = destroyself
triggerall = parent,time <= 1 && time >= 1
trigger1 = var(2) != -1

; Destroy at end of Animation
[state 7000, Destroy]
type = destroyself
triggerall = !animtime
trigger1 = var(2) != -1

; Destroy on State or Anim Change
[state 7000, Destroy]
type = destroyself
triggerall = var(0) != parent,stateno || var(1) != parent,anim
trigger1 = var(2) != -1

; Destroy on Custom State
[state 7000, Destroy]
type = null ; destroyself
triggerall = !root,var(39)
trigger1 = var(2) != -1

[state 7000, Palette]
type = remappal
trigger1 = var(6) >= 0
source = 7000, 0
dest = 7000, var(6)
persistent = 0

[state 7000, Parent Bind]
type = bindtoparent
trigger1 = parent,stateno = var(0)
trigger1 = cond(var(5) > 0, 1, !time)
pos = var(3) + parent,vel x, var(4)

[state 7000, Change Animation]
type = changeanim
trigger1 = !time
value = var(2)

[state 7000, Synchronization]
type = changeanim
trigger1 = var(0) = parent,stateno && var(1) = parent,anim
trigger1 = var(10) > 0
trigger1 = animelemtime(animelemno(0) + 1) < 0
value = var(2)
elem = parent,animelemno(0) - var(11)

[state 7000, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 7000, Priority]
type = sprpriority
trigger1 = 1
value = var(7)

[state 7000, Hitpause]
type = varset
trigger1 = var(8) > 0
trigger1 = !parent,hitpausetime
var(9) = animelemno(0)

[state 7000, Hitpause]
type = changeanim
trigger1 = var(8) > 0
trigger1 = parent,hitpausetime
value = anim
elem = var(9)

;=========================================================================
[StateDef -2]

;=========================================================================
; Precaching
;=========================================================================

[state -2, Precaching: Control Time]
type = varset
trigger1 = !var(22)
trigger1 = roundstate = 2 && ctrl
var(22) = 1
ignorehitpause = 1

[state -2, Precaching: Control Time]
type = varset
trigger1 = roundstate != 2
trigger2 = life <= 0 || p2life <= 0
var(22) = 0
ignorehitpause = 1

[state -2, Precaching: Game Time]
type = varset
trigger1 = var(22)
fvar(7) = fvar(7) + 0.01666666666666666666666666666667
ignorehitpause = 1

;=========================================================================
; System Helpers
;=========================================================================

[state -2, System Helper]
type = helper
trigger1 = !numhelper(6000)
name = "System"
ID = 6000
stateno = 6000
postype = p1
ownpal = 0
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 0
pausemovetime = 0
ignorehitpause = 1

[state -2, Display Score]
type = helper
trigger1 = win && !numhelper(6125)
trigger1 = teamside = 1 && !ishometeam
trigger1 = stateno = 180 && time > 144
name = "Display Score"
ID = 6125
stateno = 6125
postype = left
ownpal = 0
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 0
pausemovetime = 0
ignorehitpause = 1

[state -2, Final Score]
type = null ; helper
trigger1 = matchover && win && !numhelper(6130)
trigger1 = teamside = 1 && !ishometeam && matchno = 11
trigger1 = cond(numhelper(6125), helper(6125),var(4) >= 176, 1)
trigger1 = stateno = 180 && time > 200
name = "Final Score"
ID = 6130
stateno = 6130
postype = left
ownpal = 0
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 0
pausemovetime = 0
ignorehitpause = 1

[state -2, Match Results]
type = helper
trigger1 = matchover && win && !numhelper(6005)
trigger1 = cond(numhelper(6125), helper(6125),var(4) >= 176, 1)
trigger1 = cond(numhelper(6130), helper(6130),var(4) >= 600, 1)
trigger1 = stateno = 180 && time > 200
name = "Match Results"
ID = 6005
stateno = 6005
postype = left
ownpal = 0
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 0
pausemovetime = 0
ignorehitpause = 1

[state -2, Pause Screen Helper]
type = helper
trigger1 = !ailevel && roundstate = 2 && var(22)
trigger1 = cond(numenemy, !numhelper(6020), 0) && !numhelper(6020)
trigger1 = !numhelper(6005) && !numhelper(6125) && !numhelper(6130)
trigger1 = command = "start" 
name = "Pause Screen Helper"
ID = 6020
stateno = 6020
postype = left
facing = 1
ownpal = 0
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 0
pausemovetime = 0
ignorehitpause = 1

;=========================================================================
; Hit Sounds
;=========================================================================

[state -2, Detect Contact]
type = varset
trigger1 = var(0) < 0
trigger1 = movecontact = 1
var(0) = hitpausetime
ignorehitpause = 1

[state -2, Hit Sound]
type = playsnd
trigger1 = var(0) = hitpausetime
trigger1 = var(1) >= 0 || var(2) >= 0
trigger1 = movecontact = 1
value = f200, cond(movehit, var(1), var(2))
channel = 2
ignorehitpause = 1

[state -2, Reset]
type = varset
trigger1 = 1
var(0) = -1

[state -2, Reset]
type = varrangeset
trigger1 = movetype = I
trigger2 = movetype = H
trigger2 = time
first = 0
last = 2
value = -1
ignorehitpause = 1

;=========================================================================
; Juggle
;=========================================================================

[state -2, Ignore Engine's Juggle]
type = assertspecial
trigger1 = 1
flag = nojugglecheck
ignorehitpause = 1

[state -2, Detect Juggles]
type = varadd
trigger1 = movehit = 1
trigger1 = hitdefattr != SCA,AT
var(3) = 1

[state -2, Single Reset]
type = varset
triggerall = var(3) && numenemy
triggerall = enemy,stateno != 5040 || enemy,stateno = 5040 && enemy,time > 12
trigger1 = enemy,movetype != H || enemy,ctrl
trigger2 = enemy,stateno = [5110, 5150]
trigger3 = enemy,statetype != A && enemy,statetype != L
var(3) = 0
ignorehitpause = 1

[state -2, Restrict Juggle]
type = varset
triggerall = numenemy
trigger1 = enemy,stateno = 5040 && enemy,time > 12 && !enemy,ctrl
trigger2 = enemy,fvar(3) >= 40.0 || enemy,var(10)
var(4) = 1
ignorehitpause = 1

[state -2, Single Unrestrict Juggle]
type = varset
triggerall = var(4) && numenemy
triggerall = enemy,fvar(3) < 40.0 || !enemy,var(10) || enemy,stateno = 5120
trigger1 = enemy,stateno != 5040 && enemy,movetype != H
trigger2 = enemy,statetype = L || !enemy,hitshakeover || enemy,ctrl
trigger3 = enemy,stateno = 5300
; trigger4 = enemy,stateno != 5040 && enemy,movetype != H
; trigger4 = enemy,fvar(3) < 40.0 || !enemy,var(10)
var(4) = 0
ignorehitpause = 1

[state -2, Infinite Juggle]
type = varset
trigger1 = roundstate > 2
var(3) = (var(4) := 0)

;=========================================================================
; Dampener
;=========================================================================

[state -2, Detect Hits]
type = varadd
trigger1 = movehit = 1
trigger1 = !(hitdefattr = SCA,AT)
var(5) = 1

[state -2, Reset Hits]
type = varset
trigger1 = var(5)
trigger1 = numenemy
trigger1 = enemy,movetype != H
trigger1 = enemy,anim != 5300
var(5) = 0
ignorehitpause = 1

[state -2, Initialize Dampener]
type = varset
trigger1 = stateno != [3000, 3999]
fvar(1) = cond(var(5) <= 1, 1.0, 0.75 ** var(5))
ignorehitpause = 1

[state -2, Restrict Dampener]
type = varset
trigger1 = fvar(1) < 0
fvar(1) = 0.0
ignorehitpause = 1

;=========================================================================
; Dizzy Points
;=========================================================================

[state -2, Dizzy Points: Initialize Stun Bar]
type = varset
trigger1 = roundstate < 2
fvar(3) = 0.0 + 0 * (var(10) := 0)
ignorehitpause = 1

[state -2, Dizzy Points: Increment Stun Endurance by Damage]
type = varadd
trigger1 = alive && roundstate = 2
trigger1 = movetype = H && stateno != [120, 165]
trigger1 = var(20) - life > 0 && gethitvar(fall.envshake.phase) > 0
fvar(3) = gethitvar(fall.envshake.phase)
ignorehitpause = 1

[state -2, Dizzy Points: Decrement Stun Bar]
type = varadd
trigger1 = !gethitvar(hitshaketime)
trigger1 = fvar(3) = (0.0, 40.0)
trigger1 = gametime % 60 = 0
fvar(3) = -1.0
ignorehitpause = 1

[state -2, Dizzy Points: Initialize Stun Flag]
type = varset
trigger1 = stateno != 5300
trigger1 = fvar(3) >= 40.0 && !var(10)
var(10) = 1
ignorehitpause = 1

[state -2, Dizzy Points: Reset Time Since Last Hit]
type = varset
trigger1 = var(21)
trigger1 = alive && roundstate = 2
trigger1 = movetype = H && stateno != [120, 165]
trigger1 = var(20) - life > 0 && gethitvar(fall.envshake.phase) > 0
var(21) = 0
ignorehitpause = 1

[state -2, Dizzy Points: Time Since Last Hit]
type = varadd
trigger1 = var(21) < 300
trigger1 = fvar(3) = (0.0, 40.0)
trigger1 = movetype != H
var(21) = 1
ignorehitpause = 1

[state -2, Dizzy Points: Reset Dizzy Points]
type = varset
trigger1 = var(21) >= 300
fvar(3) = 0.0 + 0 * (var(10) := 0)
ignorehitpause = 1

[state -2, Dizzy Points: Prevent Dizzy Points from Going out of Bounds]
type = varset
trigger1 = fvar(3) != [0.0, 40.0]
fvar(3) = cond(fvar(3) < 0.0, 0.0, 40.0)
ignorehitpause = 1

;=========================================================================
; Directional Charge Buffering
;=========================================================================

[state -2, Horizontal Charge]
type = varadd
trigger1 = !ailevel
trigger1 = p2dist x >= 0 && command = "holdback" || p2dist x < 0 && command = "holdfwd"
trigger2 = ailevel
var(6) = 1

[state -2, Reset Horizontal Charge (Human)]
type = varset
triggerall = !ailevel
trigger1 = p2dist x >= 0 && command != "holdback"
trigger2 = p2dist x < 0 && command != "holdfwd"
var(6) = 0

[state -2, Reset Horizontal Charge (AI)]
type = varset
triggerall = ailevel
trigger1 = stateno = 0 || stateno = 20 && anim = 20
trigger2 = stateno = 40 && sysvar(1) != -1
trigger3 = time <= 1 && stateno % 100 = 0 && stateno = [1000, 3999]
var(6) = 0

[state -2, Horizontal Charge Buffer Time]
type = null
trigger1 = var(6) >= 48
trigger1 = var(7) := 32
trigger2 = var(6) < 48 && var(7)
trigger2 = var(7) := var(7) - 1

[state -2, Vertical Charge]
type = varadd
trigger1 = !ailevel
trigger1 = command = "holddown"
trigger2 = ailevel
var(8) = 1

[state -2, Reset Vertical Charge (Human)]
type = varset
trigger1 = !ailevel
trigger1 = command != "holddown"
var(8) = 0

[state -2, Reset Vertical Charge (AI)]
type = varset
triggerall = ailevel
trigger1 = stateno = 0 || stateno = 20 || stateno = 40 && time <= 1
trigger2 = (stateno = [1000, 3999]) && time <= 1
trigger3 = (stateno = [120, 155]) && statetype != C
var(8) = 0

[state -2, Vertical Charge Buffer Time]
type = null
trigger1 = var(8) >= 48
trigger1 = var(9) := 32
trigger2 = var(8) < 48 && var(9)
trigger2 = var(9) := var(9) - 1

;=========================================================================
; Results Statistics
;=========================================================================

[state -2, Match Statistics]
type = varset
trigger1 = lose && !var(11)
var(11) = 1
ignorehitpause = 1

[state -2, Match Statistics]
type = varset
trigger1 = win && var(11) = 1
trigger1 = life < lifemax * 0.2
var(11) = 2
ignorehitpause = 1

;=========================================================================
; Score Statistics
;=========================================================================

[state -2, Score System: Limit Score]
type = varset
trigger1 = var(18) != [0, 99999999]
var(18) = cond(var(18) > 99999999, 99999999, 0)
ignorehitpause = 1

;=========================================================================
; Attack and Projectile Scope
;=========================================================================

; Attack Scope Values (These values give general range identifiers to attacks to allow AI's to respond to attacks accordingly)
; 1 = Low
; 2 = Middle
; 3 = High
; 4 = Low and Middle
; 5 = Low and High
; 6 = Middle and High
; 7 = All (Grounded)
; 8 = Arbitrary Air Attack
[state -2, Scope: Attack Scope]
type = varset
trigger1 = 1
var(12) = 0

[state -2, Scope: Attack Distance]
type = varset
trigger1 = 1
var(13) = 0

[state -2, Scope: Projectile Reset]
type = varset
trigger1 = 1
var(14) = 0
ignorehitpause = 1

[state -2, Scope: Projectile Detect]
type = null
trigger1 = numhelper(1) ; Low Scope
trigger1 = helper(1),stateno % 5 != 3
trigger1 = var(14) := 1
trigger2 = numhelper(2) ; Middle Scope
trigger2 = helper(2),stateno % 5 != 3
trigger2 = var(14) := 2
trigger3 = numhelper(3) ; High Scope
trigger3 = helper(3),stateno % 5 != 3
trigger3 = var(14) := 3
trigger4 = numhelper(4) ; Low and Middle Scope
trigger4 = helper(4),stateno % 5 != 3
trigger4 = var(14) := 4
trigger5 = numhelper(5) ; Low and High Scope
trigger5 = helper(5),stateno % 5 != 3
trigger5 = var(14) := 5
trigger6 = numhelper(6) ; Middle and High Scope
trigger6 = helper(6),stateno % 5 != 3
trigger6 = var(14) := 6
trigger7 = numhelper(7) ; All Scope
trigger7 = helper(7),stateno % 5 != 3
trigger7 = var(14) := 7
trigger8 = numhelper(8) ; Shockwave
trigger8 = helper(8),stateno % 5 != 3
trigger8 = var(14) := 8
ignorehitpause = 1

[state -2, Scope: Projectile Distance]
type = varset
trigger1 = numhelper(1)
fvar(6) = (helper(1),pos x - enemy,pos x) * enemy,facing
ignorehitpause = 1

[state -2, Scope: Projectile Distance]
type = varset
trigger1 = numhelper(2)
fvar(6) = (helper(2),pos x - enemy,pos x) * enemy,facing
ignorehitpause = 1

[state -2, Scope: Projectile Distance]
type = varset
trigger1 = numhelper(3)
fvar(6) = (helper(3),pos x - enemy,pos x) * enemy,facing
ignorehitpause = 1

[state -2, Scope: Projectile Distance]
type = varset
trigger1 = numhelper(4)
fvar(6) = (helper(4),pos x - enemy,pos x) * enemy,facing
ignorehitpause = 1

[state -2, Scope: Projectile Distance]
type = varset
trigger1 = numhelper(5)
fvar(6) = (helper(5),pos x - enemy,pos x) * enemy,facing
ignorehitpause = 1

[state -2, Scope: Projectile Distance]
type = varset
trigger1 = numhelper(6)
fvar(6) = (helper(6),pos x - enemy,pos x) * enemy,facing
ignorehitpause = 1

[state -2, Scope: Projectile Distance]
type = varset
trigger1 = numhelper(7)
fvar(6) = (helper(7),pos x - enemy,pos x) * enemy,facing
ignorehitpause = 1

;=========================================================================
; Gameplay Functions -2
;=========================================================================

[state -2, Functions: Shadow]
type = varset
trigger1 = 1
var(16) = 0

[state -2, Functions: No Air Guard]
type = assertspecial
trigger1 = 1
flag = noairguard
ignorehitpause = 1

[state -2, Functions: No AI Guard]
type = assertspecial
trigger1 = ailevel
flag = nostandguard
flag2 = nocrouchguard
ignorehitpause = 1

[state -2, Functions: Target Facing]
type = targetfacing
trigger1 = numtarget = 1 && movecontact = 1
trigger1 = !target,hitshakeover && !target,hitfall && !target,time
value = cond(((target,pos x - pos x) * facing) >= 0, -1, 1)
ignorehitpause = 1

[state -2, Functions: Afterimage Cancel]
type = afterimagetime
trigger1 = movetype = H || stateno != [3000, 3999]
time = 0
ignorehitpause = 1

[state -2, Functions: Width]
type = posadd
trigger1 = numhelper(6010)
trigger1 = helper(6010),var(0)
trigger1 = frontedgebodydist < helper(6010),var(0)
x = frontedgebodydist - helper(6010),var(0)
ignorehitpause = 1

[state -2, Functions: Death Sound]
type = helper
trigger1 = !alive
trigger1 = !numhelper(6015)
name = "Death Sound"
ID = 6015
stateno = 6015
postype = p1
supermovetime = 65536
pausemovetime = 65536
ignorehitpause = 1

[state -2, Functions: Stop Voice]
type = stopsnd
trigger1 = !alive
trigger1 = numhelper(6015)
trigger1 = helper(6015),time <= 1
channel = 0
ignorehitpause = 1

[state -2, Functions: Stop Dizzy]
type = stopsnd
trigger1 = stateno != 5300
channel = 3
ignorehitpause = 1

;=========================================================================
; Characters' Unique Gameplay Functions -2
;=========================================================================

; Widow
[state -2, Cheap KO]
type = changestate
trigger1 = name = "Widow" && !alive
trigger1 = stateno = [5000, 5010]
trigger1 = (prevstateno = [120, 121]) || (prevstateno = [130, 131]) || (prevstateno = [140, 141]) || (prevstateno = [150, 153])
value = 5950
ignorehitpause = 1

;=========================================================================
; Display Status
;=========================================================================

[state -2, Status: Measure Damage]
type = varset
trigger1 = 1
var(20) = life
ignorehitpause = 1

[state -2, Status: System]
type = displaytoclipboard
trigger1 = authorname = "Super Fighter Team"
text = "Juggle = %d/%d | Score = %d/%d  | Dizzy = %f/%d \n"
params = var(3), var(4), var(18), var(19), fvar(3), var(10)
ignorehitpause = 1

[state -2, Status: System]
type = appendtoclipboard
trigger1 = authorname = "Super Fighter Team"
text = "Horizontal = %d/%d | Vertical = %d/%d | Results = %d"
params = var(6), var(7), var(8), var(9), var(11)
ignorehitpause = 1

;=========================================================================
[StateDef -3]

;=========================================================================
; CornerPush
;=========================================================================

[state -3, CornerPush: Reset]
type = varset
triggerall = fvar(2)
trigger1 = numtarget
trigger1 = target,hitover || target,gethitvar(hitshaketime) > 0 && target,time <= 0
trigger2 = abs(fvar(2)) <= 1.0 / const(movement.stand.friction)
fvar(2) = 0

[state -3, Initialize Cornerpush]
type = varset
trigger1 = numtarget && movecontact = 1
; Modify the right side of the equation for more intense or less intense cornerpush.
; target,gethitvar(xvel) * 0.0 disbales cornerpush.
; target,gethitvar(xvel) * 1.0 stabalizes cornerpush.
; target,gethitvar(xvel) * 2.0 doubles scornerpush.
fvar(2) = target,gethitvar(xvel) * 1.25
ignorehitpause = 1

[state -3, Activate Cornerpush]
type = posadd
triggerall = fvar(2) && numtarget
triggerall = !hitpausetime && target,gethitvar(hitshaketime) <= 0
triggerall = !target,gethitvar(fall)
trigger1 = target,frontedgebodydist <= abs(target,vel x + target,const(size.ground.front))
trigger1 = target,gethitvar(xvel) * target,facing > 0.0
trigger2 = target,backedgebodydist <= abs(target,vel x + target,const(size.ground.back))
trigger2 = target,gethitvar(xvel) * target,facing < 0.0
x = -abs(fvar(2))

[state -3, Cornerpush Friction]
type = varset
trigger1 = numtarget
trigger1 = target,gethitvar(hitshaketime) <= 0
fvar(2) = fvar(2) * const(movement.stand.friction)

;=========================================================================
; Gameplay Functions -3
;=========================================================================

[state -3, Functions: Jump Suspension]
type = varset
triggerall = var(15)
trigger1 = roundstate < 2 || stateno != 50 && stateno != [600, 635]
trigger2 = statetype != A || movetype = H || stateno = [5000, 5900]
var(15) = 0

[state -3, Functions: Jump Suspension]
type = varset
triggerall = fvar(5)
trigger1 = roundstate < 2 || stateno != 50 && stateno != [600, 635]
trigger2 = statetype != A || movetype = H || stateno = [5000, 5900]
fvar(5) = 0

[state -3, Functions: Jump Suspension]
type = velmul
trigger1 = statetype = A && movetype != H
trigger1 = var(15) > 0 && fvar(5) < 0
trigger1 = vel y = [fvar(5) * 0.25, -fvar(5) * 0.25]
trigger1 = var(15) := var(15) - 1
y = 0.1

;=========================================================================
; Afterimage Management
;=========================================================================

[state -3, Afterimage: Super]
type = afterimage
trigger1 = numhelper(6120) && stateno = [3000, 3999]
trigger1 = stateno % 100 = 0 || stateno % 100 = 50
trigger1 = helper(6120),time <= 1
time = 4
length = 12
timegap = 1
framegap = 4
palcolor = 256
palinvertall = 0
palbright = 0, 0, 0
palcontrast = 128, 128, 128
palpostbright = 0, 0, 0
paladd = 0, 0, 0
palmul = 1.0, 1.0, 1.0
trans = add1
ignorehitpause = 1

[state -3, Afterimage: Time]
type = afterimagetime
trigger1 = stateno = [3000, 3999]
time = 2
ignorehitpause = 1

;=========================================================================
; Super Effect -3
;=========================================================================

[state -3, Background Effect]
type = bgpalfx
triggerall = numenemy
triggerall = enemy,time <= 1 && enemy,movetype = H
trigger1 = stateno = [3000, 3999]
trigger1 = movehit = 1
trigger2 = numhelper(var(14))
trigger2 = helper(var(14)),stateno = [3000, 3999]
trigger2 = helper(var(14)),numtarget && helper(var(14)),stateno % 5 = 1
trigger2 = helper(var(14)),time <= 1 && helper(var(14)),movehit
time = 4
color = 256
invertall = 1
ignorehitpause = 1