; Super Fighter Team

;=========================================================================
; Rolling Kick
;=========================================================================
[Statedef 1000]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1000, Change Animation]
type = changeanim
trigger1 = !time
value = 1000

[state 1000, Invulnerability]
type = nothitby
trigger1 = animelemtime(10) < 0
value = ,AT
time = 1

[state 1000, Set State Type]
type = statetypeset
trigger1 = animelemtime(8) >= 0
statetype = A
persistent = 0

[state 1000, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f2, 0
volumescale = 100
channel = 0

[state 1000, Sound]
type = playsnd
trigger1 = !animelemtime(8)
value = f100, 0
volumescale = 100
channel = 1

[state 1000, Increment Position]
type = posadd
trigger1 = !animelemtime(8) || !animelemtime(10)
y = -16.0

[state 1000, Set Velocity]
type = velset
trigger1 = !animelemtime(1)
x = 4.6875

[state 1000, Set Velocity]
type = velset
trigger1 = !animelemtime(8)
x = 2.05078125
y = -2.05078125

[state 1000, Increment Velocity]
type = veladd
trigger1 = animelemtime(8) > 0
y = 0.6796875 * 0.5 ; const(movement.yaccel) * 0.5

[state 1000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 4 * (animelemno(0) = [2, 7]) + 6 * (animelemno(0) = [8, 9]) || var(13) := 32 + 48 * (animelemtime(8) >= 0)

[state 1000, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(animelemno(0)) && animelemno(0) % 2 = 1 && animelemno(0) = [2, 7]
ID = 2
attr = S, SA
damage = 8, 1
fall.envshake.phase = 8 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -8 - random % 40
animtype = hard
ground.type = low
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 9
guard.hittime = 9
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 4, 4
givepower = 2, 2
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1000, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(9)
ID = 2
attr = A, SA
damage = 8, 1
fall.envshake.phase = 8 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -72
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 9
guard.hittime = 9
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 4, 4
givepower = 2, 2
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = back

[state 1000, Idle]
type = statetypeset
trigger1 = animelemtime(10) >= 0
movetype = I
persistent = 0

[state 1000, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 1005
ctrl = 0

;=========================================================================
; Land
;=========================================================================
[Statedef 1005]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 1005, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1005, Change Animation]
type = changeanim
trigger1 = !time
value = 1005

[state 1005, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Dragonfly Dip
;=========================================================================
[Statedef 1100]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1100, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1100, Change Animation]
type = changeanim
trigger1 = !time
value = 1100

[state 1100, Set State Type]
type = statetypeset
trigger1 = animelemtime(1) >= 0
statetype = A
persistent = 0

[state 1100, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f2, 0
volumescale = 100
channel = 0

[state 1100, Sound]
type = playsnd
trigger1 = !animelemtime(9)
value = f100, 0
volumescale = 100
channel = 1

[state 1100, Increment Position]
type = posadd
trigger1 = !animelemtime(1)
y = -16.0

[state 1100, Freeze Position]
type = posfreeze
trigger1 = animelemtime(9) >= 0 && animelemtime(11) < 0
value = 1

[state 1100, Set Velocity]
type = velset
trigger1 = !animelemtime(1)
x = 5.46875
y = -8.59375

[state 1100, Freeze Position]
type = velset
trigger1 = !animelemtime(9)
x = vel x * 0.1
y = 0.0

[state 1100, Increment Velocity]
type = veladd
trigger1 = animelemtime(1) > 0 && animelemtime(9) != [0, 8]
y = 0.42650390625 * (animelemtime(11) < 0) + 0.5859375 * (animelemtime(11) >= 0)

[state 1100, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 3 || var(13) := 56

[state 1100, Attack Distance]
type = attackdist
trigger1 = !animelemtime(1) || !animelemtime(9)
value = 0 + const(size.attack.dist) * !animelemtime(9)

[state 1100, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(10)
ID = 2
attr = A, SA
damage = 30, 2
fall.envshake.phase = 30 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -64
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = cond(p2dist x < 0, 7.8125, -7.8125)
guard.velocity = cond(p2dist x < 0, 7.8125, -7.8125)
air.velocity = cond(p2dist x < 0, 2.34375, -2.34375), -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1100, Idle]
type = statetypeset
trigger1 = animelemtime(11) >= 0
movetype = I
persistent = 0

[state 1100, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 1105
ctrl = 0

;=========================================================================
; Land
;=========================================================================
[Statedef 1105]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 1105, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1105, Change Animation]
type = changeanim
trigger1 = !time
value = 1105

[state 1105, Control]
type = ctrlset
trigger1 = !time
value = 1

[state 1105, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Spinning Kicks
;=========================================================================
[Statedef 1200]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1200, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1200, Change Animation]
type = changeanim
trigger1 = !time
value = 1200

[state 1200, Shadow]
type = varset
trigger1 = 1
var(16) = 20 * (animelemtime(5) >= 0) - 6 * (animelemtime(8) >= 0)

[state 1200, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f2, 0
volumescale = 100
channel = 0

[state 1200, Sound]
type = playsnd
trigger1 = !animelemtime(2) || !animelemtime(6)
value = f100, 0
volumescale = 100
channel = 1

[state 1200, Increment Position]
type = posadd
trigger1 = !animelemtime(5)
x = 16.0

[state 1200, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 2 || var(13) := 56 + 16 * (animelemtime(5) >= 0)

[state 1200, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(3)
ID = 2
attr = S, SA
damage = 15, 1
fall.envshake.phase = 15 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1200, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(7)
ID = 2
attr = S, SA
damage = 15, 1
fall.envshake.phase = 15 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -64
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1200, Idle]
type = statetypeset
trigger1 = animelemtime(8) >= 0
movetype = I
persistent = 0

[state 1200, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1