; Super Fighter Team

;=========================================================================
; Dragon Revenge
;=========================================================================
[Statedef 3000]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 1

[state 3000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3000, Change Animation]
type = changeanim
trigger1 = !time
value = 3000

[state 3000, Add Power]
type = poweradd
trigger1 = !time
value = -power

[state 3000, Super Config]
type = helper
trigger1 = !animelemtime(1)
name = "Super Config"
id = 6120
stateno = 6120
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 65536
pausemovetime = 65536

[state 3000, Super Pause]
type = superpause
trigger1 = !animelemtime(1)
time = 48
movetime = 48
unhittable = 1
anim = -1
sound = -1
p2defmul = 1
poweradd = 0
darken = 0

[state 3000, Invulnerability]
type = nothitby
trigger1 = animelemtime(1) <= 48
value = SCA
time = 12

[state 3000, Set State Type]
type = statetypeset
trigger1 = animelemtime(15) >= 0
statetype = A
physics = N
persistent = 0

[state 3000, Voice]
type = playsnd
trigger1 = !animelemtime(2) ; || !animelemtime(5) 
; trigger2 = !animelemtime(10) || !animelemtime(13)
value = f0, 0
volumescale = 100
channel = 0

[state 3000, Voice]
type = playsnd
trigger1 = !animelemtime(13)
value = f4, 0
volumescale = 100
channel = 0

[state 3000, Sound]
type = playsnd
trigger1 = !animelemtime(2) || !animelemtime(5) 
trigger2 = !animelemtime(10) || !animelemtime(13)
value = f100, 0
volumescale = 100
channel = 1

[state 3000, Increment]
type = posadd
trigger1 = animelemno(0) = 2 || (animelemno(0) = [4, 5]) || animelemno(0) = 7
trigger2 = (animelemno(0) = [9, 10]) || (animelemno(0) = [12, 13])
x = 2.0

[state 3000, Increment]
type = posadd
trigger1 = !animelemtime(2) || !animelemtime(5) || !animelemtime(7)
trigger2 = !animelemtime(10) || !animelemtime(13)
x = 16.0

[state 3000, Increment Position]
type = posadd
trigger1 = !animelemtime(15)
x = 24.0

[state 3000, Set Velocity]
type = velset
trigger1 = !animelemtime(15)
x = 6.25
y = -8.59375

[state 3000, Increment Velocity]
type = veladd
trigger1 = animelemtime(15) > 0 && animelemtime(15) <= 20
x = -0.3125
y = 0.4296875

[state 3000, Set Velocity]
type = velset
trigger1 = animelemtime(15) = 20
x = 0.0
y = 0.0

[state 3000, Set Velocity]
type = velset
trigger1 = !animelemtime(17)
x = 0.5859375

[state 3000, Increment Velocity]
type = veladd
trigger1 = animelemtime(17) > 0
y = const(movement.yaccel)

[state 3000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 7 || var(13) := 64

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(3)
ID = 3
attr = S, HA
damage = 10, 1
fall.envshake.phase = 3 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 8, 8
guard.pausetime = 8, 8
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -64
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -3.90625
guard.velocity = -3.90625
air.velocity = -3.125, -3.515625
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(5)
ID = 3
attr = S, HA
damage = 10, 1
fall.envshake.phase = 3 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 8, 8
guard.pausetime = 8, 8
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -56
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -3.90625
guard.velocity = -3.90625
air.velocity = -3.125, -3.515625
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(8)
ID = 3
attr = S, HA
damage = 10, 1
fall.envshake.phase = 3 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 8, 8
guard.pausetime = 8, 8
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -80
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -3.90625
guard.velocity = -3.90625
air.velocity = -3.125, -3.515625
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(11)
ID = 3
attr = S, HA
damage = 10, 1
fall.envshake.phase = 3 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 8, 8
guard.pausetime = 8, 8
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -64
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -3.90625
guard.velocity = -3.90625
air.velocity = -3.125, -3.515625
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(14)
ID = 3
attr = S, HA
damage = 10, 1
fall.envshake.phase = 3 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -64
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -2.34375, -8.59375
guard.velocity = -3.90625
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 1
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(16)
ID = 3
attr = S, HA
damage = 10, 1
fall.envshake.phase = 3 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -64
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -4.296875, -6.25
guard.velocity = -7.8125
air.velocity = -4.296875, -6.25
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 1
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Idle]
type = statetypeset
trigger1 = animelemtime(17) >= 0
movetype = I
persistent = 0

[state 3000, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 3005
ctrl = 0

;=========================================================================
; Land
;=========================================================================
[Statedef 3005]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 3005, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3005, Change Animation]
type = changeanim
trigger1 = !time
value = 3005

[state 3005, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1