; Super Fighter Team

;=========================================================================
; Hair Whip
;=========================================================================
[Statedef 1000]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1000, Change Animation]
type = changeanim
trigger1 = !time
value = 1000

[state 1000, Shadow]
type = varset
trigger1 = 1
var(16) = 16 * (animelemtime(1) >= 0) + 16 * (animelemtime(2) >= 0) - 16 * (animelemtime(4) >= 0)

[state 1000, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f9, 0
volumescale = 100
channel = 0

[state 1000, Sound]
type = playsnd
trigger1 = !animelemtime(2)
value = f100, 0
volumescale = 100
channel = 1

[state 1000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 2 || var(13) := 120

[state 1000, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(3)
ID = 2
attr = S, SA
damage = 22, 1
fall.envshake.phase = 22 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1000, Idle]
type = statetypeset
trigger1 = animelemtime(4) >= 0
movetype = I
persistent = 0

[state 1000, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Queue Attack
;=========================================================================
[Statedef 1100]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1100, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1100, Change Animation]
type = changeanim
trigger1 = !time
value = 1100

[state 1100, Shadow]
type = varset
trigger1 = 1
var(16) = 16 * (animelemtime(1) >= 0) + 16 * (animelemtime(2) >= 0) - 16 * (animelemtime(4) >= 0)

[state 1100, Sound]
type = playsnd
trigger1 = !animelemtime(1) || !animelemtime(3) || !animelemtime(5)
value = f100, 0
volumescale = 100
channel = 1

[state 1100, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 7 || var(13) := 48

[state 1100, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(animelemno(0)) && animelemno(0) % 2 = 0
ID = 2
attr = S, SA
damage = 16, 2
fall.envshake.phase = 16 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -40
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -5.2083333333333333333333333333333
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1100, Idle]
type = statetypeset
trigger1 = animelemtime(7) >= 0
movetype = I
persistent = 0

[state 1100, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Toad Breath
;=========================================================================
[Statedef 1200]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 0

[state 1200, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1200, Change Animation]
type = changeanim
trigger1 = !time
value = 1200

[state 1200, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f9, 1
volumescale = 100
channel = 0

[state 1200, Stink Breath]
type = helper
trigger1 = !animelemtime(2)
name = "Stink Breath"
ID = 2
stateno = 1205
postype = p1
pos = 40, -56
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 1200, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 0 || var(13) := 80

[state 1200, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 1200, Idle]
type = statetypeset
trigger1 = animelemtime(2) >= 16
movetype = I
persistent = 0

[state 1200, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Proj Start
;=========================================================================
[Statedef 1205]
type = S
movetype = A
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 4

[state 1205, Juggling and Dampener]
type = null
trigger1 = var(3) := root,var(3) || var(4) := root,var(4) || fvar(1) := root,fvar(1)

[state 1205, Change Animation]
type = changeanim
trigger1 = !time
value = 1205

[state 1205, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 1205, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NP,SP,HP
time = -1

[state 1205, Hit Override]
type = hitoverride
trigger1 = 1
attr = SCA,NP,SP,HP
stateno = 1207
slot = 0
time = -1
forceair = 0

[state 1205, Set Velocity]
type = velset
trigger1 = !time
x = 3.515625
y = 0.0

[state 1205, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 1205, Miss]
type = hitdef
trigger1 = 1
attr = S, SP
hitflag = 

[state 1205, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
ID = 2
attr = S, SP 
damage = 16, 2
fall.envshake.phase = 16 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 0, 6
guard.pausetime = 1, 1
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = -1 ; 195 + 5 * teamside
guard.sparkno = -1 ; 195 + 5 * teamside
sparkxy = 0, 0
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -6.8359375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = back
; forcestand = 1
p2facing = p2statetype != A

[state 1205, End State]
type = changestate
trigger1 = movecontact || movereversed
value = stateno + 1
ignorehitpause = 1

[state 1205, Destroy Helper]
type = destroyself
trigger1 = frontedgedist <= -96

;=========================================================================
; Proj Contact
;=========================================================================
[Statedef 1206]
type = S
movetype = A
physics = N
ctrl = 0
movehitpersist = 1

[state 1206, Juggle]
type = parentvaradd
trigger1 = movehit = 1 && numtarget
var(3) = 1

[state 1206, Dampener]
type = parentvaradd
trigger1 = movehit = 1 && numtarget
var(5) = 1

[state 1206, Pause Frame]
type = changeanim
trigger1 = 1
value = anim
elem = animelemno(0)

[state 1206, Hit Sound]
type = playsnd
trigger1 = movecontact = 1 && numtarget
value = f200, cond(movehit, var(1), var(2))
channel = 2

[state 1206, Hit Spark]
type = explod
trigger1 = movecontact = 1 && numtarget
ID = 195 + 5 * teamside
anim = f195 + 5 * teamside
postype = p1
pos = enemy,const(size.ground.front), 0
bindtime = 1
removetime = -2
removeongethit = 0
ownpal = 1
scale = 1.0, 1.0
sprpriority = 5

[state 1206, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 1206, Priority]
type = sprpriority
trigger1 = 1
value = 4

[state 1206, Freeze Position]
type = posfreeze
trigger1 = 1
value = 1

[state 1206, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NP,SP,HP
time = -1

[state 1206, Hit Override]
type = hitoverride
trigger1 = 1
attr = SCA,NP,SP,HP
stateno = 1207
slot = 0
time = -1
forceair = 0

[state 1206, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = -1

[state 1206, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 1206, Miss]
type = hitdef
trigger1 = 1
attr = S, SP
hitflag = 

[state 1206, End State]
type = changestate
trigger1 = time > 6
value = 1208

;=========================================================================
; Proj Canceled
;=========================================================================
[Statedef 1207]
type = S
movetype = A
physics = N
ctrl = 0
movehitpersist = 1

[state 1207, Pause Frame]
type = changeanim
trigger1 = 1
value = anim
elem = animelemno(0)

[state 1207, Hit Sound]
type = null ; playsnd
trigger1 = !time
value = f200, 120
channel = 2

[state 1207, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 1207, Priority]
type = sprpriority
trigger1 = 1
value = 4

[state 1207, Freeze Position]
type = posfreeze
trigger1 = 1
value = 1

[state 1207, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NP,SP,HP
time = -1

[state 1207, Hit Override]
type = hitoverride
trigger1 = 1
attr = SCA,NP,SP,HP
stateno = 1207
slot = 0
time = -1
forceair = 0

[state 1207, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = -1

[state 1207, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 1207, Miss]
type = hitdef
trigger1 = 1
attr = S, SP
hitflag = 

[state 1207, End State]
type = changestate
trigger1 = time > 6
value = 1208

;=========================================================================
; Proj End
;=========================================================================
[Statedef 1208]
type = S
movetype = I
physics = N
ctrl = 0
velset = 0, 0
movehitpersist = 1

[state 1208, Change Animation]
type = changeanim
trigger1 = !time
value = 1208

[state 1208, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 1208, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = -1

[state 1208, Destroy Helper]
type = destroyself
trigger1 = !animtime

;=========================================================================
; Human Tank
;=========================================================================
[Statedef 1300]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1300, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1300, Change Animation]
type = changeanim
trigger1 = !time
value = 1300

[state 1300, Invulnerability]
type = nothitby
trigger1 = animelemtime(9) < 0
value = ,AT
time = 1

[state 1300, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f9, 0
volumescale = 100
channel = 0

[state 1000, Sound]
type = playsnd
trigger1 = !animelemtime(1)
value = f100, 0
volumescale = 100
channel = 1

[state 1300, Set Velocity]
type = velset
trigger1 = !animelemtime(1)
x = 6.640625

[state 1300, Set Velocity]
type = velset
trigger1 = !animelemtime(9)
x = 0.0

[state 1300, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 2 || var(13) := 32

[state 1300, Cornerpush]
type = varset
trigger1 = numtarget && movecontact = 1
fvar(2) = target,gethitvar(xvel) * 1.5

[state 1300, Hit Counter]
type = varset
trigger1 = !time
var(40) = 0

[state 1300, Hit Counter]
type = varadd
trigger1 = movecontact = 1 || movereversed = 1
var(40) = 1

[state 1300, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy && var(40) < 5
trigger1 = !animelemtime(animelemno(0)) && animelemtime(2) >= 0 && animelemtime(9) < 0
ID = 2
attr = A, SA
damage = 10, 1
fall.envshake.phase = 5 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -16
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 9
guard.hittime = 9
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1300, Idle]
type = statetypeset
trigger1 = animelemtime(9) >= 0
movetype = I
persistent = 0

[state 1300, End State]
type = changestate
trigger1 = !animtime
value = 11
ctrl = 1

;=========================================================================
; Thunderbolt Spin
;=========================================================================
[Statedef 1400]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1400, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1400, Change Animation]
type = changeanim
trigger1 = !time
value = 1400

[state 1400, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f9, 0
volumescale = 100
channel = 0

[state 1400, Sound]
type = playsnd
trigger1 = movetype = A
trigger1 = !animelemtime(animelemno(0)) && animelemno(0) % 4 = 0
value = f100, 0
volumescale = 100
channel = 1

[state 1400, Set Velocity]
type = velset
trigger1 = !animelemtime(2)
x = 7.8125

[state 1400, Increment Velocity]
type = veladd
trigger1 = animelemtime(2) > 0 && animelemtime(18) < 0
x = -0.1220703125

[state 1400, Set Velocity]
type = velset
trigger1 = !animelemtime(18)
x = 0.0

[state 1400, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 2 || var(13) := 40

[state 1400, Cornerpush]
type = varset
trigger1 = numtarget && movecontact = 1
fvar(2) = target,gethitvar(xvel) * 1.5

[state 1400, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy && movetype = A ; && hitcount < 2
trigger1 = !animelemtime(animelemno(0)) && (animelemno(0) - 1) % 2 = 0 && animelemtime(2) >= 0
ID = 2
attr = A, SA
damage = 15, 2
fall.envshake.phase = 5 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 9
guard.hittime = 9
air.hittime = 15
ground.velocity = -11.71875
guard.velocity = -11.71875
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1400, Idle]
type = statetypeset
trigger1 = animelemtime(18) >= 0
movetype = I
persistent = 0

[state 1400, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1