; Super Fighter Team

;=========================================================================
; Top Storm
;=========================================================================
[Statedef 3000]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 1

[state 3000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3000, Change Animation]
type = changeanim
trigger1 = !time
value = 3000

[state 3000, Animation Loop]
type = changeanim
trigger1 = time - 48 < 54
trigger1 = !animelemtime(8)
value = anim
elem = 2

[state 3000, Add Power]
type = poweradd
trigger1 = !time
value = -power

[state 3000, Super Config]
type = helper
trigger1 = !animelemtime(1)
name = "Super Config"
id = 6120
stateno = 6120
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 65536
pausemovetime = 65536

[state 3000, Super Pause]
type = superpause
trigger1 = !animelemtime(1)
time = 48
movetime = 48
unhittable = 1
anim = -1
sound = -1
p2defmul = 1
poweradd = 0
darken = 0

[state 3000, Invulnerability]
type = nothitby
trigger1 = animelemtime(1) <= 48
value = SCA
time = 4

[state 3000, Sound]
type = playsnd
trigger1 = !animelemtime(2) || !animelemtime(4) || !animelemtime(6)
value = f100, 0
volumescale = 100
channel = 1

[state 3000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 7 || var(13) := 64

[state 3000, Wind]
type = helper
trigger1 = !numhelper(3005)
trigger1 = animelemtime(2) >= 0 && animelemtime(8) < 0
name = "Wind"
ID = 3005
stateno = 3005
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
size.ground.front = 8
size.ground.back = 8
size.height = 128

[state 3000, Attack Distance]
type = attackdist
trigger1 = !time
value = floor(const(size.attack.dist) * 0.5)

[state 3000, Cornerpush]
type = varset
trigger1 = numtarget && movecontact = 1
fvar(2) = target,gethitvar(xvel) * 0.5

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(3) || !animelemtime(7)
ID = 3
attr = S, HA
damage = 6, 1
fall.envshake.phase = 1 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 3, 3
guard.pausetime = 3, 3
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48 + random % 8
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -3.125
guard.velocity = -3.90625
air.velocity = -3.125, -3.515625
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(5)
ID = 3
attr = S, HA
damage = 6, 1
fall.envshake.phase = 1 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 3, 3
guard.pausetime = 3, 3
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48 + random % 8
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = 6.25
guard.velocity = 3.90625
air.velocity = -3.125, -3.515625
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(7) && time - 48 >= 48
ID = 3
attr = S, HA
damage = 6, 1
fall.envshake.phase = 1 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48 + random % 8
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -4.296875, -6.25
guard.velocity = -7.8125
air.velocity = -4.296875, -6.25
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 1
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Idle]
type = statetypeset
trigger1 = animelemtime(8) >= 0
movetype = I
persistent = 0

[state 3000, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Wind
;=========================================================================
[Statedef 3005]
type = S
movetype = A
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 4

[state 3005, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3005, Change Animation]
type = changeanim
trigger1 = !time
value = 3005

[state 3005, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 3005, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = -1

[state 3005, Turn]
type = turn
trigger1 = rootdist x < 8

[state 3005, Solidity]
type = playerpush
trigger1 = p2bodydist x = [ -8, 8]
value = cond(p2movetype = H && p2stateno != 5300 || p2statetype = L, 0, 1)

[state 3005, Increment Position]
type = posadd
trigger1 = p2bodydist x != [-8, 8]
x = p2dist x - 32

[state 3005, Set Velocity]
type = velset
trigger1 = 1
x = (256.0 - 128.0 * (p2stateno = [120, 155])) / (rootdist x * 0.5 + 1.0)

[state 3005, Destroy Helper]
type = destroyself
trigger1 = root,stateno != 3000 || root,anim != 3000
trigger2 = root,animelemtime(8) >= 0 || root,movetype != A

;=========================================================================
; Thunderstorm Spin
;=========================================================================
[Statedef 3100]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 1

[state 3100, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3100, Change Animation]
type = changeanim
trigger1 = !time
value = 3100

[state 3100, Animation Loop]
type = changeanim
trigger1 = time - 48 < 72
trigger1 = !animelemtime(10)
value = anim
elem = 2

[state 3100, Add Power]
type = poweradd
trigger1 = !time
value = -power

[state 3100, Super Config]
type = helper
trigger1 = !animelemtime(1)
name = "Super Config"
id = 6120
stateno = 6120
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 65536
pausemovetime = 65536

[state 3100, Super Pause]
type = superpause
trigger1 = !animelemtime(1)
time = 48
movetime = 48
unhittable = 1
anim = -1
sound = -1
p2defmul = 1
poweradd = 0
darken = 0

[state 3100, Invulnerability]
type = nothitby
trigger1 = animelemtime(1) <= 48
value = SCA
time = 4

[state 3100, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f9, 0
volumescale = 100
channel = 0

[state 3100, Sound]
type = playsnd
trigger1 = movetype = A
trigger1 = animelemno(0) % 4 = 0
trigger1 = !animelemtime(animelemno(0))
value = f100, 0
volumescale = 100
channel = 1

[state 3100, Set Velocity]
type = velset
trigger1 = !animelemtime(2)
x = 7.8125
persistent = 0

[state 3100, Increment Velocity]
type = veladd
trigger1 = animelemtime(2) > 0 && animelemtime(10) < 0
x = -0.10850694444444444444444444444444

[state 3100, Set Velocity]
type = velset
trigger1 = !animelemtime(10)
x = 0.0

[state 3100, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 7 || var(13) := 48

[state 3100, Cornerpush]
type = varset
trigger1 = 1
fvar(2) = 0

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(3) || !animelemtime(7)
trigger1 = time - 48 < 66
ID = 3
attr = S, HA
damage = 5, 1
fall.envshake.phase = 1 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 6, 6
guard.pausetime = 6, 6
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -56 + random % 8
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -3.90625
guard.velocity = -3.90625
air.velocity = -3.125, -3.515625
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(5) || !animelemtime(9)
trigger1 = time - 48 < 66
ID = 3
attr = S, HA
damage = 5, 1
fall.envshake.phase = 1 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 6, 6
guard.pausetime = 6, 6
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -56 + random % 8
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -3.90625
guard.velocity = -3.90625
air.velocity = -3.125, -3.515625
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(9)
trigger1 = time - 48 >= 66
ID = 3
attr = S, HA
damage = 5, 1
fall.envshake.phase = 1 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 6, 6
guard.pausetime = 6, 6
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -56 + random % 8
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -3.125, -8.59375
guard.velocity = -7.8125
air.velocity = -3.125, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 1
air.fall = 1
fall.recover = 0
fall.animtype = back
p2facing = 1

[state 3100, Idle]
type = statetypeset
trigger1 = animelemtime(10) >= 0
movetype = I
persistent = 0

[state 3100, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1