; Super Fighter Team

;=========================================================================
; Tai Chi Rocket
;=========================================================================
[Statedef 3000]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 1

[state 3000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3000, Change Animation]
type = changeanim
trigger1 = !time
value = 3000

[state 3000, Add Power]
type = poweradd
trigger1 = !time
value = -power

[state 3000, Super Config]
type = helper
trigger1 = !animelemtime(1)
name = "Super Config"
id = 6120
stateno = 6120
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 65536
pausemovetime = 65536

[state 3000, Super Pause]
type = superpause
trigger1 = !animelemtime(1)
time = 48
movetime = 48
unhittable = 1
anim = -1
sound = -1
p2defmul = 1
poweradd = 0
darken = 0

[state 3000, Invulnerability]
type = nothitby
trigger1 = animelemtime(1) <= 48
value = SCA
time = 20

[state 3000, Set State Type]
type = statetypeset
trigger1 = animelemtime(2) >= 0
statetype = A
physics = N
persistent = 0

[state 3000, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f0, 0
volumescale = 100
channel = 0

[state 3000, Sound]
type = playsnd
trigger1 = !animelemtime(8)
value = f100, 0
volumescale = 100
channel = 1

[state 3000, Set Velocity]
type= velset
trigger1 = !ailevel && !animelemtime(2)
x = 6.25 * command = "holdfwd" - 6.25 * command = "holdback"

[state 3000, Set Velocity]
type= velset
trigger1 = ailevel && !animelemtime(2)
x = 6.25 * (p2bodydist x > 128) - 6.25 * (p2bodydist x < 64)

[state 3000, Set Velocity]
type= velset
trigger1 = !animelemtime(2)
y = -10.9375

[state 3000, Increment Velocity]
type = veladd
trigger1 = animelemtime(2) > 0 && animelemtime(5) < 0
y = const(movement.yaccel)

[state 3000, Set Velocity]
type = velset
trigger1 = !animelemtime(5)
x = 0.0
y = 0.0

[state 3000, Set Velocity]
type = velset
trigger1 = !animelemtime(8)
x = 7.03125
y = 5.859375

[state 3000, Attack Distance]
type = attackdist
trigger1 = !time
value = 0

[state 3000, Attack Distance]
type = attackdist
trigger1 = !animelemtime(8)
value = const(size.attack.dist)

[state 3000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 8 || var(13) := 24

[state 3000, Cornerpush]
type = varset
trigger1 = 1
fvar(2) = 0

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = animelemtime(9) % 2 = 0
ID = 3
attr = A, HA
damage = 5, 1
fall.envshake.phase = 0 ; dizzy points
guardflag = H
hitflag = MAF
priority = 4, Hit
pausetime = 6, 6
guard.pausetime = 6, 6
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -32 + random % 8
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 27
ground.hittime = 27
guard.slidetime = 18
guard.hittime = 18
air.hittime = 27
ground.velocity = -3.90625
guard.velocity = -3.90625
air.velocity = -3.125, -3.515625
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = animelemtime(9) % 4 = 0
ID = 3
attr = A, HA
damage = 5, 1
fall.envshake.phase = 0 ; dizzy points
guardflag = H
hitflag = MAF
priority = 4, Hit
pausetime = 6, 6
guard.pausetime = 6, 6
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -32 + random % 8
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 27
ground.hittime = 27
guard.slidetime = 18
guard.hittime = 18
air.hittime = 27
ground.velocity = -3.90625
guard.velocity = -3.90625
air.velocity = -3.125, -3.515625
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Idle]
type = null ; statetypeset
trigger1 = animelemtime(0) >= 0
movetype = I
persistent = 0

[state 3000, End State]
type = changestate
trigger1 = pos y + vel y > 24
value = 3005
ctrl = 0

;=========================================================================
; Tai Chi Power Punch
;=========================================================================
[Statedef 3005]
type = S
movetype = A
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 3005, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3005, Change Animation]
type = changeanim
trigger1 = !time
value = 3005

[state 3005, Voice]
type = playsnd
trigger1 = !animelemtime(2)
value = f0, 0
volumescale = 100
channel = 0

[state 3005, Sound]
type = playsnd
trigger1 = !animelemtime(2)
value = f100, 0
volumescale = 100
channel = 1

[state 3005, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 6

[state 3005, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(3)
ID = 3
attr = S, HA
damage = 20, 2
fall.envshake.phase = 5 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 16, 16
guard.pausetime = 16, 16
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -60
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 10
guard.hittime = 10
air.hittime = 18
ground.velocity = -4.296875, -6.25
guard.velocity = -7.8125
air.velocity = -4.296875, -6.25
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 1
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Idle]
type = statetypeset
trigger1 = animelemtime(4) >= 0
movetype = I
persistent = 0

[state 3005, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1