; Super Fighter Team

;=========================================================================
; Whirlwind Ninjutsu Short
;=========================================================================
[Statedef 1000]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1000, Change Animation]
type = changeanim
trigger1 = !time
value = 1000

[state 1000, Shadow]
type = varset
trigger1 = 1
var(16) = 16 * (animelemtime(2) >= 0) + 8 * (animelemtime(3) >= 0) + 32 * (animelemtime(4) >= 0) - 56 * (animelemtime(7) >= 0)

[state 1000, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f5, 0
volumescale = 100
channel = 0

[state 1000, Sound]
type = playsnd
trigger1 = !animelemtime(3)
value = f100, 0
volumescale = 100
channel = 1

[state 1000, Width]
type = helper
trigger1 = !animelemtime(4)
name = "Width"
ID = 6010
stateno = 6010
postype = p1
pos = 0, 0
ownpal = 1
keyctrl = 0
size.ground.front = 0
size.ground.back = 0

[state 1000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 2 || var(13) := 120

[state 1000, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(5)
ID = 2
attr = S, SA
damage = 15, 1
fall.envshake.phase = 15 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -44
animtype = hard
ground.type = low
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = back

[state 1000, Idle]
type = statetypeset
trigger1 = animelemtime(6) >= 0 
movetype = I
persistent = 0

[state 1000, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Whirlwind Ninjutsu Far
;=========================================================================
[Statedef 1100]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1100, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1100, Change Animation]
type = changeanim
trigger1 = !time
value = 1100

[state 1100, Shadow]
type = varset
trigger1 = 1
var(16) = 16 * (animelemtime(2) >= 0) + 8 * (animelemtime(3) >= 0) + 32 * (animelemtime(4) >= 0) - 56 * (animelemtime(8) >= 0)

[state 1100, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f5, 0
volumescale = 100
channel = 0

[state 1100, Sound]
type = playsnd
trigger1 = !animelemtime(3)
value = f100, 0
volumescale = 100
channel = 1

[state 1100, Width]
type = helper
trigger1 = !animelemtime(4)
name = "Width"
ID = 6010
stateno = 6010
postype = p1
pos = 0, 0
ownpal = 1
keyctrl = 0
size.ground.front = 0
size.ground.back = 0

[state 1100, Cane]
type = helper
trigger1 = !animelemtime(4)
name = "Cane"
ID = 1105
stateno = 1105
postype = p1
pos = 25, 0
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 1100, Arm]
type = helper
trigger1 = !animelemtime(4)
name = "Arm"
ID = 1110
stateno = 1110
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 0.01408450704225352112676056338028
size.yscale = 1.0

[state 1100, Increment Position]
type = posadd
trigger1 = !animelemtime(4)
x = 25.0

[state 1110, Increment Position]
type = varset
trigger1 = !time
fvar(20) = 0.0

[state 1110, Increment Position]
type = varadd
trigger1 = frontedgedist > 72 && !movecontact && !movereversed
trigger1 = animelemtime(4) >= 0 && animelemtime(5) < 0
fvar(20) = 11.833333333333333333333333333333

[state 1110, Increment Position]
type = varset
trigger1 = !animelemtime(6)
fvar(20) = -fvar(20) / 6.0

[state 1110, Increment Position]
type = posadd
trigger1 = frontedgedist > 72 && !movecontact && !movereversed
trigger1 = animelemtime(4) >= 0 && animelemtime(5) < 0
trigger2 = animelemtime(6) >= 0 && animelemtime(7) < 0
x = cond(animelemtime(6) < 0, 11.833333333333333333333333333333, fvar(20))

[state 1100, Increment Position]
type = posadd
trigger1 = !animelemtime(7)
x = -25.0

[state 1100, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 4 || var(13) := 104

[state 1100, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(4)
ID = 2
attr = S, SA
damage = 15, 1
fall.envshake.phase = 15 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -40
animtype = hard
ground.type = low
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = back

[state 1100, Idle]
type = statetypeset
trigger1 = animelemtime(5) >= 0 
movetype = I
persistent = 0

[state 1100, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Cane
;=========================================================================
[Statedef 1105]
type = S
movetype = I
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 1

[state 1105, Change Animation]
type = changeanim
trigger1 = anim != 1105
value = 1105

[state 1105, Parent Bind]
type = varset
trigger1 = !parent,fvar(2)
fvar(0) = -parentdist x

[state 1105, Parent Bind]
type = bindtoparent
trigger1 = 1
pos = cond(parentdist x < 0, 0, fvar(0)), 0

[state 1105, Turn]
type = turn
trigger1 = facing != parent,facing

[state 1105, Destroy Helper]
type = destroyself
trigger1 = parent,movetype = H || parent,gethitvar(isbound)
trigger2 = parent,stateno != 1100 || parent,anim != 1100
trigger3 = parent,animelemtime(7) >= 0 

;=========================================================================
; Arm
;=========================================================================
[Statedef 1110]
type = S
movetype = I
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 1

[state 1110, Change Animation]
type = changeanim
trigger1 = anim != 1110
value = 1110

[state 1110, Offset]
type = offset
trigger1 = facing = -1
x = -1

[state 1110, Parent Bind]
type = posset
trigger1 = numhelper(1105)
x = helper(1105),pos x

[state 1110, Turn]
type = turn
trigger1 = facing != parent,facing

[state 1110, Angle]
type = angledraw
trigger1 = 1
scale = parentdist x, 1.0

[state 1110, Destroy Helper]
type = destroyself
trigger1 = parent,movetype = H || parent,gethitvar(isbound)
trigger2 = parent,stateno != 1100 || parent,anim != 1100
trigger3 = parent,animelemtime(7) >= 0

;=========================================================================
; Turtle Ninjutsu
;=========================================================================
[Statedef 1200]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1200, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1200, Change Animation]
type = changeanim
trigger1 = !time
value = 1200

[state 1200, Invulnerability]
type = nothitby
trigger1 = animelemtime(14) < 0
value = ,AT
time = 1

[state 1200, Set State Type]
type = statetypeset
trigger1 = animelemtime(2) >= 0
statetype = C
persistent = 0

[state 1200, Set State Type]
type = statetypeset
trigger1 = animelemtime(15) >= 0
statetype = S
persistent = 0

[state 1200, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f5, 0
volumescale = 100
channel = 0

[state 1200, Set Velocity]
type = velset
trigger1 = !animelemtime(2)
x = 4.6875

[state 1200, Increment Velocity]
type = veladd
trigger1 = !animelemtime(4) || !animelemtime(7) || !animelemtime(10) || !animelemtime(12)
x = 0.29296875

[state 1200, Increment Velocity]
type = veladd
trigger1 = vel x
x = -0.07102272727272727272727272727273

[state 1200, Set Velocity]
type = velset
trigger1 = !animelemtime(15)
x = 0.0

[state 1200, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 4 || var(13) := 48

[state 1200, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(4) || !animelemtime(7) || !animelemtime(10) || !animelemtime(12)
ID = 2
attr = C, SA
damage = 8, 1
fall.envshake.phase = 8 ; dizzy points
guardflag = L
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -32 - random % 8
animtype = hard
ground.type = low
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 9
guard.hittime = 9
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 4, 4
givepower = 2, 2
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1200, Idle]
type = statetypeset
trigger1 = animelemtime(14) >= 0
movetype = I
persistent = 0

[state 1200, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Air Throw - Attempt
;=========================================================================
[Statedef 1300]
type = A
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = vel x, vel y
sprpriority = 0

[state 1300, Change Animation]
type = changeanim
trigger1 = !time && anim = [41, 43]
value = 1300 + 1 * (anim = 42) + 2 * (anim = 43)
elem = animelemno(0)

[state 1300, Change Animation]
type = changeanim
trigger1 = time = 1
value = 41 + 1 * (anim = 1301) + 2 * (anim = 1302)
elem = animelemno(0)

[state 1300, Increment Velocity]
type = veladd
trigger1 = 1
y = const(movement.yaccel)

[state 1300, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 0 || var(13) := 0

[state 1300, Throw]
type = hitdef
trigger1 = !time
ID = 2
attr = A, ST
damage = 0
fall.envshake.phase = 0 ; dizzy points
hitflag = A-
priority = 1, miss
pausetime = 0, 0
hitsound = -1 + 0 * (var(1) := -1)
guardsound = -1 + 0 * (var(2) := -1)
sparkno = -1
guard.sparkno = -1
ground.slidetime = 0
ground.hittime = 0
ground.velocity = 0.0, 0.0
ground.cornerpush.veloff = 0.0
yaccel = 0.5859375
fall = 1
fall.recover = 0
p1facing = 1
p2facing = 1
p1stateno = 1305

[state 1300, Miss]
type = hitdef
trigger1 = time = 1
ID = 2
attr = A, ST
hitflag = 

[state 1300, Idle]
type = statetypeset
trigger1 = time = 1
movetype = I
persistent = 0

[state 1300, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 52

;=========================================================================
; Air Throw - Success
;=========================================================================
[Statedef 1305]
type = A
movetype = A
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 1

[state 1305, Change Animation]
type = changeanim
trigger1 = !time
value = 1305

[state 1305, Width]
type = width
trigger1 = !time
edge = 40, 0

[state 1305, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f5, 0
volumescale = 100
channel = 0

[state 1305, Increment Velocity]
type = veladd
trigger1 = animelemtime(3) > 0
y = const(movement.yaccel) * 0.75

[state 1305, Attack Distance]
type = attackdist
trigger1 = !time
value = 0

[state 1305, Target State]
type = targetstate
trigger1 = !time
value = 1310

[state 1305, Target Facing]
type = targetfacing
trigger1 = !time
value = -1

[state 1305, Target Bind]
type = targetbind
trigger1 = animelemtime(1) >= 0 && animelemtime(2) < 0
pos = 20, -56

[state 1305, Target Bind]
type = targetbind
trigger1 = !animelemtime(2)
pos = 48, -16

[state 1305, Target Damage]
type = targetlifeadd
trigger1 = !time
value = -24

[state 1305, Target Power]
type = targetpoweradd
trigger1 = !time
value = 10

[state 1305, Target State]
type = targetstate
trigger1 = !animelemtime(2)
value = 1311

[state 1305, Add Power]
type = poweradd
trigger1 = !time
value = 10

[state 1305, Juggle and Dampener Hit Counters]
type = null
trigger1 = !time
trigger1 = var(3) := var(3) + 1 || var(4) := 1 || var(5) := var(5) + 1

[state 1305, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 52

;=========================================================================
; Target Grabbed
;=========================================================================
[Statedef 1310]
type = S
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 1310, Change Animation]
type = changeanim2
trigger1 = !time
value = 1310

[state 1310, Bound]
type = screenbound
trigger1 = 1
value = 0
movecamera = 1, 1

[state 1310, Own State]
type = selfstate
trigger1 = !gethitvar(isbound)
trigger1 = time > 100
value = 5050

;=========================================================================
; Target Slammed
;=========================================================================
[Statedef 1311]
type = A
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 1311, Set Hit Fall]
type = hitfallset
trigger1 = !time
value = 1

[state 1311, Change Animation]
type = changeanim
trigger1 = !time
value = 5050

[state 1311, Change Animation]
type = changeanim
trigger1 = vel y > 0
value = 5060
persistent = 0

[state 1311, Increment Position]
type = posadd
trigger1 = !time
y = -const(size.mid.pos.y)

[state 1311, Set Velocity]
type = velset
trigger1 = !time
x = -3.90625
; y = 3.90625

[state 1311, Increment Velocity]
type = veladd
trigger1 = 1
y = 0.5859375

[state 1311, Own State]
type = selfstate
trigger1 = pos y >= const(movement.air.gethit.groundlevel)
trigger1 = vel y > 0
value = 5100
ctrl = 0