; Super Fighter Team

;=========================================================================
; Trifecta
;=========================================================================
[Statedef 3000]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 1

[state 3000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3000, Change Animation]
type = changeanim
trigger1 = !time
value = 3000

[state 3000, Add Power]
type = poweradd
trigger1 = !time
value = -power

[state 3000, Super Config]
type = helper
trigger1 = !animelemtime(1)
helpertype = normal
name = "Super Config"
id = 6120
stateno = 6120
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 65536
pausemovetime = 65536

[state 3000, Super Pause]
type = superpause
trigger1 = !animelemtime(1)
time = 48
movetime = 48
unhittable = 1
anim = -1
sound = -1
p2defmul = 1
poweradd = 0
darken = 0

[state 3000, Invulnerability]
type = nothitby
trigger1 = animelemtime(1) <= 48
value = SCA
time = 12

[state 3000,  Set State Type]
type = statetypeset
trigger1 = animelemtime(14) >= 0
statetype = A
physics = N
persistent = 0

[state 3000, Voice]
type = playsnd
trigger1 = !animelemtime(2) || !animelemtime(9) || !animelemtime(14)
value = f3, 0
volumescale = 100
channel = 0

[state 3000, Sound]
type = playsnd
trigger1 = !animelemtime(3) || !animelemtime(9) || !animelemtime(14)
value = f100, 0
volumescale = 100
channel = 1

[state 3000, Increment Position]
type = posadd
trigger1 = animelemtime(3) >= 0 && animelemtime(8) < 0
x = 6.0 - 0.375 * animelemtime(3)

[state 3000, Increment Position]
type = posadd
trigger1 = !animelemtime(12)
x = -16.0

[state 3000, Increment Position]
type = posadd
trigger1 = !animelemtime(13)
x = -4.0

[state 3000, Increment Position]
type = posadd
trigger1 = !animelemtime(14)
x = 24.0
y = -8.0

[state 3000, Set Velocity]
type = velset
trigger1 = !animelemtime(14)
x = 4.6875
y = -1.5625

[state 3000, Increment Velocity]
type = veladd
trigger1 = animelemtime(14) > 0 && animelemtime(16) < 0
x = -0.1953125

[state 3000, Increment Velocity]
type = veladd
trigger1 = animelemtime(14) > 0
y = const(movement.yaccel)

[state 3000, Width]
type = helper
trigger1 = !animelemtime(9)
helpertype = normal
name = "Width"
ID = 6010
stateno = 6010
postype = p1
pos = 0, 0
ownpal = 1
keyctrl = 0
size.ground.front = 0
size.ground.back = 0

[state 3000, Energy]
type = null ; helper
trigger1 = !animelemtime(14)
helpertype = normal
name = "Energy"
ID = 3015
stateno = 7000
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 3000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 7 || var(13) := 64

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(4)
ID = 3
attr = S, HA
damage = 12, 1
fall.envshake.phase = 0 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 8, 8
guard.pausetime = 8, 8
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48 - random % 16
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 27
ground.hittime = 27
guard.slidetime = 27
guard.hittime = 27
air.hittime = 27
ground.velocity = -1.5625
guard.velocity = -1.5625
air.velocity = -3.125, -3.90625
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(6)
ID = 3
attr = S, HA
damage = 12, 1
fall.envshake.phase = 0 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 8, 8
guard.pausetime = 8, 8
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48 - random % 16
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 27
ground.hittime = 27
guard.slidetime = 27
guard.hittime = 27
air.hittime = 27
ground.velocity = -1.5625
guard.velocity = -1.5625
air.velocity = -3.125, -3.90625
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(10)
ID = 3
attr = S, HA
damage = 12, 1
fall.envshake.phase = 0 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 8, 8
guard.pausetime = 8, 8
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -88
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 27
ground.hittime = 27
guard.slidetime = 27
guard.hittime = 27
air.hittime = 27
ground.velocity = -3.125
guard.velocity = -3.125
air.velocity = -1.5625, -5.2734375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(14)
ID = 3
attr = A, HA
damage = 12, 1
fall.envshake.phase = 0 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 8, 8
guard.pausetime = 8, 8
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -64
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -3.125
guard.velocity = -3.125
air.velocity = -1.5625, -5.2734375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1

[state 3000, Idle]
type = null ; statetypeset
trigger1 = animelemtime(16) >= 0
movetype = I
persistent = 0

[state 3000, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 3005
ctrl = 0

;=========================================================================
; Second Spiral Blade
;=========================================================================
[Statedef 3005]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 1
movehitpersist = 1
hitcountpersist = 1

[state 3005, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3005, Change Animation]
type = changeanim
trigger1 = !time
value = 3005

[state 3005,  Set State Type]
type = statetypeset
trigger1 = animelemtime(3) >= 0
statetype = A
physics = N
persistent = 0

[state 3005, Voice]
type = playsnd
trigger1 = !animelemtime(3)
value = f3, 0
volumescale = 100
channel = 0

[state 3005, Sound]
type = playsnd
trigger1 = !animelemtime(3)
value = f100, 0
volumescale = 100
channel = 1

[state 3005, Increment Position]
type = posadd
trigger1 = !animelemtime(1)
x = -16.0

[state 3005, Increment Position]
type = posadd
trigger1 = !animelemtime(2)
x = -4.0

[state 3005, Increment Position]
type = posadd
trigger1 = !animelemtime(3)
x = 24.0
y = -8.0

[state 3005, Set Velocity]
type = velset
trigger1 = !animelemtime(3)
x = 4.6875
y = -4.6875

[state 3005, Increment Velocity]
type = veladd
trigger1 = animelemtime(3) > 0 && animelemtime(5) < 0
x = -0.1953125

[state 3005, Increment Velocity]
type = veladd
trigger1 = animelemtime(3) > 0
y = const(movement.yaccel)

[state 3005, Energy]
type = null ; helper
trigger1 = !animelemtime(3)
helpertype = normal
name = "Energy"
ID = 3015
stateno = 7000
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 3005, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 7

[state 3005, Hit]
type = hitdef
trigger1 = !var(4) && numenemy ; !(var(3) &&
trigger1 = !animelemtime(4)
ID = 3
attr = A, HA
damage = 12, 1
fall.envshake.phase = 5 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 8, 8
guard.pausetime = 16, 16
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -72
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 18
ground.hittime = 18
guard.slidetime = 18
guard.hittime = 18
air.hittime = 18
ground.velocity = -10.9375, 0.0
guard.velocity = -7.8125
air.velocity = -10.9375, 0.0
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 0, 0
givepower = 4, 4
envshake.time = 8
envshake.ampl = 4
fall = 1
air.fall = 1
fall.recover = 0
fall.animtype = hard
forcestand = 1
p2stateno = 3020

[state 3005, Idle]
type = statetypeset
trigger1 = animelemtime(5) >= 0
movetype = I
persistent = 0

[state 3005, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 3010
ctrl = 0

;=========================================================================
; Land
;=========================================================================
[Statedef 3010]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 3010, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3010, Change Animation]
type = changeanim
trigger1 = !time
value = 3010

[state 3010, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Wall Slam Entrance
;=========================================================================
[Statedef 3020]
type = A
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 3020, Set Hit Fall]
type = hitfallset
trigger1 = !time
value = 1

[state 3020, Increment Position]
type = posadd
trigger1 = !time
y = -8.0

[state 3020, Own State]
type = selfstate
trigger1 = 1
value = 5230
ctrl = 0

;=========================================================================
; Phoenix's Ashes
;=========================================================================
[Statedef 3100]
type = S
movetype = I
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 1

[state 3100, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3100, Change Animation]
type = changeanim
trigger1 = !time
value = 3100

[state 3100, Add Power]
type = poweradd
trigger1 = !time
value = -power

[state 3100, Super Config]
type = helper
trigger1 = !animelemtime(1)
helpertype = normal
name = "Super Config"
id = 6120
stateno = 6120
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 65536
pausemovetime = 65536

[state 3100, Super Pause]
type = superpause
trigger1 = !animelemtime(1)
time = 48
movetime = 48
unhittable = 1
anim = -1
sound = -1
p2defmul = 1
poweradd = 0
darken = 0

[state 3100, Invulnerability]
type = nothitby
trigger1 = animelemtime(1) <= 48
value = SCA
time = 1

[state 3100, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f3, 0
volumescale = 100
channel = 0

[state 3100, Palette Effect]
type = null ; palfx
trigger1 = animelemtime(2) >= 0
time = 1
mul = 512 + floor(256.0 * cos(time * pi / 32.0)), 512 + floor(256.0 * sin(time * pi / 32.0)), 512 - floor(256.0 * cos(time * pi / 32.0))
add = 0, 0, 0
color = 256
invertall = 0

[state 3100, Add life]
type = varset
trigger1 = !time
var(40) = 0

[state 3100, Add Life]
type = lifeadd
trigger1 = animelemtime(2) >= 0 && animelemtime(2) % 8 = 0
trigger1 = var(40) < lifemax * 0.2
trigger1 = var(40) := var(40) + 1
value = 1

[state 3100, Sparkle]
type = helper
trigger1 = numhelper(3105) < 4
trigger1 = animelemtime(2) >= 0 && animelemtime(2) % 8 = 0
helpertype = normal
name = "Sparkle"
ID = 3105
stateno = 3105
postype = p1
ownpal = 0
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 3100, Sparkle]
type = helper
trigger1 = numhelper(3106) < 4
trigger1 = animelemtime(2) >= 0 && animelemtime(2) % 8 = 0
helpertype = normal
name = "Sparkle"
ID = 3106
stateno = 3105
postype = p1
ownpal = 0
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 3100, Sparkle]
type = helper
trigger1 = numhelper(3107) < 4
trigger1 = animelemtime(2) >= 0 && animelemtime(2) % 8 = 0
helpertype = normal
name = "Sparkle"
ID = 3107
stateno = 3105
postype = p1
ownpal = 0
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 3100, End State]
type = changestate
trigger1 = life >= lifemax
trigger2 = var(40) >= lifemax * 0.2
value = 0
ctrl = 1

;=========================================================================
; Sparkle
;=========================================================================
[Statedef 3105]
type = S
movetype = I
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 4

[state 3105, Change Animation]
type = changeanim
trigger1 = anim != 3105
value = 3105

[state 3005, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 3105, Root Bind]
type = bindtoparent
trigger1 = ishelper(3105)
pos = var(40) := ceil(40.0 * cos(time * pi / 16.0)), -ceil(40.0 * sin(time * pi / 32.0)) - 48

[state 3105, Root Bind]
type = bindtoparent
trigger1 = ishelper(3106)
pos = var(40) := -ceil(40.0 * cos(time * pi / 16.0)), -ceil(40.0 * sin(time * pi / 32.0)) - 48

[state 3105, Root Bind]
type = bindtoparent
trigger1 = ishelper(3107)
pos = var(40) := ceil(40.0 * cos(time * pi / 16.0)), -48

[state 3105, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA

[state 3105, Priority]
type = sprpriority
trigger1 = var(40) >= 40 || var(40) <= -40
trigger1 = var(41) := var(41) + 1
value = cond(var(40) >= 40, 4, -4)

[state 3105, Angle]
type = null ; angledraw
trigger1 = var(41) % 2 = 1
scale = fvar(20) := var(40) * 0.025, var(40) * 0.025

[state 3105, Angle]
type = null ; angledraw
trigger1 = 1
scale =  fvar(20), fvar(20)

[state 3105, Angle]
type = angleadd
trigger1 = 1
value = 8

[state 3105, Destroy Helper]
type = destroyself
trigger1 = parent,stateno != 3100