; Super Fighter Team

;=========================================================================
; Swirling Bash
;=========================================================================
[Statedef 1000]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1000, Change Animation]
type = changeanim
trigger1 = !time
value = 1000

[state 1000, Finish]
type = changeanim
trigger1 = animelemtime(8) >= 0 && var(40) >= 5
value = anim
elem = 13
persistent = 0

[state 1000, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f9, 0
volumescale = 100
channel = 0

[state 1000, Sound]
type = playsnd
trigger1 = !animelemtime(1)
value = f100, 0
volumescale = 100
channel = 1

[state 1000, Set Velocity]
type = velset
trigger1 = !animelemtime(1)
x = 6.640625

[state 1000, Set Velocity]
type = velset
trigger1 = !animelemtime(13)
x = 0.0

[state 1000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 4 || var(13) := 32

[state 1000, Cornerpush]
type = varset
trigger1 = numtarget && movecontact = 1
fvar(2) = target,gethitvar(xvel) * 1.75

[state 1000, Hit Counter]
type = varset
trigger1 = !time
var(40) = 0

[state 1000, Hit Counter]
type = varadd
trigger1 = movecontact = 1 || movereversed = 1
var(40) = 1

[state 1000, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy && var(40) < 5
trigger1 = !animelemtime(animelemno(0)) && animelemtime(2) >= 0 && animelemtime(13) < 0
ID = 2
attr = A, SA
damage = 10, 1
fall.envshake.phase = 5 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 9
guard.hittime = 9
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = back

[state 1000, Idle]
type = statetypeset
trigger1 = animelemtime(13) >= 0
movetype = I
persistent = 0

[state 1000, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Powerful Shockwave
;=========================================================================
[Statedef 1100]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 0

[state 1100, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1100, Change Animation]
type = changeanim
trigger1 = !time
value = 1100

[state 1100, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f10, 0
volumescale = 100
channel = 0

[state 1100, Shockwave]
type = helper
trigger1 = !animelemtime(2)
name = "Shockwave"
ID = 8
stateno = 1105
postype = p1
pos = 74, -42
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 1100, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 0 || var(13) := 80

[state 1100, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 1100, Idle]
type = statetypeset
trigger1 = animelemtime(2) >= 16
movetype = I
persistent = 0

[state 1100, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Proj Start
;=========================================================================
[Statedef 1105]
type = S
movetype = A
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 4

[state 1105, Juggling and Dampener]
type = null
trigger1 = var(3) := root,var(3) || var(4) := root,var(4) || fvar(1) := root,fvar(1)

[state 1105, Change Animation]
type = changeanim
trigger1 = !time
value = 1105

[state 1105, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 1105, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NP,SP,HP
time = -1

[state 1105, Hit Override]
type = hitoverride
trigger1 = 1
attr = SCA,NP,SP,HP
stateno = 1107
slot = 0
time = -1
forceair = 0

[state 1105, Invulnerability]
type = nothitby
trigger1 = cond(numenemy, !enemy,numhelper(8), 0)
value = SCA,NP,SP,HP
time = 1

[state 1105, Set Velocity]
type = velset
trigger1 = !time
x = 3.515625
y = 0.0

[state 1105, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 1105, Miss]
type = hitdef
trigger1 = 1
attr = S, SP
hitflag = 

[state 1105, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
ID = 2
attr = S, SP 
damage = 22, 2
fall.envshake.phase = 22 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 0, 6
guard.pausetime = 1, 1
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = -1 ; 195 + 5 * teamside
guard.sparkno = -1 ; 195 + 5 * teamside
sparkxy = 0, 0
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -6.8359375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = back
; forcestand = 1
p2facing = p2statetype != A

[state 1105, End State]
type = changestate
trigger1 = movecontact || movereversed
value = stateno + 1
ignorehitpause = 1

[state 1105, Destroy Helper]
type = destroyself
trigger1 = frontedgedist <= -96

;=========================================================================
; Proj Contact
;=========================================================================
[Statedef 1106]
type = S
movetype = A
physics = N
ctrl = 0
movehitpersist = 1
hitcountpersist = 1

[state 1106, Hit Counter]
type = varadd
trigger1 = !time
var(0) = 1

[state 1106, Hit Counter]
type = varadd
trigger1 = numtarget
trigger1 = target,movetype = H && target,stateno = [5000, 5999]
trigger1 = target,time <= 1 && time <= 1 && !target,hitshakeover
trigger2 = moveguarded || movereversed
var(0) = 65536

[state 1106, Juggle]
type = parentvaradd
trigger1 = movehit = 1 && numtarget
var(3) = 1

[state 1106, Dampener]
type = parentvaradd
trigger1 = movehit = 1 && numtarget
var(5) = 1

[state 1106, Pause Frame]
type = changeanim
trigger1 = 1
value = anim
elem = 1 + var(0) % 2

[state 1106, Hit Sound]
type = playsnd
trigger1 = movecontact = 1 && numtarget
value = f200, cond(movehit, var(1), var(2))
channel = 2

[state 1106, Hit Spark]
type = explod
trigger1 = movecontact = 1 && numtarget
ID = 195 + 5 * teamside
anim = f195 + 5 * teamside
postype = p1
pos = enemy,const(size.ground.front), 0
bindtime = 1
removetime = -2
removeongethit = 0
ownpal = 1
scale = 1.0, 1.0
sprpriority = 5

[state 1106, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 1106, Priority]
type = sprpriority
trigger1 = 1
value = 4

[state 1106, Freeze Position]
type = posfreeze
trigger1 = 1
value = 1

[state 1106, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NP,SP,HP
time = -1

[state 1106, Hit Override]
type = hitoverride
trigger1 = 1
attr = SCA,NP,SP,HP
stateno = 1107
slot = 0
time = -1
forceair = 0

[state 1106, Invulnerability]
type = nothitby
trigger1 = var(0) >= 65536
trigger2 = cond(numenemy, !enemy,numhelper(8), 0)
value = SCA
time = 1

[state 1106, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 1106, Miss]
type = hitdef
trigger1 = 1
attr = S, SP
hitflag = 

[state 1106, End State]
type = changestate
trigger1 = time > 6
value = 1105 + 3 * (var(0) >= 65536)

;=========================================================================
; Proj Canceled
;=========================================================================
[Statedef 1107]
type = S
movetype = A
physics = N
ctrl = 0
movehitpersist = 1
hitcountpersist = 1

[state 1107, Hit Counter]
type = varadd
trigger1 = !time
var(0) = 1

[state 1107, Pause Frame]
type = changeanim
trigger1 = 1
value = anim
elem = 1 + var(0) % 2

[state 1107, Hit Sound]
type = null ; playsnd
trigger1 = !time
value = f200, 120
channel = 2

[state 1107, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 1107, Priority]
type = sprpriority
trigger1 = 1
value = 4

[state 1107, Freeze Position]
type = posfreeze
trigger1 = 1
value = 1

[state 1107, Vulnerability]
type = hitby
trigger1 = 1
value = SCA,NP,SP,HP
time = -1

[state 1107, Hit Override]
type = hitoverride
trigger1 = 1
attr = SCA,NP,SP,HP
stateno = 1107
slot = 0
time = -1
forceair = 0

[state 1107, Invulnerability]
type = nothitby
trigger1 = var(0) >= 1
trigger2 = cond(numenemy, !enemy,numhelper(8), 0)
value = SCA
time = 1

[state 1107, Attack Distance]
type = attackdist
trigger1 = !time
value = const(size.proj.attack.dist)

[state 1107, Miss]
type = hitdef
trigger1 = 1
attr = S, SP
hitflag = 

[state 1107, End State]
type = changestate
trigger1 = time > 6
value = 1105 + 3 * (var(0) >= 1)

;=========================================================================
; Proj End
;=========================================================================
[Statedef 1108]
type = S
movetype = I
physics = N
ctrl = 0
velset = 0, 0
movehitpersist = 1

[state 1108, Change Animation]
type = changeanim
trigger1 = !time
value = 1108

[state 1108, Special Effect]
type = assertspecial
trigger1 = 1
flag = noshadow

[state 1108, Invulnerability]
type = nothitby
trigger1 = 1
value = SCA
time = -1

[state 1108, Destroy Helper]
type = destroyself
trigger1 = !animtime

;=========================================================================
; Invisible Kick
;=========================================================================
[Statedef 1200]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1200, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1200, Change Animation]
type = changeanim
trigger1 = !time
value = 1200

[state 1200, Set State Type]
type = statetypeset
trigger1 = animelemtime(1) >= 0
statetype = A
persistent = 0

[state 1200, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f9, 0
volumescale = 100
channel = 0

[state 1200, Sound]
type = playsnd
trigger1 = !animelemtime(3)
value = f100, 0
volumescale = 100

[state 1200, Increment Position]
type = posadd
trigger1 = !animelemtime(1)
y = -16.0

[state 1200, Set Velocity]
type = velset
trigger1 = !animelemtime(1)
x = 4.6875
y = -2.34375

[state 1200, Increment Velocity]
type = veladd
trigger1 = animelemtime(1) > 0
y = const(movement.yaccel) * 0.3
 
[state 1200, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 6 + (animelemtime(6) >= 0) || var(13) := 80

[state 1200, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(3)
ID = 2
attr = A, SA
damage = 15, 1
fall.envshake.phase = 15 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1200, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(5)
ID = 2
attr = A, SA
damage = 15, 1
fall.envshake.phase = 15 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -44
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -2.34375, -4.296875
guard.velocity = -7.8125
air.velocity = -2.34375, -4.296875
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 1
air.fall = 1
fall.recover = 0
fall.animtype = back

[state 1200, End State]
type = changestate
trigger1 = pos y + vel y > 32
value = 1205
ctrl = 0

;=========================================================================
; Land
;=========================================================================
[Statedef 1205]
type = S
movetype = A
physics = N
ctrl = 0
velset = vel x, 0
hitdefpersist = 1

[state 1205, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1205, Change Animation]
type = changeanim
trigger1 = !time
value = 1205

[state 1205, Increment Velocity]
type = veladd
trigger1 = animelemtime(2) < 0
x = -0.46875

[state 1205, Set Velocity]
type = velset
trigger1 = !animelemtime(2)
x = 0.0

[state 1205, Idle]
type = statetypeset
trigger1 = animelemtime(2) >= 0
movetype = I
persistent = 0

[state 1205, End State]
type = changestate
trigger1 = !animtime
value = 11
ctrl = 1

;=========================================================================
; Feather Cap
;=========================================================================
[Statedef 1300]
type = A
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1300, Set Position]
type = null ; posset
trigger1 = !time
y = 0

[state 1300, Change Animation]
type = changeanim
trigger1 = !time
value = 1300

[state 1300, Voice]
type = playsnd
trigger1 = anim = 1300 && !animelemtime(1)
value = f10, 0
volumescale = 100
channel = 0

[state 1300, Set Velocity]
type = velset
trigger1 = anim = 1300 && !animelemtime(1)
x = p2dist x / 36.0
y = const(velocity.jump.y)

[state 1300, Increment Velocity]
type = veladd
trigger1 = anim = 1300 && animelemtime(1) > 0
y = const(movement.yaccel)

[state 1300, Turn]
type = turn
trigger1 = anim = 1300 && vel x < 0
persistent = 0

[state 1300, Set Velocity]
type = velset
trigger1 = anim = 1300
trigger1 = vel x > 10 || vel x < 0
x = cond(vel x < 0, 0.0, 10.0)

[state 1300, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 8 || var(13) := 16

[state 1300, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !movecontact && !movereversed
trigger1 = anim = 1300 && animelemtime(3) >= 0
trigger1 = vel y >= 0 && enemy,pos y - pos y >= enemy,const(size.head.pos.y)
ID = 2
attr = A, SA
damage = 25, 2
fall.envshake.phase = 32 ; dizzy points
guardflag = H
hitflag = MAF
priority = 4, Hit
pausetime = 0, 24
guard.pausetime = 0, 24
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), 0
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 1
fall.recover = 0
fall.animtype = hard ; back

[state 1300, Hit]
type = changeanim
trigger1 = anim = 1300
trigger1 = movecontact || movereversed
value = 1305

[state 1300, Hit]
type = posadd
trigger1 = numenemy
trigger1 = anim = 1305 && !animelemtime(1)
; x = enemy,pos x
y = enemy,pos y - pos y + enemy,const(size.head.pos.y) * cond(enemy,statetype = C, 0.85, 1.0)

[state 1300, Hit]
type = posfreeze
trigger1 = anim = 1305
value = 1

[state 1300, Hit]
type = playerpush
trigger1 = anim = 1305
value = 0

[state 1300, Set Velocity]
type = velset
trigger1 = anim = 1305 && !animelemtime(1)
x = 0.0
y = 0.0

[state 1300, End State]
type = changestate
trigger1 = anim = 1305 && !animtime
value = 1310

[state 1300, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 1320

;=========================================================================
; Finish
;=========================================================================
[Statedef 1310]
type = A
movetype = I
physics = N
ctrl = 1
velset = 0, 0
sprpriority = 0

[state 1310, Change Animation]
type = changeanim
trigger1 = !time
value = 1310

[state 40, Jump Direction]
type = varset
trigger1 = command = "holdfwd" || command = "holdback" || ailevel
sysvar(1) = cond(!time, 0, cond(command = "holdfwd", 1, cond(command = "holdback", -1, sysvar(1))))

[state 1310, Set Velocity]
type = velset
trigger1 = !time
x = cond(command = "holdfwd", 4.0 , cond(command = "holdback", -4.0, vel x))
y = const(velocity.jump.y) * 0.65

[state 1310, Set Velocity]
type = velset
trigger1 = command = "holdfwd" || command = "holdback" || ailevel
x = cond(command = "holdfwd", 4.0 , -6.0)

[state 1310, Multiply Velocity]
type = velmul
trigger1 = 1
x = 0.95

[state 1310, Increment Velocity]
type = veladd
trigger1 = time > 0
y = const(movement.yaccel)

[state 1310, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 1315

;=========================================================================
; Land
;=========================================================================
[Statedef 1315]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 1320, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1320, Change Animation]
type = changeanim
trigger1 = !time
value = 1315

[state 1320, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Miss
;=========================================================================
[Statedef 1320]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 1320, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1320, Change Animation]
type = changeanim
trigger1 = !time
value = 1320

[state 1320, Sound]
type = playsnd
trigger1 = !time
value = f5100, 0

[state 1320, Shake]
type = envshake
trigger1 = !time
time = 8
ampl = -4

[state 1320, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1