; Super Fighter Team

;=========================================================================
; Standing Punch
;=========================================================================
[Statedef 200]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 0
sprpriority = 1

[state 200, Set Position]
type = posset
trigger1 = !time
y = 0

[state 200, Change Animation]
type = changeanim
trigger1 = !time
value = 200

[state 200, Sound]
type = playsnd
trigger1 = !animelemtime(1)
value = f100, 0
volumescale = 100
channel = 1

[state 200, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 6 || var(13) := 56

[state 200, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(2)
ID = 1
attr = S, NA
damage = 10
fall.envshake.phase = 10 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 0)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -72
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 12
ground.hittime = 12
guard.slidetime = 12
guard.hittime = 12
air.hittime = 12
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 200, Idle]
type = statetypeset
trigger1 = animelemtime(3) >= 0
movetype = I
persistent = 0

[state 200, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Standing Kick
;=========================================================================
[Statedef 230]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 0
sprpriority = 1

[state 230, Set Position]
type = posset
trigger1 = !time
y = 0

[state 230, Change Animation]
type = changeanim
trigger1 = !time
value = 230

[state 230, Sound]
type = playsnd
trigger1 = !animelemtime(1)
value = f100, 0
volumescale = 100
channel = 1

[state 230, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 2 || var(13) := 56

[state 230, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(3)
ID = 1
attr = S, NA
damage = 10
fall.envshake.phase = 10 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 0)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -72
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 12
ground.hittime = 12
guard.slidetime = 12
guard.hittime = 12
air.hittime = 12
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 230, Idle]
type = statetypeset
trigger1 = animelemtime(4) >= 0
movetype = I
persistent = 0

[state 230, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Crouching Punch
;=========================================================================
[Statedef 400]
type = C
movetype = A
physics = C
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 0
sprpriority = 1

[state 400, Set Position]
type = posset
trigger1 = !time
y = 0

[state 400, Change Animation]
type = changeanim
trigger1 = !time
value = 400

[state 400, Sound]
type = playsnd
trigger1 = !animelemtime(1)
value = f100, 0
volumescale = 100
channel = 1

[state 400, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 2 || var(13) := 56

[state 400, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(2)
ID = 1
attr = C, NA
damage = 10
fall.envshake.phase = 10 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 0)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 12
ground.hittime = 12
guard.slidetime = 12
guard.hittime = 12
air.hittime = 12
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 400, Idle]
type = statetypeset
trigger1 = animelemtime(3) >= 0
movetype = I
persistent = 0

[state 400, End State]
type = changestate
trigger1 = !animtime
value = 11
ctrl = 1

;=========================================================================
; Crouching Kick
;=========================================================================
[Statedef 430]
type = C
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 0
sprpriority = 1

[state 430, Set Position]
type = posset
trigger1 = !time
y = 0

[state 430, Change Animation]
type = changeanim
trigger1 = !time
value = 430

[state 430, Shadow]
type = varset
trigger1 = 1
var(16) = -4 * (animelemtime(1) >= 0) + 4 * (animelemtime(3) >= 0)

[state 430, Sound]
type = playsnd
trigger1 = !animelemtime(1)
value = f100, 0
volumescale = 100
channel = 1

[state 430, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 1 || var(13) := 64

[state 430, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(2)
ID = 1
attr = C, NA
damage = 10
fall.envshake.phase = 10 ; dizzy points
guardflag = L
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 0)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -8
animtype = hard
ground.type = low
air.animtype = back
air.type = low
ground.slidetime = 12
ground.hittime = 12
guard.slidetime = 12
guard.hittime = 12
air.hittime = 12
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 430, Idle]
type = statetypeset
trigger1 = animelemtime(3) >= 0
movetype = I
persistent = 0

[state 430, End State]
type = changestate
trigger1 = !animtime
value = 11
ctrl = 1

;=========================================================================
; Aerial Punch - Motionless
;=========================================================================
[Statedef 600]
type = A
movetype = A
physics = N
ctrl = 0
facep2 = 0
velset = vel x, vel y
poweradd = 0
sprpriority = 1

[state 600, Change Animation]
type = changeanim
trigger1 = !time
value = 600

[state 600, Sound]
type = playsnd
trigger1 = !animelemtime(1)
value = f100, 0
volumescale = 100
channel = 1

[state 600, Increment Velocity]
type = veladd
trigger1 = 1
y = const(movement.yaccel)

[state 600, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 8 || var(13) := 56

[state 600, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(2)
ID = 1
attr = A, NA
damage = 10
fall.envshake.phase = 10 ; dizzy points
guardflag = H
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 0)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = high
air.animtype = hard
air.type = high
ground.slidetime = 12
ground.hittime = 12
guard.slidetime = 12
guard.hittime = 12
air.hittime = 12
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 600, Idle]
type = statetypeset
trigger1 = animelemtime(3) >= 0
movetype = I
persistent = 0

[state 600, Control]
type = ctrlset
trigger1 = time > 20
value = 1

[state 600, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 52

;=========================================================================
; Aerial Punch - Motional
;=========================================================================
[Statedef 605]
type = A
movetype = A
physics = N
ctrl = 0
facep2 = 0
velset = vel x, vel y
poweradd = 0
sprpriority = 1

[state 605, Change Animation]
type = changeanim
trigger1 = !time
value = 605

[state 605, Sound]
type = playsnd
trigger1 = !animelemtime(1)
value = f100, 0
volumescale = 100
channel = 1

[state 605, Increment Velocity]
type = veladd
trigger1 = 1
y = const(movement.yaccel)

[state 605, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 8 || var(13) := 56

[state 605, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(2)
ID = 1
attr = A, NA
damage = 10
fall.envshake.phase = 10 ; dizzy points
guardflag = H
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 0)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = high
air.animtype = hard
air.type = high
ground.slidetime = 12
ground.hittime = 12
guard.slidetime = 12
guard.hittime = 12
air.hittime = 12
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 605, Idle]
type = statetypeset
trigger1 = pos y + vel y > 0
movetype = I
persistent = 0

[state 605, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 52

;=========================================================================
; Aerial Kick - Motionless
;=========================================================================
[Statedef 630]
type = A
movetype = A
physics = N
ctrl = 0
facep2 = 0
velset = vel x, vel y
poweradd = 0
sprpriority = 1

[state 630, Change Animation]
type = changeanim
trigger1 = !time
value = 630

[state 630, Sound]
type = playsnd
trigger1 = !animelemtime(1)
value = f100, 0
volumescale = 100
channel = 1

[state 630, Increment Velocity]
type = veladd
trigger1 = 1
y = const(movement.yaccel)

[state 630, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 8 || var(13) := 64

[state 630, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(2)
ID = 1
attr = A, NA
damage = 10
fall.envshake.phase = 10 ; dizzy points
guardflag = H
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 0)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = high
air.animtype = hard
air.type = high
ground.slidetime = 12
ground.hittime = 12
guard.slidetime = 12
guard.hittime = 12
air.hittime = 12
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 630, Idle]
type = statetypeset
trigger1 = animelemtime(3) >= 0
movetype = I
persistent = 0

[state 630, Control]
type = ctrlset
trigger1 = time > 20
value = 1

[state 630, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 52

;=========================================================================
; Aerial Kick - Motional
;=========================================================================
[Statedef 635]
type = A
movetype = A
physics = N
ctrl = 0
facep2 = 0
velset = vel x, vel y
poweradd = 0
sprpriority = 1

[state 635, Change Animation]
type = changeanim
trigger1 = !time
value = 635

[state 635, Sound]
type = playsnd
trigger1 = !animelemtime(1)
value = f100, 0
volumescale = 100
channel = 1

[state 635, Increment Velocity]
type = veladd
trigger1 = 1
y = const(movement.yaccel)

[state 635, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 8 || var(13) := 64

[state 635, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(2)
ID = 1
attr = A, NA
damage = 10
fall.envshake.phase = 10 ; dizzy points
guardflag = H
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 0)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -48
animtype = hard
ground.type = high
air.animtype = hard
air.type = high
ground.slidetime = 12
ground.hittime = 12
guard.slidetime = 12
guard.hittime = 12
air.hittime = 12
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 635, Idle]
type = statetypeset
trigger1 = pos y + vel y > 0
movetype = I
persistent = 0

[state 635, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 52

;=========================================================================
; Grab - Attempt
;=========================================================================
[Statedef 800]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = vel x * (prevstateno = 1 || prevstateno = 20), 0
sprpriority = 0

[state 800, Change Animation]
type = changeanim
trigger1 = !time
value = 800 + 1 * (anim = 6 || anim = [10, 11]) + 2 * (anim = 20) + 3 * (anim = 21)
elem = animelemno(0)

[state 800, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 0 || var(13) := 0

[state 800, Throw]
type = hitdef
trigger1 = time > 2
ID = 1
attr = S, NT
damage = 0
fall.envshake.phase = 0 ; dizzy points
hitflag = M-
priority = 1, miss
pausetime = 0, 0
hitsound = -1 + 0 * (var(1) := -1)
guardsound = -1 + 0 * (var(2) := -1)
sparkno = -1
guard.sparkno = -1
ground.slidetime = 0
ground.hittime = 0
ground.velocity = 0.0, 0.0
ground.cornerpush.veloff = 0.0
yaccel = 0.5859375
fall = 1
fall.recover = 0
p1facing = 1
p2facing = -1
p1stateno = 805

[state 800, Throw]
type = hitdef
trigger1 = time > 2 && numenemy
trigger1 = enemy,stateno = 5300
ID = 1
attr = S, NT
damage = 0
fall.envshake.phase = 12 ; dizzy points
hitflag = M
priority = 1, miss
pausetime = 0, 0
hitsound = -1 + 0 * (var(1) := -1)
guardsound = -1 + 0 * (var(2) := -1)
sparkno = -1
guard.sparkno = -1
ground.slidetime = 0
ground.hittime = 0
ground.velocity = 0.0, 0.0
ground.cornerpush.veloff = 0.0
yaccel = 0.5859375
fall = 1
fall.recover = 0
p1facing = 1
p2facing = -1
p1stateno = 805

[state 800, Idle]
type = statetypeset
trigger1 = time > 8
movetype = I
persistent = 0

[state 800, End State]
type = changestate
trigger1 = time > 8
value = 11 * (prevstateno = [10, 11]) + 20 * (prevstateno = 1 || prevstateno = 20)
ctrl = 1

;=========================================================================
; Throw
;=========================================================================
[Statedef 805]
type = S
movetype = A
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 1

[state 805, Change Animation]
type = changeanim
trigger1 = !time
value = 805

[state 805, Width]
type = width
trigger1 = !time || !animelemtime(3)
edge = 40, 84 * !animelemtime(3)

[state 805, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f1, 0
volumescale = 100
channel = 0

[state 805, Sound]
type = playsnd
trigger1 = !animelemtime(3)
value = f5100, 0
volumescale = 100

[state 805, Attack Distance]
type = attackdist
trigger1 = !time
value = 0

[state 805, Target State]
type = targetstate
trigger1 = !time
value = 810

[state 805, Target Facing]
type = targetfacing
trigger1 = !time
value = 1

[state 805, Target Bind]
type = targetbind
trigger1 = animelemtime(1) >= 0 && animelemtime(2) < 0
pos = 24, 0

[state 805, Target Bind]
type = targetbind
trigger1 = animelemtime(2) >= 0 && animelemtime(3) < 0
pos = -8, -84

[state 805, Target Bind]
type = targetbind
trigger1 = animelemtime(3) >= 0 && animelemtime(3) < 14
pos = -84, -24

[state 805, Target Bind]
type = targetbind
trigger1 = animelemtime(3) = 14
pos = -84, -48

[state 805, Target Damage]
type = targetlifeadd
trigger1 = !time
value = -30

[state 805, Target Power]
type = targetpoweradd
trigger1 = !time
value = 5

[state 805, Target State]
type = targetstate
trigger1 = animelemtime(3) = 14
value = 811

[state 805, Add Power]
type = poweradd
trigger1 = !time
value = 10

[state 805, Juggle and Dampener Hit Counters]
type = null
trigger1 = !time
trigger1 = var(3) := var(3) + 1 || var(4) := 1 || var(5) := var(5) + 1

[state 805, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Target Grabbed
;=========================================================================
[Statedef 810]
type = S
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 810, Change Animation]
type = changeanim2
trigger1 = !time
value = 810

[state 810, Bound]
type = screenbound
trigger1 = 1
value = 0
movecamera = 1, 1

[state 810, Own State]
type = selfstate
trigger1 = !gethitvar(isbound)
trigger1 = time > 100
value = 5050

;=========================================================================
; Target Slammed
;=========================================================================
[Statedef 811]
type = A
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 811, Set Hit Fall]
type = hitfallset
trigger1 = !time
value = 1

[state 811, Change Animation]
type = changeanim
trigger1 = !time
value = 5050

[state 811, Change Animation]
type = changeanim
trigger1 = vel y > 0
value = 5060
persistent = 0

[state 811, Increment Position]
type = posadd
trigger1 = !time
y = -const(size.mid.pos.y)

[state 811, Set Velocity]
type = velset
trigger1 = !time
x = -3.90625
y = -6.640625

[state 811, Increment Velocity]
type = veladd
trigger1 = 1
y = 0.5859375

[state 811, Own State]
type = selfstate
trigger1 = pos y >= const(movement.air.gethit.groundlevel)
trigger1 = vel y > 0
value = 5100
ctrl = 0