; Super Fighter Team

;=========================================================================
; Centrifugal Dump
;=========================================================================
[Statedef 3000]
type = S
movetype = A
physics = S
ctrl = 0
facep2 = 1
velset = 0, 0
sprpriority = 1

[state 3000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 3000, Change Animation]
type = changeanim
trigger1 = !time
value = 3000

[state 3000, Add Power]
type = poweradd
trigger1 = !time
value = -power

[state 3000, Super Config]
type = helper
trigger1 = !animelemtime(1)
name = "Super Config"
id = 6120
stateno = 6120
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0
supermovetime = 65536
pausemovetime = 65536

[state 3000, Super Pause]
type = superpause
trigger1 = !animelemtime(1)
time = 48
movetime = 48
unhittable = 1
anim = -1
sound = -1
p2defmul = 1
poweradd = 0
darken = 0

[state 3000, Invulnerability]
type = nothitby
trigger1 = animelemtime(1) <= 48
value = SCA
time = 1

[state 3000, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f1, 0
volumescale = 100
channel = 0

[state 3000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 0 || var(13) := 0

[state 3000, Throw]
type = hitdef
trigger1 = !animelemtime(2) && numenemy
ID = 3
attr = S, HT
damage = 0
fall.envshake.phase = 40 ; dizzy points
hitflag = MA
priority = 1, miss
pausetime = 0, 0
hitsound = -1 + 0 * (var(1) := -1)
guardsound = -1 + 0 * (var(2) := -1)
sparkno = -1
guard.sparkno = -1
ground.slidetime = 0
ground.hittime = 0
ground.velocity = -11.71875, 0.0
ground.cornerpush.veloff = 0.0
yaccel = 0.5859375
fall = 1
fall.recover = 0
p1facing = 1
p2facing = 1
p1stateno = 3005

[state 3000, Idle]
type = statetypeset
trigger1 = animelemtime(3) >= 0
movetype = I
persistent = 0

[state 3000, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Centrifugal - Success
;=========================================================================
[Statedef 3005]
type = S
movetype = A
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 1

[state 3005, Change Animation]
type = changeanim
trigger1 = !time
value = 3005

[state 3005, Animation Loop]
type = changeanim
trigger1 = time - 16 < 90
trigger1 = !animelemtime(7)
value = anim
elem = 2

[state 3005, Width]
type = width
trigger1 = !time || !animelemtime(2) || !animelemtime(3) || !animelemtime(4) || !animelemtime(6)
edge = 40 * (!animelemtime(2) || !animelemtime(6)), 24 * !animelemtime(3) + 40 * !animelemtime(4)

[state 3005, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f1, 0
volumescale = 100
channel = 0

[state 3005, Sound]
type = playsnd
trigger1 = !animelemtime(4) || !animelemtime(6) && time < 90
value = f100, 0
volumescale = 100
channel = 1

[state 3005, Attack Distance]
type = attackdist
trigger1 = !time
value = 0

[state 3005, Target State]
type = targetstate
trigger1 = !time
value = 3010

[state 3005, Target Facing]
type = targetfacing
trigger1 = !time || !animelemtime(5)
value = -1

[state 3005, Target Facing]
type = targetfacing
trigger1 = !animelemtime(4)
value = 1

[state 3005, Target Bind]
type = targetbind
trigger1 = animelemtime(1) >= 0 && animelemtime(3) < 0
pos = 16, -72

[state 3005, Target Bind]
type = targetbind
trigger1 = animelemtime(3) >= 0 && animelemtime(4) < 0
pos = -12, -76

[state 3005, Target Bind]
type = targetbind
trigger1 = animelemtime(4) >= 0 && animelemtime(5) < 0
pos = -32, -72

[state 3005, Target Bind]
type = targetbind
trigger1 = animelemtime(5) >= 0 && animelemtime(6) < 0
pos = 0, -74

[state 3005, Target Bind]
type = targetbind
trigger1 = animelemtime(6) >= 0 && animelemtime(7) < 0 && time < 90
pos = 16, -72

[state 3005, Target Bind]
type = targetbind
trigger1 = !animelemtime(6) && time >= 90
pos = 40, -56

[state 3005, Target Damage]
type = targetlifeadd
trigger1 = !animelemtime(6)
value = -8
kill = (time >= 90)

[state 3005, Target Power]
type = targetpoweradd
trigger1 = !animelemtime(6)
value = 4

[state 3005, Target State]
type = targetstate
trigger1 = !animelemtime(6) && time >= 90
value = 3011

[state 3005, Juggle and Dampener Hit Counters]
type = null
trigger1 = !time
trigger1 = var(3) := var(3) + 1 || var(4) := 1 || var(5) := var(5) + 1

[state 3005, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Target Grabbed
;=========================================================================
[Statedef 3010]
type = S
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 3010, Change Animation]
type = changeanim2
trigger1 = !time
value = 3010

[state 3010, Bound]
type = screenbound
trigger1 = 1
value = 0
movecamera = 1, 1

[state 3010, Priority]
type = sprpriority
trigger1 = numenemy
trigger1 = enemy,stateno = 3005
trigger1 = !enemy,animelemtime(2) || !enemy,animelemtime(5) || !enemy,animelemtime(6) ; && enemy,time < 120
value = -1 + 3 * !enemy,animelemtime(5)

[state 3010, Own State]
type = selfstate
trigger1 = !gethitvar(isbound)
trigger1 = time > 200
value = 5050

;=========================================================================
; Wall Slam Entrance
;=========================================================================
[Statedef 3011]
type = A
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 3011, Set Hit Fall]
type = hitfallset
trigger1 = !time
value = 1

[state 3011, Increment Position]
type = posadd
trigger1 = 1
y = 32.0

[state 3011, Own State]
type = selfstate
trigger1 = 1
value = 5230
ctrl = 0