; Super Fighter Team

;=========================================================================
; Slicing Whip
;=========================================================================
[Statedef 1000]
type = S
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = 0, 0
poweradd = 4
sprpriority = 1

[state 1000, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1000, Change Animation]
type = changeanim
trigger1 = !time
value = 1000

[state 1000, Shadow]
type = varset
trigger1 = 1
var(16) = -2 * (animelemtime(1) >= 0) + 2 * (animelemtime(2) >= 0) - 2 * (animelemtime(4) >= 0)

[state 1000, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f8, 0
volumescale = 100
channel = 0

[state 1000, Sound]
type = playsnd
trigger1 = !animelemtime(2)
value = f100, 0
volumescale = 100
channel = 1

[state 1000, Energy]
type = helper
trigger1 = !animelemtime(2)
name = "Energy"
ID = 1005
stateno = 7000
postype = p1
ownpal = 1
keyctrl = 0
size.xscale = 1.0
size.yscale = 1.0

[state 1000, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 4 || var(13) := 152

[state 1000, Hit]
type = hitdef
trigger1 = !var(3) && !var(4) && numenemy
trigger1 = !animelemtime(3)
ID = 2
attr = S, SA
damage = 20, 2
fall.envshake.phase = 20 ; dizzy points
guardflag = M
hitflag = MAF
priority = 4, Hit
pausetime = 12, 12
guard.pausetime = 12, 12
hitsound = -1 + 0 * (var(1) := 10)
guardsound = -1 + 0 * (var(2) := 120)
sparkno = 195 + 5 * teamside
guard.sparkno = 195 + 5 * teamside
sparkxy = -enemy,const(size.ground.front), -32
animtype = hard
ground.type = high
air.animtype = back
air.type = high
ground.slidetime = 15
ground.hittime = 15
guard.slidetime = 15
guard.hittime = 15
air.hittime = 15
ground.velocity = -7.8125
guard.velocity = -7.8125
air.velocity = -2.34375, -8.59375
ground.cornerpush.veloff = 0.0
guard.cornerpush.veloff = 0.0
yaccel = 0.5859375
getpower = 8, 8
givepower = 4, 4
fall = 0
air.fall = 0
fall.recover = 0
fall.animtype = back

[state 1000, Idle]
type = statetypeset
trigger1 = animelemtime(4) >= 0
movetype = I
persistent = 0

[state 1000, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Air Throw - Attempt
;=========================================================================
[Statedef 1100]
type = A
movetype = A
physics = N
ctrl = 0
facep2 = 1
velset = vel x, vel y
sprpriority = 0

[state 1100, Change Animation]
type = changeanim
trigger1 = !time && anim = [41, 43]
value = 1100 + 1 * (anim = 42) + 2 * (anim = 43)
elem = animelemno(0)

[state 1100, Change Animation]
type = changeanim
trigger1 = time = 1
value = 41 + 1 * (anim = 1101) + 2 * (anim = 1102)
elem = animelemno(0)

[state 1100, Increment Velocity]
type = veladd
trigger1 = 1
y = const(movement.yaccel)

[state 1100, Attack Scope]
type = null
trigger1 = movetype = A
trigger1 = var(12) := 0 || var(13) := 0

[state 1100, Throw]
type = hitdef
trigger1 = time > 2
ID = 2
attr = A, ST
damage = 0
fall.envshake.phase = 0 ; dizzy points
hitflag = A-
priority = 1, miss
pausetime = 0, 0
hitsound = -1 + 0 * (var(1) := -1)
guardsound = -1 + 0 * (var(2) := -1)
sparkno = -1
guard.sparkno = -1
ground.slidetime = 0
ground.hittime = 0
ground.velocity = 0.0, 0.0
ground.cornerpush.veloff = 0.0
yaccel = 0.5859375
fall = 1
fall.recover = 0
; fall.xvelocity = -4.6875
fall.yvelocity = -6.640625
p1facing = 1
p2facing = 1
p1stateno = 1105

[state 1100, Miss]
type = hitdef
trigger1 = time = 1
ID = 2
attr = A, ST
hitflag = 

[state 1100, Idle]
type = statetypeset
trigger1 = time = 1
movetype = I
persistent = 0

[state 1100, End State]
type = changestate
trigger1 = pos y + vel y > 0
value = 52

;=========================================================================
; Air Throw - Success
;=========================================================================
[Statedef 1105]
type = S
movetype = A
physics = N
ctrl = 0
velset = 0, 0
sprpriority = 1

[state 1105, Change Animation]
type = changeanim
trigger1 = !time
value = 1105

[state 1105, Voice]
type = playsnd
trigger1 = !animelemtime(1)
value = f8, 0
volumescale = 100
channel = 0

[state 1105, Set Velocity]
type = velset
trigger1 = !animelemtime(2)
x = -3.515625
y = -7.03125

[state 1105, Increment Velocity]
type = veladd
trigger1 = animelemtime(2) > 0 && animelemtime(4) < 0
y = const(movement.yaccel) * 1.25

[state 1105, Set Velocity]
type = null ; velset
trigger1 = !animelemtime(4)
x = 0.0
y = 0.0

[state 1105, Set Velocity]
type = null ; velset
trigger1 = !animelemtime(5)
x = -1.953125
y = -9.375

[state 1105, Increment Velocity]
type = veladd
trigger1 = animelemtime(5) > 0
y = const(movement.yaccel)

[state 1105, Attack Distance]
type = attackdist
trigger1 = !time
value = 0

[state 1105, Target State]
type = targetstate
trigger1 = !time
value = 1110

[state 1105, Target Facing]
type = targetfacing
trigger1 = !time
value = 1

[state 1105, Target Bind]
type = targetbind
trigger1 = animelemtime(1) >= 0 && animelemtime(2) < 0
pos = 8, 0

[state 1105, Target Bind]
type = targetbind
trigger1 = animelemtime(2) >= 0 && animelemtime(3) < 0
pos = -12, -80

[state 1105, Target Bind]
type = targetbind
trigger1 = animelemtime(3) >= 0 && animelemtime(4) < 4
pos = -8, -16

[state 1105, Target Damage]
type = targetlifeadd
trigger1 = !time
value = -30

[state 1105, Target Power]
type = targetpoweradd
trigger1 = !time
value = 5

[state 1105, Target State]
type = null ; targetstate
trigger1 = animelemtime(4) = 4
value = 1111

[state 1105, Add Power]
type = poweradd
trigger1 = !time
value = 10

[state 1105, Juggle and Dampener Hit Counters]
type = null
trigger1 = !time
trigger1 = var(3) := var(3) + 1 || var(4) := 1 || var(5) := var(5) + 1

[state 1105, End State]
type = changestate
; trigger1 = animelemtime(5) < 0
trigger1 = pos y + vel y > 0
value = 806

[state 1105, End State]
type = null ; changestate
trigger1 = pos y + vel y > 0
value = 1106

;=========================================================================
; Land
;=========================================================================
[Statedef 1106]
type = S
movetype = I
physics = S
ctrl = 0
velset = 0, 0
sprpriority = 0

[state 1106, Set Position]
type = posset
trigger1 = !time
y = 0

[state 1106, Change Animation]
type = changeanim
trigger1 = !time
value = 1106

[state 1106, End State]
type = changestate
trigger1 = !animtime
value = 0
ctrl = 1

;=========================================================================
; Target Grabbed
;=========================================================================
[Statedef 1110]
type = S
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 1110, Change Animation]
type = changeanim2
trigger1 = !time
value = 1110

[state 1110, Bound]
type = screenbound
trigger1 = 1
value = 0
movecamera = 1, 1

[state 1110, Own State]
type = selfstate
trigger1 = !gethitvar(isbound)
trigger1 = time > 100
value = 5050

;=========================================================================
; Target Slammed
;=========================================================================
[Statedef 1111]
type = A
movetype = H
physics = N
ctrl = 0
velset = 0, 0
sprpriority = -1

[state 1111, Set Hit Fall]
type = hitfallset
trigger1 = !time
value = 1

[state 1111, Set Velocity]
type = velset
trigger1 = !time
x = -4.6875
y = 6.640625

[state 1111, Increment Velocity]
type = veladd
trigger1 = time > 0
y = 0.5859375

[state 1111, Own State]
type = selfstate
trigger1 = pos y + vel y > 0
value = 5100
ctrl = 0

;=========================================================================
; Spider Jump Start
;=========================================================================
[Statedef 1200]
type = S
movetype = I
physics = S
ctrl = 0
facep2 = 0
velset = 0, 0
sprpriority = 1

[state 1200, Change Animation]
type = changeanim
trigger1 = !time
value = 1200

[state 1200, Turn]
type = turn
trigger1 = !time && frontedgedist < backedgedist

[state 1200, Set Position]
type = posset
trigger1 = 1
x = gamewidth * 0.5 * -facing

[state 1200, Set Velocity]
type = velset
trigger1 = !animtime
x = const(velocity.jump.fwd.x)
y = const(velocity.jump.y)

[state 1200, Turn]
type = turn
trigger1 = !animtime && p2dist x < const(size.ground.front) * 2.0

[state 1200, Jump Direction]
type = varset
trigger1 = !animtime
sysvar(1) = cond(vel x < 0, -1, 1)

[state 1200, End State]
type = changestate
trigger1 = !animtime
value = 50
ctrl = 1

[state 1200, Angle]
type = angledraw
trigger1 = 1
value = -36